/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TOKEN_METADATA_PROGRAM_ADDRESS } from '../programs';
export type ApproveCollectionAuthorityInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountCollectionAuthorityRecord extends string | IAccountMeta<string> = string, TAccountNewCollectionAuthority extends string | IAccountMeta<string> = string, TAccountUpdateAuthority extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountRent extends string | IAccountMeta<string> | undefined = undefined, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountCollectionAuthorityRecord extends string ? WritableAccount<TAccountCollectionAuthorityRecord> : TAccountCollectionAuthorityRecord,
    TAccountNewCollectionAuthority extends string ? ReadonlyAccount<TAccountNewCollectionAuthority> : TAccountNewCollectionAuthority,
    TAccountUpdateAuthority extends string ? WritableSignerAccount<TAccountUpdateAuthority> & IAccountSignerMeta<TAccountUpdateAuthority> : TAccountUpdateAuthority,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountMetadata extends string ? ReadonlyAccount<TAccountMetadata> : TAccountMetadata,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...(TAccountRent extends undefined ? [] : [
        TAccountRent extends string ? ReadonlyAccount<TAccountRent> : TAccountRent
    ]),
    ...TRemainingAccounts
]>;
export type ApproveCollectionAuthorityInstructionData = {
    discriminator: number;
};
export type ApproveCollectionAuthorityInstructionDataArgs = {};
export declare function getApproveCollectionAuthorityInstructionDataEncoder(): Encoder<ApproveCollectionAuthorityInstructionDataArgs>;
export declare function getApproveCollectionAuthorityInstructionDataDecoder(): Decoder<ApproveCollectionAuthorityInstructionData>;
export declare function getApproveCollectionAuthorityInstructionDataCodec(): Codec<ApproveCollectionAuthorityInstructionDataArgs, ApproveCollectionAuthorityInstructionData>;
export type ApproveCollectionAuthorityInput<TAccountCollectionAuthorityRecord extends string = string, TAccountNewCollectionAuthority extends string = string, TAccountUpdateAuthority extends string = string, TAccountPayer extends string = string, TAccountMetadata extends string = string, TAccountMint extends string = string, TAccountSystemProgram extends string = string, TAccountRent extends string = string> = {
    /** Collection Authority Record PDA */
    collectionAuthorityRecord: Address<TAccountCollectionAuthorityRecord>;
    /** A Collection Authority */
    newCollectionAuthority: Address<TAccountNewCollectionAuthority>;
    /** Update Authority of Collection NFT */
    updateAuthority: TransactionSigner<TAccountUpdateAuthority>;
    /** Payer */
    payer: TransactionSigner<TAccountPayer>;
    /** Collection Metadata account */
    metadata: Address<TAccountMetadata>;
    /** Mint of Collection Metadata */
    mint: Address<TAccountMint>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Rent info */
    rent?: Address<TAccountRent>;
};
export declare function getApproveCollectionAuthorityInstruction<TAccountCollectionAuthorityRecord extends string, TAccountNewCollectionAuthority extends string, TAccountUpdateAuthority extends string, TAccountPayer extends string, TAccountMetadata extends string, TAccountMint extends string, TAccountSystemProgram extends string, TAccountRent extends string>(input: ApproveCollectionAuthorityInput<TAccountCollectionAuthorityRecord, TAccountNewCollectionAuthority, TAccountUpdateAuthority, TAccountPayer, TAccountMetadata, TAccountMint, TAccountSystemProgram, TAccountRent>): ApproveCollectionAuthorityInstruction<typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountCollectionAuthorityRecord, TAccountNewCollectionAuthority, TAccountUpdateAuthority, TAccountPayer, TAccountMetadata, TAccountMint, TAccountSystemProgram, TAccountRent>;
export type ParsedApproveCollectionAuthorityInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Collection Authority Record PDA */
        collectionAuthorityRecord: TAccountMetas[0];
        /** A Collection Authority */
        newCollectionAuthority: TAccountMetas[1];
        /** Update Authority of Collection NFT */
        updateAuthority: TAccountMetas[2];
        /** Payer */
        payer: TAccountMetas[3];
        /** Collection Metadata account */
        metadata: TAccountMetas[4];
        /** Mint of Collection Metadata */
        mint: TAccountMetas[5];
        /** System program */
        systemProgram: TAccountMetas[6];
        /** Rent info */
        rent?: TAccountMetas[7] | undefined;
    };
    data: ApproveCollectionAuthorityInstructionData;
};
export declare function parseApproveCollectionAuthorityInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedApproveCollectionAuthorityInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=approveCollectionAuthority.d.ts.map