/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TOKEN_METADATA_PROGRAM_ADDRESS } from '../programs';
export type ApproveUseAuthorityInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountUseAuthorityRecord extends string | IAccountMeta<string> = string, TAccountOwner extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountUser extends string | IAccountMeta<string> = string, TAccountOwnerTokenAccount extends string | IAccountMeta<string> = string, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountBurner extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountRent extends string | IAccountMeta<string> | undefined = undefined, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountUseAuthorityRecord extends string ? WritableAccount<TAccountUseAuthorityRecord> : TAccountUseAuthorityRecord,
    TAccountOwner extends string ? WritableSignerAccount<TAccountOwner> & IAccountSignerMeta<TAccountOwner> : TAccountOwner,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountUser extends string ? ReadonlyAccount<TAccountUser> : TAccountUser,
    TAccountOwnerTokenAccount extends string ? WritableAccount<TAccountOwnerTokenAccount> : TAccountOwnerTokenAccount,
    TAccountMetadata extends string ? ReadonlyAccount<TAccountMetadata> : TAccountMetadata,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountBurner extends string ? ReadonlyAccount<TAccountBurner> : TAccountBurner,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...(TAccountRent extends undefined ? [] : [
        TAccountRent extends string ? ReadonlyAccount<TAccountRent> : TAccountRent
    ]),
    ...TRemainingAccounts
]>;
export type ApproveUseAuthorityInstructionData = {
    discriminator: number;
    numberOfUses: bigint;
};
export type ApproveUseAuthorityInstructionDataArgs = {
    numberOfUses: number | bigint;
};
export declare function getApproveUseAuthorityInstructionDataEncoder(): Encoder<ApproveUseAuthorityInstructionDataArgs>;
export declare function getApproveUseAuthorityInstructionDataDecoder(): Decoder<ApproveUseAuthorityInstructionData>;
export declare function getApproveUseAuthorityInstructionDataCodec(): Codec<ApproveUseAuthorityInstructionDataArgs, ApproveUseAuthorityInstructionData>;
export type ApproveUseAuthorityInput<TAccountUseAuthorityRecord extends string = string, TAccountOwner extends string = string, TAccountPayer extends string = string, TAccountUser extends string = string, TAccountOwnerTokenAccount extends string = string, TAccountMetadata extends string = string, TAccountMint extends string = string, TAccountBurner extends string = string, TAccountTokenProgram extends string = string, TAccountSystemProgram extends string = string, TAccountRent extends string = string> = {
    /** Use Authority Record PDA */
    useAuthorityRecord: Address<TAccountUseAuthorityRecord>;
    /** Owner */
    owner: TransactionSigner<TAccountOwner>;
    /** Payer */
    payer: TransactionSigner<TAccountPayer>;
    /** A Use Authority */
    user: Address<TAccountUser>;
    /** Owned Token Account Of Mint */
    ownerTokenAccount: Address<TAccountOwnerTokenAccount>;
    /** Metadata account */
    metadata: Address<TAccountMetadata>;
    /** Mint of Metadata */
    mint: Address<TAccountMint>;
    /** Program As Signer (Burner) */
    burner: Address<TAccountBurner>;
    /** Token program */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Rent info */
    rent?: Address<TAccountRent>;
    numberOfUses: ApproveUseAuthorityInstructionDataArgs['numberOfUses'];
};
export declare function getApproveUseAuthorityInstruction<TAccountUseAuthorityRecord extends string, TAccountOwner extends string, TAccountPayer extends string, TAccountUser extends string, TAccountOwnerTokenAccount extends string, TAccountMetadata extends string, TAccountMint extends string, TAccountBurner extends string, TAccountTokenProgram extends string, TAccountSystemProgram extends string, TAccountRent extends string>(input: ApproveUseAuthorityInput<TAccountUseAuthorityRecord, TAccountOwner, TAccountPayer, TAccountUser, TAccountOwnerTokenAccount, TAccountMetadata, TAccountMint, TAccountBurner, TAccountTokenProgram, TAccountSystemProgram, TAccountRent>): ApproveUseAuthorityInstruction<typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountUseAuthorityRecord, TAccountOwner, TAccountPayer, TAccountUser, TAccountOwnerTokenAccount, TAccountMetadata, TAccountMint, TAccountBurner, TAccountTokenProgram, TAccountSystemProgram, TAccountRent>;
export type ParsedApproveUseAuthorityInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Use Authority Record PDA */
        useAuthorityRecord: TAccountMetas[0];
        /** Owner */
        owner: TAccountMetas[1];
        /** Payer */
        payer: TAccountMetas[2];
        /** A Use Authority */
        user: TAccountMetas[3];
        /** Owned Token Account Of Mint */
        ownerTokenAccount: TAccountMetas[4];
        /** Metadata account */
        metadata: TAccountMetas[5];
        /** Mint of Metadata */
        mint: TAccountMetas[6];
        /** Program As Signer (Burner) */
        burner: TAccountMetas[7];
        /** Token program */
        tokenProgram: TAccountMetas[8];
        /** System program */
        systemProgram: TAccountMetas[9];
        /** Rent info */
        rent?: TAccountMetas[10] | undefined;
    };
    data: ApproveUseAuthorityInstructionData;
};
export declare function parseApproveUseAuthorityInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedApproveUseAuthorityInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=approveUseAuthority.d.ts.map