/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TOKEN_METADATA_PROGRAM_ADDRESS } from '../programs';
import { type BurnArgs, type BurnArgsArgs } from '../types';
export type BurnInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountCollectionMetadata extends string | IAccountMeta<string> = string, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountEdition extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountToken extends string | IAccountMeta<string> = string, TAccountMasterEdition extends string | IAccountMeta<string> = string, TAccountMasterEditionMint extends string | IAccountMeta<string> = string, TAccountMasterEditionToken extends string | IAccountMeta<string> = string, TAccountEditionMarker extends string | IAccountMeta<string> = string, TAccountTokenRecord extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountSysvarInstructions extends string | IAccountMeta<string> = 'Sysvar1nstructions1111111111111111111111111', TAccountSplTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountAuthority extends string ? WritableSignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountCollectionMetadata extends string ? WritableAccount<TAccountCollectionMetadata> : TAccountCollectionMetadata,
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountEdition extends string ? WritableAccount<TAccountEdition> : TAccountEdition,
    TAccountMint extends string ? WritableAccount<TAccountMint> : TAccountMint,
    TAccountToken extends string ? WritableAccount<TAccountToken> : TAccountToken,
    TAccountMasterEdition extends string ? WritableAccount<TAccountMasterEdition> : TAccountMasterEdition,
    TAccountMasterEditionMint extends string ? ReadonlyAccount<TAccountMasterEditionMint> : TAccountMasterEditionMint,
    TAccountMasterEditionToken extends string ? ReadonlyAccount<TAccountMasterEditionToken> : TAccountMasterEditionToken,
    TAccountEditionMarker extends string ? WritableAccount<TAccountEditionMarker> : TAccountEditionMarker,
    TAccountTokenRecord extends string ? WritableAccount<TAccountTokenRecord> : TAccountTokenRecord,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountSysvarInstructions extends string ? ReadonlyAccount<TAccountSysvarInstructions> : TAccountSysvarInstructions,
    TAccountSplTokenProgram extends string ? ReadonlyAccount<TAccountSplTokenProgram> : TAccountSplTokenProgram,
    ...TRemainingAccounts
]>;
export type BurnInstructionData = {
    discriminator: number;
    burnArgs: BurnArgs;
};
export type BurnInstructionDataArgs = {
    burnArgs: BurnArgsArgs;
};
export declare function getBurnInstructionDataEncoder(): Encoder<BurnInstructionDataArgs>;
export declare function getBurnInstructionDataDecoder(): Decoder<BurnInstructionData>;
export declare function getBurnInstructionDataCodec(): Codec<BurnInstructionDataArgs, BurnInstructionData>;
export type BurnInput<TAccountAuthority extends string = string, TAccountCollectionMetadata extends string = string, TAccountMetadata extends string = string, TAccountEdition extends string = string, TAccountMint extends string = string, TAccountToken extends string = string, TAccountMasterEdition extends string = string, TAccountMasterEditionMint extends string = string, TAccountMasterEditionToken extends string = string, TAccountEditionMarker extends string = string, TAccountTokenRecord extends string = string, TAccountSystemProgram extends string = string, TAccountSysvarInstructions extends string = string, TAccountSplTokenProgram extends string = string> = {
    /** Asset owner or Utility delegate */
    authority: TransactionSigner<TAccountAuthority>;
    /** Metadata of the Collection */
    collectionMetadata?: Address<TAccountCollectionMetadata>;
    /** Metadata (pda of ['metadata', program id, mint id]) */
    metadata: Address<TAccountMetadata>;
    /** Edition of the asset */
    edition?: Address<TAccountEdition>;
    /** Mint of token asset */
    mint: Address<TAccountMint>;
    /** Token account to close */
    token: Address<TAccountToken>;
    /** Master edition account */
    masterEdition?: Address<TAccountMasterEdition>;
    /** Master edition mint of the asset */
    masterEditionMint?: Address<TAccountMasterEditionMint>;
    /** Master edition token account */
    masterEditionToken?: Address<TAccountMasterEditionToken>;
    /** Edition marker account */
    editionMarker?: Address<TAccountEditionMarker>;
    /** Token record account */
    tokenRecord?: Address<TAccountTokenRecord>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Instructions sysvar account */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    /** SPL Token Program */
    splTokenProgram?: Address<TAccountSplTokenProgram>;
    burnArgs: BurnInstructionDataArgs['burnArgs'];
};
export declare function getBurnInstruction<TAccountAuthority extends string, TAccountCollectionMetadata extends string, TAccountMetadata extends string, TAccountEdition extends string, TAccountMint extends string, TAccountToken extends string, TAccountMasterEdition extends string, TAccountMasterEditionMint extends string, TAccountMasterEditionToken extends string, TAccountEditionMarker extends string, TAccountTokenRecord extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string, TAccountSplTokenProgram extends string>(input: BurnInput<TAccountAuthority, TAccountCollectionMetadata, TAccountMetadata, TAccountEdition, TAccountMint, TAccountToken, TAccountMasterEdition, TAccountMasterEditionMint, TAccountMasterEditionToken, TAccountEditionMarker, TAccountTokenRecord, TAccountSystemProgram, TAccountSysvarInstructions, TAccountSplTokenProgram>): BurnInstruction<typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountAuthority, TAccountCollectionMetadata, TAccountMetadata, TAccountEdition, TAccountMint, TAccountToken, TAccountMasterEdition, TAccountMasterEditionMint, TAccountMasterEditionToken, TAccountEditionMarker, TAccountTokenRecord, TAccountSystemProgram, TAccountSysvarInstructions, TAccountSplTokenProgram>;
export type ParsedBurnInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Asset owner or Utility delegate */
        authority: TAccountMetas[0];
        /** Metadata of the Collection */
        collectionMetadata?: TAccountMetas[1] | undefined;
        /** Metadata (pda of ['metadata', program id, mint id]) */
        metadata: TAccountMetas[2];
        /** Edition of the asset */
        edition?: TAccountMetas[3] | undefined;
        /** Mint of token asset */
        mint: TAccountMetas[4];
        /** Token account to close */
        token: TAccountMetas[5];
        /** Master edition account */
        masterEdition?: TAccountMetas[6] | undefined;
        /** Master edition mint of the asset */
        masterEditionMint?: TAccountMetas[7] | undefined;
        /** Master edition token account */
        masterEditionToken?: TAccountMetas[8] | undefined;
        /** Edition marker account */
        editionMarker?: TAccountMetas[9] | undefined;
        /** Token record account */
        tokenRecord?: TAccountMetas[10] | undefined;
        /** System program */
        systemProgram: TAccountMetas[11];
        /** Instructions sysvar account */
        sysvarInstructions: TAccountMetas[12];
        /** SPL Token Program */
        splTokenProgram: TAccountMetas[13];
    };
    data: BurnInstructionData;
};
export declare function parseBurnInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedBurnInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=burn.d.ts.map