/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TOKEN_METADATA_PROGRAM_ADDRESS } from '../programs';
export type CloseEscrowAccountInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountEscrow extends string | IAccountMeta<string> = string, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountTokenAccount extends string | IAccountMeta<string> = string, TAccountEdition extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountSysvarInstructions extends string | IAccountMeta<string> = 'Sysvar1nstructions1111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountEscrow extends string ? WritableAccount<TAccountEscrow> : TAccountEscrow,
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountTokenAccount extends string ? ReadonlyAccount<TAccountTokenAccount> : TAccountTokenAccount,
    TAccountEdition extends string ? ReadonlyAccount<TAccountEdition> : TAccountEdition,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountSysvarInstructions extends string ? ReadonlyAccount<TAccountSysvarInstructions> : TAccountSysvarInstructions,
    ...TRemainingAccounts
]>;
export type CloseEscrowAccountInstructionData = {
    discriminator: number;
};
export type CloseEscrowAccountInstructionDataArgs = {};
export declare function getCloseEscrowAccountInstructionDataEncoder(): Encoder<CloseEscrowAccountInstructionDataArgs>;
export declare function getCloseEscrowAccountInstructionDataDecoder(): Decoder<CloseEscrowAccountInstructionData>;
export declare function getCloseEscrowAccountInstructionDataCodec(): Codec<CloseEscrowAccountInstructionDataArgs, CloseEscrowAccountInstructionData>;
export type CloseEscrowAccountInput<TAccountEscrow extends string = string, TAccountMetadata extends string = string, TAccountMint extends string = string, TAccountTokenAccount extends string = string, TAccountEdition extends string = string, TAccountPayer extends string = string, TAccountSystemProgram extends string = string, TAccountSysvarInstructions extends string = string> = {
    /** Escrow account */
    escrow: Address<TAccountEscrow>;
    /** Metadata account */
    metadata: Address<TAccountMetadata>;
    /** Mint account */
    mint: Address<TAccountMint>;
    /** Token account */
    tokenAccount: Address<TAccountTokenAccount>;
    /** Edition account */
    edition: Address<TAccountEdition>;
    /** Wallet paying for the transaction and new account */
    payer: TransactionSigner<TAccountPayer>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Instructions sysvar account */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
};
export declare function getCloseEscrowAccountInstruction<TAccountEscrow extends string, TAccountMetadata extends string, TAccountMint extends string, TAccountTokenAccount extends string, TAccountEdition extends string, TAccountPayer extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string>(input: CloseEscrowAccountInput<TAccountEscrow, TAccountMetadata, TAccountMint, TAccountTokenAccount, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions>): CloseEscrowAccountInstruction<typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountEscrow, TAccountMetadata, TAccountMint, TAccountTokenAccount, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions>;
export type ParsedCloseEscrowAccountInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Escrow account */
        escrow: TAccountMetas[0];
        /** Metadata account */
        metadata: TAccountMetas[1];
        /** Mint account */
        mint: TAccountMetas[2];
        /** Token account */
        tokenAccount: TAccountMetas[3];
        /** Edition account */
        edition: TAccountMetas[4];
        /** Wallet paying for the transaction and new account */
        payer: TAccountMetas[5];
        /** System program */
        systemProgram: TAccountMetas[6];
        /** Instructions sysvar account */
        sysvarInstructions: TAccountMetas[7];
    };
    data: CloseEscrowAccountInstructionData;
};
export declare function parseCloseEscrowAccountInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedCloseEscrowAccountInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=closeEscrowAccount.d.ts.map