/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type Option, type OptionOrNullable, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TOKEN_METADATA_PROGRAM_ADDRESS } from '../programs';
export type CreateMasterEditionV3Instruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountEdition extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountUpdateAuthority extends string | IAccountMeta<string> = string, TAccountMintAuthority extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountRent extends string | IAccountMeta<string> | undefined = undefined, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountEdition extends string ? WritableAccount<TAccountEdition> : TAccountEdition,
    TAccountMint extends string ? WritableAccount<TAccountMint> : TAccountMint,
    TAccountUpdateAuthority extends string ? ReadonlySignerAccount<TAccountUpdateAuthority> & IAccountSignerMeta<TAccountUpdateAuthority> : TAccountUpdateAuthority,
    TAccountMintAuthority extends string ? ReadonlySignerAccount<TAccountMintAuthority> & IAccountSignerMeta<TAccountMintAuthority> : TAccountMintAuthority,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...(TAccountRent extends undefined ? [] : [
        TAccountRent extends string ? ReadonlyAccount<TAccountRent> : TAccountRent
    ]),
    ...TRemainingAccounts
]>;
export type CreateMasterEditionV3InstructionData = {
    discriminator: number;
    maxSupply: Option<bigint>;
};
export type CreateMasterEditionV3InstructionDataArgs = {
    maxSupply: OptionOrNullable<number | bigint>;
};
export declare function getCreateMasterEditionV3InstructionDataEncoder(): Encoder<CreateMasterEditionV3InstructionDataArgs>;
export declare function getCreateMasterEditionV3InstructionDataDecoder(): Decoder<CreateMasterEditionV3InstructionData>;
export declare function getCreateMasterEditionV3InstructionDataCodec(): Codec<CreateMasterEditionV3InstructionDataArgs, CreateMasterEditionV3InstructionData>;
export type CreateMasterEditionV3Input<TAccountEdition extends string = string, TAccountMint extends string = string, TAccountUpdateAuthority extends string = string, TAccountMintAuthority extends string = string, TAccountPayer extends string = string, TAccountMetadata extends string = string, TAccountTokenProgram extends string = string, TAccountSystemProgram extends string = string, TAccountRent extends string = string> = {
    /** Unallocated edition V2 account with address as pda of ['metadata', program id, mint, 'edition'] */
    edition: Address<TAccountEdition>;
    /** Metadata mint */
    mint: Address<TAccountMint>;
    /** Update authority */
    updateAuthority: TransactionSigner<TAccountUpdateAuthority>;
    /** Mint authority on the metadata's mint - THIS WILL TRANSFER AUTHORITY AWAY FROM THIS KEY */
    mintAuthority: TransactionSigner<TAccountMintAuthority>;
    /** payer */
    payer: TransactionSigner<TAccountPayer>;
    /** Metadata account */
    metadata: Address<TAccountMetadata>;
    /** Token program */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Rent info */
    rent?: Address<TAccountRent>;
    maxSupply: CreateMasterEditionV3InstructionDataArgs['maxSupply'];
};
export declare function getCreateMasterEditionV3Instruction<TAccountEdition extends string, TAccountMint extends string, TAccountUpdateAuthority extends string, TAccountMintAuthority extends string, TAccountPayer extends string, TAccountMetadata extends string, TAccountTokenProgram extends string, TAccountSystemProgram extends string, TAccountRent extends string>(input: CreateMasterEditionV3Input<TAccountEdition, TAccountMint, TAccountUpdateAuthority, TAccountMintAuthority, TAccountPayer, TAccountMetadata, TAccountTokenProgram, TAccountSystemProgram, TAccountRent>): CreateMasterEditionV3Instruction<typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountEdition, TAccountMint, TAccountUpdateAuthority, TAccountMintAuthority, TAccountPayer, TAccountMetadata, TAccountTokenProgram, TAccountSystemProgram, TAccountRent>;
export type ParsedCreateMasterEditionV3Instruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Unallocated edition V2 account with address as pda of ['metadata', program id, mint, 'edition'] */
        edition: TAccountMetas[0];
        /** Metadata mint */
        mint: TAccountMetas[1];
        /** Update authority */
        updateAuthority: TAccountMetas[2];
        /** Mint authority on the metadata's mint - THIS WILL TRANSFER AUTHORITY AWAY FROM THIS KEY */
        mintAuthority: TAccountMetas[3];
        /** payer */
        payer: TAccountMetas[4];
        /** Metadata account */
        metadata: TAccountMetas[5];
        /** Token program */
        tokenProgram: TAccountMetas[6];
        /** System program */
        systemProgram: TAccountMetas[7];
        /** Rent info */
        rent?: TAccountMetas[8] | undefined;
    };
    data: CreateMasterEditionV3InstructionData;
};
export declare function parseCreateMasterEditionV3Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedCreateMasterEditionV3Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=createMasterEditionV3.d.ts.map