/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TOKEN_METADATA_PROGRAM_ADDRESS } from '../programs';
export type CreateMetadataAccountV2Instruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountMintAuthority extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountUpdateAuthority extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountRent extends string | IAccountMeta<string> | undefined = undefined, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountMintAuthority extends string ? ReadonlySignerAccount<TAccountMintAuthority> & IAccountSignerMeta<TAccountMintAuthority> : TAccountMintAuthority,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountUpdateAuthority extends string ? ReadonlyAccount<TAccountUpdateAuthority> : TAccountUpdateAuthority,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...(TAccountRent extends undefined ? [] : [
        TAccountRent extends string ? ReadonlyAccount<TAccountRent> : TAccountRent
    ]),
    ...TRemainingAccounts
]>;
export type CreateMetadataAccountV2InstructionData = {
    discriminator: number;
};
export type CreateMetadataAccountV2InstructionDataArgs = {};
export declare function getCreateMetadataAccountV2InstructionDataEncoder(): Encoder<CreateMetadataAccountV2InstructionDataArgs>;
export declare function getCreateMetadataAccountV2InstructionDataDecoder(): Decoder<CreateMetadataAccountV2InstructionData>;
export declare function getCreateMetadataAccountV2InstructionDataCodec(): Codec<CreateMetadataAccountV2InstructionDataArgs, CreateMetadataAccountV2InstructionData>;
export type CreateMetadataAccountV2Input<TAccountMetadata extends string = string, TAccountMint extends string = string, TAccountMintAuthority extends string = string, TAccountPayer extends string = string, TAccountUpdateAuthority extends string = string, TAccountSystemProgram extends string = string, TAccountRent extends string = string> = {
    /** Metadata key (pda of ['metadata', program id, mint id]) */
    metadata: Address<TAccountMetadata>;
    /** Mint of token asset */
    mint: Address<TAccountMint>;
    /** Mint authority */
    mintAuthority: TransactionSigner<TAccountMintAuthority>;
    /** payer */
    payer: TransactionSigner<TAccountPayer>;
    /** update authority info */
    updateAuthority: Address<TAccountUpdateAuthority>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Rent info */
    rent?: Address<TAccountRent>;
};
export declare function getCreateMetadataAccountV2Instruction<TAccountMetadata extends string, TAccountMint extends string, TAccountMintAuthority extends string, TAccountPayer extends string, TAccountUpdateAuthority extends string, TAccountSystemProgram extends string, TAccountRent extends string>(input: CreateMetadataAccountV2Input<TAccountMetadata, TAccountMint, TAccountMintAuthority, TAccountPayer, TAccountUpdateAuthority, TAccountSystemProgram, TAccountRent>): CreateMetadataAccountV2Instruction<typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetadata, TAccountMint, TAccountMintAuthority, TAccountPayer, TAccountUpdateAuthority, TAccountSystemProgram, TAccountRent>;
export type ParsedCreateMetadataAccountV2Instruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Metadata key (pda of ['metadata', program id, mint id]) */
        metadata: TAccountMetas[0];
        /** Mint of token asset */
        mint: TAccountMetas[1];
        /** Mint authority */
        mintAuthority: TAccountMetas[2];
        /** payer */
        payer: TAccountMetas[3];
        /** update authority info */
        updateAuthority: TAccountMetas[4];
        /** System program */
        systemProgram: TAccountMetas[5];
        /** Rent info */
        rent?: TAccountMetas[6] | undefined;
    };
    data: CreateMetadataAccountV2InstructionData;
};
export declare function parseCreateMetadataAccountV2Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedCreateMetadataAccountV2Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=createMetadataAccountV2.d.ts.map