/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type Option, type OptionOrNullable, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TOKEN_METADATA_PROGRAM_ADDRESS } from '../programs';
import { type Collection, type CollectionArgs, type CollectionDetails, type CollectionDetailsArgs, type Creator, type CreatorArgs, type PrintSupply, type PrintSupplyArgs, type TokenStandard, type TokenStandardArgs, type Uses, type UsesArgs } from '../types';
export type CreateV1Instruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountMasterEdition extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountUpdateAuthority extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountSysvarInstructions extends string | IAccountMeta<string> = 'Sysvar1nstructions1111111111111111111111111', TAccountSplTokenProgram extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountMasterEdition extends string ? WritableAccount<TAccountMasterEdition> : TAccountMasterEdition,
    TAccountMint extends string ? WritableAccount<TAccountMint> : TAccountMint,
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountUpdateAuthority extends string ? ReadonlyAccount<TAccountUpdateAuthority> : TAccountUpdateAuthority,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountSysvarInstructions extends string ? ReadonlyAccount<TAccountSysvarInstructions> : TAccountSysvarInstructions,
    TAccountSplTokenProgram extends string ? ReadonlyAccount<TAccountSplTokenProgram> : TAccountSplTokenProgram,
    ...TRemainingAccounts
]>;
export type CreateV1InstructionData = {
    discriminator: number;
    createV1Discriminator: number;
    name: string;
    symbol: string;
    uri: string;
    sellerFeeBasisPoints: number;
    creators: Option<Array<Creator>>;
    primarySaleHappened: boolean;
    isMutable: boolean;
    tokenStandard: TokenStandard;
    collection: Option<Collection>;
    uses: Option<Uses>;
    collectionDetails: Option<CollectionDetails>;
    ruleSet: Option<Address>;
    decimals: Option<number>;
    printSupply: Option<PrintSupply>;
};
export type CreateV1InstructionDataArgs = {
    name: string;
    symbol: string;
    uri: string;
    sellerFeeBasisPoints: number;
    creators: OptionOrNullable<Array<CreatorArgs>>;
    primarySaleHappened: boolean;
    isMutable: boolean;
    tokenStandard: TokenStandardArgs;
    collection: OptionOrNullable<CollectionArgs>;
    uses: OptionOrNullable<UsesArgs>;
    collectionDetails: OptionOrNullable<CollectionDetailsArgs>;
    ruleSet: OptionOrNullable<Address>;
    decimals: OptionOrNullable<number>;
    printSupply: OptionOrNullable<PrintSupplyArgs>;
};
export declare function getCreateV1InstructionDataEncoder(): Encoder<CreateV1InstructionDataArgs>;
export declare function getCreateV1InstructionDataDecoder(): Decoder<CreateV1InstructionData>;
export declare function getCreateV1InstructionDataCodec(): Codec<CreateV1InstructionDataArgs, CreateV1InstructionData>;
export type CreateV1AsyncInput<TAccountMetadata extends string = string, TAccountMasterEdition extends string = string, TAccountMint extends string = string, TAccountAuthority extends string = string, TAccountPayer extends string = string, TAccountUpdateAuthority extends string = string, TAccountSystemProgram extends string = string, TAccountSysvarInstructions extends string = string, TAccountSplTokenProgram extends string = string> = {
    /** Unallocated metadata account with address as pda of ['metadata', program id, mint id] */
    metadata: Address<TAccountMetadata>;
    /** Unallocated edition account with address as pda of ['metadata', program id, mint, 'edition'] */
    masterEdition?: Address<TAccountMasterEdition>;
    /** Mint of token asset */
    mint: Address<TAccountMint> | TransactionSigner<TAccountMint>;
    /** Mint authority */
    authority: TransactionSigner<TAccountAuthority>;
    /** Payer */
    payer: TransactionSigner<TAccountPayer>;
    /** Update authority for the metadata account */
    updateAuthority: Address<TAccountUpdateAuthority> | TransactionSigner<TAccountUpdateAuthority>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Instructions sysvar account */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    /** SPL Token program */
    splTokenProgram?: Address<TAccountSplTokenProgram>;
    name: CreateV1InstructionDataArgs['name'];
    symbol: CreateV1InstructionDataArgs['symbol'];
    uri: CreateV1InstructionDataArgs['uri'];
    sellerFeeBasisPoints: CreateV1InstructionDataArgs['sellerFeeBasisPoints'];
    creators: CreateV1InstructionDataArgs['creators'];
    primarySaleHappened: CreateV1InstructionDataArgs['primarySaleHappened'];
    isMutable: CreateV1InstructionDataArgs['isMutable'];
    tokenStandard: CreateV1InstructionDataArgs['tokenStandard'];
    collection: CreateV1InstructionDataArgs['collection'];
    uses: CreateV1InstructionDataArgs['uses'];
    collectionDetails: CreateV1InstructionDataArgs['collectionDetails'];
    ruleSet: CreateV1InstructionDataArgs['ruleSet'];
    decimals: CreateV1InstructionDataArgs['decimals'];
    printSupply: CreateV1InstructionDataArgs['printSupply'];
};
export declare function getCreateV1InstructionAsync<TAccountMetadata extends string, TAccountMasterEdition extends string, TAccountMint extends string, TAccountAuthority extends string, TAccountPayer extends string, TAccountUpdateAuthority extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string, TAccountSplTokenProgram extends string>(input: CreateV1AsyncInput<TAccountMetadata, TAccountMasterEdition, TAccountMint, TAccountAuthority, TAccountPayer, TAccountUpdateAuthority, TAccountSystemProgram, TAccountSysvarInstructions, TAccountSplTokenProgram>): Promise<CreateV1Instruction<typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetadata, TAccountMasterEdition, (typeof input)['mint'] extends TransactionSigner<TAccountMint> ? WritableSignerAccount<TAccountMint> & IAccountSignerMeta<TAccountMint> : TAccountMint, TAccountAuthority, TAccountPayer, (typeof input)['updateAuthority'] extends TransactionSigner<TAccountUpdateAuthority> ? ReadonlySignerAccount<TAccountUpdateAuthority> & IAccountSignerMeta<TAccountUpdateAuthority> : TAccountUpdateAuthority, TAccountSystemProgram, TAccountSysvarInstructions, TAccountSplTokenProgram>>;
export type CreateV1Input<TAccountMetadata extends string = string, TAccountMasterEdition extends string = string, TAccountMint extends string = string, TAccountAuthority extends string = string, TAccountPayer extends string = string, TAccountUpdateAuthority extends string = string, TAccountSystemProgram extends string = string, TAccountSysvarInstructions extends string = string, TAccountSplTokenProgram extends string = string> = {
    /** Unallocated metadata account with address as pda of ['metadata', program id, mint id] */
    metadata: Address<TAccountMetadata>;
    /** Unallocated edition account with address as pda of ['metadata', program id, mint, 'edition'] */
    masterEdition?: Address<TAccountMasterEdition>;
    /** Mint of token asset */
    mint: Address<TAccountMint> | TransactionSigner<TAccountMint>;
    /** Mint authority */
    authority: TransactionSigner<TAccountAuthority>;
    /** Payer */
    payer: TransactionSigner<TAccountPayer>;
    /** Update authority for the metadata account */
    updateAuthority: Address<TAccountUpdateAuthority> | TransactionSigner<TAccountUpdateAuthority>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Instructions sysvar account */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    /** SPL Token program */
    splTokenProgram?: Address<TAccountSplTokenProgram>;
    name: CreateV1InstructionDataArgs['name'];
    symbol: CreateV1InstructionDataArgs['symbol'];
    uri: CreateV1InstructionDataArgs['uri'];
    sellerFeeBasisPoints: CreateV1InstructionDataArgs['sellerFeeBasisPoints'];
    creators: CreateV1InstructionDataArgs['creators'];
    primarySaleHappened: CreateV1InstructionDataArgs['primarySaleHappened'];
    isMutable: CreateV1InstructionDataArgs['isMutable'];
    tokenStandard: CreateV1InstructionDataArgs['tokenStandard'];
    collection: CreateV1InstructionDataArgs['collection'];
    uses: CreateV1InstructionDataArgs['uses'];
    collectionDetails: CreateV1InstructionDataArgs['collectionDetails'];
    ruleSet: CreateV1InstructionDataArgs['ruleSet'];
    decimals: CreateV1InstructionDataArgs['decimals'];
    printSupply: CreateV1InstructionDataArgs['printSupply'];
};
export declare function getCreateV1Instruction<TAccountMetadata extends string, TAccountMasterEdition extends string, TAccountMint extends string, TAccountAuthority extends string, TAccountPayer extends string, TAccountUpdateAuthority extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string, TAccountSplTokenProgram extends string>(input: CreateV1Input<TAccountMetadata, TAccountMasterEdition, TAccountMint, TAccountAuthority, TAccountPayer, TAccountUpdateAuthority, TAccountSystemProgram, TAccountSysvarInstructions, TAccountSplTokenProgram>): CreateV1Instruction<typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetadata, TAccountMasterEdition, (typeof input)['mint'] extends TransactionSigner<TAccountMint> ? WritableSignerAccount<TAccountMint> & IAccountSignerMeta<TAccountMint> : TAccountMint, TAccountAuthority, TAccountPayer, (typeof input)['updateAuthority'] extends TransactionSigner<TAccountUpdateAuthority> ? ReadonlySignerAccount<TAccountUpdateAuthority> & IAccountSignerMeta<TAccountUpdateAuthority> : TAccountUpdateAuthority, TAccountSystemProgram, TAccountSysvarInstructions, TAccountSplTokenProgram>;
export type ParsedCreateV1Instruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Unallocated metadata account with address as pda of ['metadata', program id, mint id] */
        metadata: TAccountMetas[0];
        /** Unallocated edition account with address as pda of ['metadata', program id, mint, 'edition'] */
        masterEdition?: TAccountMetas[1] | undefined;
        /** Mint of token asset */
        mint: TAccountMetas[2];
        /** Mint authority */
        authority: TAccountMetas[3];
        /** Payer */
        payer: TAccountMetas[4];
        /** Update authority for the metadata account */
        updateAuthority: TAccountMetas[5];
        /** System program */
        systemProgram: TAccountMetas[6];
        /** Instructions sysvar account */
        sysvarInstructions: TAccountMetas[7];
        /** SPL Token program */
        splTokenProgram?: TAccountMetas[8] | undefined;
    };
    data: CreateV1InstructionData;
};
export declare function parseCreateV1Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedCreateV1Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=createV1.d.ts.map