/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount } from '@solana/web3.js';
import { TOKEN_METADATA_PROGRAM_ADDRESS } from '../programs';
export type DeprecatedCreateMasterEditionInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountEdition extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountPrintingMint extends string | IAccountMeta<string> = string, TAccountOneTimePrintingAuthorizationMint extends string | IAccountMeta<string> = string, TAccountUpdateAuthority extends string | IAccountMeta<string> = string, TAccountPrintingMintAuthority extends string | IAccountMeta<string> = string, TAccountMintAuthority extends string | IAccountMeta<string> = string, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountRent extends string | IAccountMeta<string> = 'SysvarRent111111111111111111111111111111111', TAccountOneTimePrintingAuthorizationMintAuthority extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountEdition extends string ? WritableAccount<TAccountEdition> : TAccountEdition,
    TAccountMint extends string ? WritableAccount<TAccountMint> : TAccountMint,
    TAccountPrintingMint extends string ? WritableAccount<TAccountPrintingMint> : TAccountPrintingMint,
    TAccountOneTimePrintingAuthorizationMint extends string ? WritableAccount<TAccountOneTimePrintingAuthorizationMint> : TAccountOneTimePrintingAuthorizationMint,
    TAccountUpdateAuthority extends string ? ReadonlySignerAccount<TAccountUpdateAuthority> & IAccountSignerMeta<TAccountUpdateAuthority> : TAccountUpdateAuthority,
    TAccountPrintingMintAuthority extends string ? ReadonlySignerAccount<TAccountPrintingMintAuthority> & IAccountSignerMeta<TAccountPrintingMintAuthority> : TAccountPrintingMintAuthority,
    TAccountMintAuthority extends string ? ReadonlySignerAccount<TAccountMintAuthority> & IAccountSignerMeta<TAccountMintAuthority> : TAccountMintAuthority,
    TAccountMetadata extends string ? ReadonlyAccount<TAccountMetadata> : TAccountMetadata,
    TAccountPayer extends string ? ReadonlySignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountRent extends string ? ReadonlyAccount<TAccountRent> : TAccountRent,
    TAccountOneTimePrintingAuthorizationMintAuthority extends string ? ReadonlySignerAccount<TAccountOneTimePrintingAuthorizationMintAuthority> & IAccountSignerMeta<TAccountOneTimePrintingAuthorizationMintAuthority> : TAccountOneTimePrintingAuthorizationMintAuthority,
    ...TRemainingAccounts
]>;
export type DeprecatedCreateMasterEditionInstructionData = {
    discriminator: number;
};
export type DeprecatedCreateMasterEditionInstructionDataArgs = {};
export declare function getDeprecatedCreateMasterEditionInstructionDataEncoder(): Encoder<DeprecatedCreateMasterEditionInstructionDataArgs>;
export declare function getDeprecatedCreateMasterEditionInstructionDataDecoder(): Decoder<DeprecatedCreateMasterEditionInstructionData>;
export declare function getDeprecatedCreateMasterEditionInstructionDataCodec(): Codec<DeprecatedCreateMasterEditionInstructionDataArgs, DeprecatedCreateMasterEditionInstructionData>;
export type DeprecatedCreateMasterEditionInput<TAccountEdition extends string = string, TAccountMint extends string = string, TAccountPrintingMint extends string = string, TAccountOneTimePrintingAuthorizationMint extends string = string, TAccountUpdateAuthority extends string = string, TAccountPrintingMintAuthority extends string = string, TAccountMintAuthority extends string = string, TAccountMetadata extends string = string, TAccountPayer extends string = string, TAccountTokenProgram extends string = string, TAccountSystemProgram extends string = string, TAccountRent extends string = string, TAccountOneTimePrintingAuthorizationMintAuthority extends string = string> = {
    /** Unallocated edition V1 account with address as pda of ['metadata', program id, mint, 'edition'] */
    edition: Address<TAccountEdition>;
    /** Metadata mint */
    mint: Address<TAccountMint>;
    /** Printing mint - A mint you control that can mint tokens that can be exchanged for limited editions of your master edition via the MintNewEditionFromMasterEditionViaToken endpoint */
    printingMint: Address<TAccountPrintingMint>;
    /** One time authorization printing mint - A mint you control that prints tokens that gives the bearer permission to mint any number of tokens from the printing mint one time via an endpoint with the token-metadata program for your metadata. Also burns the token. */
    oneTimePrintingAuthorizationMint: Address<TAccountOneTimePrintingAuthorizationMint>;
    /** Current Update authority key */
    updateAuthority: TransactionSigner<TAccountUpdateAuthority>;
    /** Printing mint authority - THIS WILL TRANSFER AUTHORITY AWAY FROM THIS KEY. */
    printingMintAuthority: TransactionSigner<TAccountPrintingMintAuthority>;
    /** Mint authority on the metadata's mint - THIS WILL TRANSFER AUTHORITY AWAY FROM THIS KEY */
    mintAuthority: TransactionSigner<TAccountMintAuthority>;
    /** Metadata account */
    metadata: Address<TAccountMetadata>;
    /** payer */
    payer: TransactionSigner<TAccountPayer>;
    /** Token program */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Rent info */
    rent?: Address<TAccountRent>;
    /** One time authorization printing mint authority - must be provided if using max supply. THIS WILL TRANSFER AUTHORITY AWAY FROM THIS KEY. */
    oneTimePrintingAuthorizationMintAuthority: TransactionSigner<TAccountOneTimePrintingAuthorizationMintAuthority>;
};
export declare function getDeprecatedCreateMasterEditionInstruction<TAccountEdition extends string, TAccountMint extends string, TAccountPrintingMint extends string, TAccountOneTimePrintingAuthorizationMint extends string, TAccountUpdateAuthority extends string, TAccountPrintingMintAuthority extends string, TAccountMintAuthority extends string, TAccountMetadata extends string, TAccountPayer extends string, TAccountTokenProgram extends string, TAccountSystemProgram extends string, TAccountRent extends string, TAccountOneTimePrintingAuthorizationMintAuthority extends string>(input: DeprecatedCreateMasterEditionInput<TAccountEdition, TAccountMint, TAccountPrintingMint, TAccountOneTimePrintingAuthorizationMint, TAccountUpdateAuthority, TAccountPrintingMintAuthority, TAccountMintAuthority, TAccountMetadata, TAccountPayer, TAccountTokenProgram, TAccountSystemProgram, TAccountRent, TAccountOneTimePrintingAuthorizationMintAuthority>): DeprecatedCreateMasterEditionInstruction<typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountEdition, TAccountMint, TAccountPrintingMint, TAccountOneTimePrintingAuthorizationMint, TAccountUpdateAuthority, TAccountPrintingMintAuthority, TAccountMintAuthority, TAccountMetadata, TAccountPayer, TAccountTokenProgram, TAccountSystemProgram, TAccountRent, TAccountOneTimePrintingAuthorizationMintAuthority>;
export type ParsedDeprecatedCreateMasterEditionInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Unallocated edition V1 account with address as pda of ['metadata', program id, mint, 'edition'] */
        edition: TAccountMetas[0];
        /** Metadata mint */
        mint: TAccountMetas[1];
        /** Printing mint - A mint you control that can mint tokens that can be exchanged for limited editions of your master edition via the MintNewEditionFromMasterEditionViaToken endpoint */
        printingMint: TAccountMetas[2];
        /** One time authorization printing mint - A mint you control that prints tokens that gives the bearer permission to mint any number of tokens from the printing mint one time via an endpoint with the token-metadata program for your metadata. Also burns the token. */
        oneTimePrintingAuthorizationMint: TAccountMetas[3];
        /** Current Update authority key */
        updateAuthority: TAccountMetas[4];
        /** Printing mint authority - THIS WILL TRANSFER AUTHORITY AWAY FROM THIS KEY. */
        printingMintAuthority: TAccountMetas[5];
        /** Mint authority on the metadata's mint - THIS WILL TRANSFER AUTHORITY AWAY FROM THIS KEY */
        mintAuthority: TAccountMetas[6];
        /** Metadata account */
        metadata: TAccountMetas[7];
        /** payer */
        payer: TAccountMetas[8];
        /** Token program */
        tokenProgram: TAccountMetas[9];
        /** System program */
        systemProgram: TAccountMetas[10];
        /** Rent info */
        rent: TAccountMetas[11];
        /** One time authorization printing mint authority - must be provided if using max supply. THIS WILL TRANSFER AUTHORITY AWAY FROM THIS KEY. */
        oneTimePrintingAuthorizationMintAuthority: TAccountMetas[12];
    };
    data: DeprecatedCreateMasterEditionInstructionData;
};
export declare function parseDeprecatedCreateMasterEditionInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedDeprecatedCreateMasterEditionInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=deprecatedCreateMasterEdition.d.ts.map