/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount } from '@solana/web3.js';
import { TOKEN_METADATA_PROGRAM_ADDRESS } from '../programs';
export type DeprecatedCreateReservationListInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountReservationList extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountUpdateAuthority extends string | IAccountMeta<string> = string, TAccountMasterEdition extends string | IAccountMeta<string> = string, TAccountResource extends string | IAccountMeta<string> = string, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountRent extends string | IAccountMeta<string> = 'SysvarRent111111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountReservationList extends string ? WritableAccount<TAccountReservationList> : TAccountReservationList,
    TAccountPayer extends string ? ReadonlySignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountUpdateAuthority extends string ? ReadonlySignerAccount<TAccountUpdateAuthority> & IAccountSignerMeta<TAccountUpdateAuthority> : TAccountUpdateAuthority,
    TAccountMasterEdition extends string ? ReadonlyAccount<TAccountMasterEdition> : TAccountMasterEdition,
    TAccountResource extends string ? ReadonlyAccount<TAccountResource> : TAccountResource,
    TAccountMetadata extends string ? ReadonlyAccount<TAccountMetadata> : TAccountMetadata,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountRent extends string ? ReadonlyAccount<TAccountRent> : TAccountRent,
    ...TRemainingAccounts
]>;
export type DeprecatedCreateReservationListInstructionData = {
    discriminator: number;
};
export type DeprecatedCreateReservationListInstructionDataArgs = {};
export declare function getDeprecatedCreateReservationListInstructionDataEncoder(): Encoder<DeprecatedCreateReservationListInstructionDataArgs>;
export declare function getDeprecatedCreateReservationListInstructionDataDecoder(): Decoder<DeprecatedCreateReservationListInstructionData>;
export declare function getDeprecatedCreateReservationListInstructionDataCodec(): Codec<DeprecatedCreateReservationListInstructionDataArgs, DeprecatedCreateReservationListInstructionData>;
export type DeprecatedCreateReservationListInput<TAccountReservationList extends string = string, TAccountPayer extends string = string, TAccountUpdateAuthority extends string = string, TAccountMasterEdition extends string = string, TAccountResource extends string = string, TAccountMetadata extends string = string, TAccountSystemProgram extends string = string, TAccountRent extends string = string> = {
    /** PDA for ReservationList of ['metadata', program id, master edition key, 'reservation', resource-key] */
    reservationList: Address<TAccountReservationList>;
    /** Payer */
    payer: TransactionSigner<TAccountPayer>;
    /** Update authority */
    updateAuthority: TransactionSigner<TAccountUpdateAuthority>;
    /**  Master Edition V1 key (pda of ['metadata', program id, mint id, 'edition']) */
    masterEdition: Address<TAccountMasterEdition>;
    /** A resource you wish to tie the reservation list to. This is so your later visitors who come to redeem can derive your reservation list PDA with something they can easily get at. You choose what this should be. */
    resource: Address<TAccountResource>;
    /** Metadata key (pda of ['metadata', program id, mint id]) */
    metadata: Address<TAccountMetadata>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Rent info */
    rent?: Address<TAccountRent>;
};
export declare function getDeprecatedCreateReservationListInstruction<TAccountReservationList extends string, TAccountPayer extends string, TAccountUpdateAuthority extends string, TAccountMasterEdition extends string, TAccountResource extends string, TAccountMetadata extends string, TAccountSystemProgram extends string, TAccountRent extends string>(input: DeprecatedCreateReservationListInput<TAccountReservationList, TAccountPayer, TAccountUpdateAuthority, TAccountMasterEdition, TAccountResource, TAccountMetadata, TAccountSystemProgram, TAccountRent>): DeprecatedCreateReservationListInstruction<typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountReservationList, TAccountPayer, TAccountUpdateAuthority, TAccountMasterEdition, TAccountResource, TAccountMetadata, TAccountSystemProgram, TAccountRent>;
export type ParsedDeprecatedCreateReservationListInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** PDA for ReservationList of ['metadata', program id, master edition key, 'reservation', resource-key] */
        reservationList: TAccountMetas[0];
        /** Payer */
        payer: TAccountMetas[1];
        /** Update authority */
        updateAuthority: TAccountMetas[2];
        /**  Master Edition V1 key (pda of ['metadata', program id, mint id, 'edition']) */
        masterEdition: TAccountMetas[3];
        /** A resource you wish to tie the reservation list to. This is so your later visitors who come to redeem can derive your reservation list PDA with something they can easily get at. You choose what this should be. */
        resource: TAccountMetas[4];
        /** Metadata key (pda of ['metadata', program id, mint id]) */
        metadata: TAccountMetas[5];
        /** System program */
        systemProgram: TAccountMetas[6];
        /** Rent info */
        rent: TAccountMetas[7];
    };
    data: DeprecatedCreateReservationListInstructionData;
};
export declare function parseDeprecatedCreateReservationListInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedDeprecatedCreateReservationListInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=deprecatedCreateReservationList.d.ts.map