/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount } from '@solana/web3.js';
import { TOKEN_METADATA_PROGRAM_ADDRESS } from '../programs';
export type DeprecatedMintPrintingTokensViaTokenInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountDestination extends string | IAccountMeta<string> = string, TAccountToken extends string | IAccountMeta<string> = string, TAccountOneTimePrintingAuthorizationMint extends string | IAccountMeta<string> = string, TAccountPrintingMint extends string | IAccountMeta<string> = string, TAccountBurnAuthority extends string | IAccountMeta<string> = string, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountMasterEdition extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TAccountRent extends string | IAccountMeta<string> = 'SysvarRent111111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountDestination extends string ? WritableAccount<TAccountDestination> : TAccountDestination,
    TAccountToken extends string ? WritableAccount<TAccountToken> : TAccountToken,
    TAccountOneTimePrintingAuthorizationMint extends string ? WritableAccount<TAccountOneTimePrintingAuthorizationMint> : TAccountOneTimePrintingAuthorizationMint,
    TAccountPrintingMint extends string ? WritableAccount<TAccountPrintingMint> : TAccountPrintingMint,
    TAccountBurnAuthority extends string ? ReadonlySignerAccount<TAccountBurnAuthority> & IAccountSignerMeta<TAccountBurnAuthority> : TAccountBurnAuthority,
    TAccountMetadata extends string ? ReadonlyAccount<TAccountMetadata> : TAccountMetadata,
    TAccountMasterEdition extends string ? ReadonlyAccount<TAccountMasterEdition> : TAccountMasterEdition,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    TAccountRent extends string ? ReadonlyAccount<TAccountRent> : TAccountRent,
    ...TRemainingAccounts
]>;
export type DeprecatedMintPrintingTokensViaTokenInstructionData = {
    discriminator: number;
};
export type DeprecatedMintPrintingTokensViaTokenInstructionDataArgs = {};
export declare function getDeprecatedMintPrintingTokensViaTokenInstructionDataEncoder(): Encoder<DeprecatedMintPrintingTokensViaTokenInstructionDataArgs>;
export declare function getDeprecatedMintPrintingTokensViaTokenInstructionDataDecoder(): Decoder<DeprecatedMintPrintingTokensViaTokenInstructionData>;
export declare function getDeprecatedMintPrintingTokensViaTokenInstructionDataCodec(): Codec<DeprecatedMintPrintingTokensViaTokenInstructionDataArgs, DeprecatedMintPrintingTokensViaTokenInstructionData>;
export type DeprecatedMintPrintingTokensViaTokenInput<TAccountDestination extends string = string, TAccountToken extends string = string, TAccountOneTimePrintingAuthorizationMint extends string = string, TAccountPrintingMint extends string = string, TAccountBurnAuthority extends string = string, TAccountMetadata extends string = string, TAccountMasterEdition extends string = string, TAccountTokenProgram extends string = string, TAccountRent extends string = string> = {
    /** Destination account */
    destination: Address<TAccountDestination>;
    /** Token account containing one time authorization token */
    token: Address<TAccountToken>;
    /** One time authorization mint */
    oneTimePrintingAuthorizationMint: Address<TAccountOneTimePrintingAuthorizationMint>;
    /** Printing mint */
    printingMint: Address<TAccountPrintingMint>;
    /** Burn authority */
    burnAuthority: TransactionSigner<TAccountBurnAuthority>;
    /** Metadata key (pda of ['metadata', program id, mint id]) */
    metadata: Address<TAccountMetadata>;
    /** Master Edition V1 key (pda of ['metadata', program id, mint id, 'edition']) */
    masterEdition: Address<TAccountMasterEdition>;
    /** Token program */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** Rent */
    rent?: Address<TAccountRent>;
};
export declare function getDeprecatedMintPrintingTokensViaTokenInstruction<TAccountDestination extends string, TAccountToken extends string, TAccountOneTimePrintingAuthorizationMint extends string, TAccountPrintingMint extends string, TAccountBurnAuthority extends string, TAccountMetadata extends string, TAccountMasterEdition extends string, TAccountTokenProgram extends string, TAccountRent extends string>(input: DeprecatedMintPrintingTokensViaTokenInput<TAccountDestination, TAccountToken, TAccountOneTimePrintingAuthorizationMint, TAccountPrintingMint, TAccountBurnAuthority, TAccountMetadata, TAccountMasterEdition, TAccountTokenProgram, TAccountRent>): DeprecatedMintPrintingTokensViaTokenInstruction<typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountDestination, TAccountToken, TAccountOneTimePrintingAuthorizationMint, TAccountPrintingMint, TAccountBurnAuthority, TAccountMetadata, TAccountMasterEdition, TAccountTokenProgram, TAccountRent>;
export type ParsedDeprecatedMintPrintingTokensViaTokenInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Destination account */
        destination: TAccountMetas[0];
        /** Token account containing one time authorization token */
        token: TAccountMetas[1];
        /** One time authorization mint */
        oneTimePrintingAuthorizationMint: TAccountMetas[2];
        /** Printing mint */
        printingMint: TAccountMetas[3];
        /** Burn authority */
        burnAuthority: TAccountMetas[4];
        /** Metadata key (pda of ['metadata', program id, mint id]) */
        metadata: TAccountMetas[5];
        /** Master Edition V1 key (pda of ['metadata', program id, mint id, 'edition']) */
        masterEdition: TAccountMetas[6];
        /** Token program */
        tokenProgram: TAccountMetas[7];
        /** Rent */
        rent: TAccountMetas[8];
    };
    data: DeprecatedMintPrintingTokensViaTokenInstructionData;
};
export declare function parseDeprecatedMintPrintingTokensViaTokenInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedDeprecatedMintPrintingTokensViaTokenInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=deprecatedMintPrintingTokensViaToken.d.ts.map