/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TOKEN_METADATA_PROGRAM_ADDRESS } from '../programs';
export type MigrateInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountEdition extends string | IAccountMeta<string> = string, TAccountToken extends string | IAccountMeta<string> = string, TAccountTokenOwner extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountCollectionMetadata extends string | IAccountMeta<string> = string, TAccountDelegateRecord extends string | IAccountMeta<string> = string, TAccountTokenRecord extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountSysvarInstructions extends string | IAccountMeta<string> = 'Sysvar1nstructions1111111111111111111111111', TAccountSplTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TAccountAuthorizationRulesProgram extends string | IAccountMeta<string> = string, TAccountAuthorizationRules extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountEdition extends string ? WritableAccount<TAccountEdition> : TAccountEdition,
    TAccountToken extends string ? WritableAccount<TAccountToken> : TAccountToken,
    TAccountTokenOwner extends string ? ReadonlyAccount<TAccountTokenOwner> : TAccountTokenOwner,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountCollectionMetadata extends string ? ReadonlyAccount<TAccountCollectionMetadata> : TAccountCollectionMetadata,
    TAccountDelegateRecord extends string ? ReadonlyAccount<TAccountDelegateRecord> : TAccountDelegateRecord,
    TAccountTokenRecord extends string ? WritableAccount<TAccountTokenRecord> : TAccountTokenRecord,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountSysvarInstructions extends string ? ReadonlyAccount<TAccountSysvarInstructions> : TAccountSysvarInstructions,
    TAccountSplTokenProgram extends string ? ReadonlyAccount<TAccountSplTokenProgram> : TAccountSplTokenProgram,
    TAccountAuthorizationRulesProgram extends string ? ReadonlyAccount<TAccountAuthorizationRulesProgram> : TAccountAuthorizationRulesProgram,
    TAccountAuthorizationRules extends string ? ReadonlyAccount<TAccountAuthorizationRules> : TAccountAuthorizationRules,
    ...TRemainingAccounts
]>;
export type MigrateInstructionData = {
    discriminator: number;
};
export type MigrateInstructionDataArgs = {};
export declare function getMigrateInstructionDataEncoder(): Encoder<MigrateInstructionDataArgs>;
export declare function getMigrateInstructionDataDecoder(): Decoder<MigrateInstructionData>;
export declare function getMigrateInstructionDataCodec(): Codec<MigrateInstructionDataArgs, MigrateInstructionData>;
export type MigrateInput<TAccountMetadata extends string = string, TAccountEdition extends string = string, TAccountToken extends string = string, TAccountTokenOwner extends string = string, TAccountMint extends string = string, TAccountPayer extends string = string, TAccountAuthority extends string = string, TAccountCollectionMetadata extends string = string, TAccountDelegateRecord extends string = string, TAccountTokenRecord extends string = string, TAccountSystemProgram extends string = string, TAccountSysvarInstructions extends string = string, TAccountSplTokenProgram extends string = string, TAccountAuthorizationRulesProgram extends string = string, TAccountAuthorizationRules extends string = string> = {
    /** Metadata account */
    metadata: Address<TAccountMetadata>;
    /** Edition account */
    edition: Address<TAccountEdition>;
    /** Token account */
    token: Address<TAccountToken>;
    /** Token account owner */
    tokenOwner: Address<TAccountTokenOwner>;
    /** Mint account */
    mint: Address<TAccountMint>;
    /** Payer */
    payer: TransactionSigner<TAccountPayer>;
    /** Update authority */
    authority: TransactionSigner<TAccountAuthority>;
    /** Collection metadata account */
    collectionMetadata: Address<TAccountCollectionMetadata>;
    /** Delegate record account */
    delegateRecord: Address<TAccountDelegateRecord>;
    /** Token record account */
    tokenRecord: Address<TAccountTokenRecord>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Instruction sysvar account */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    /** SPL Token Program */
    splTokenProgram?: Address<TAccountSplTokenProgram>;
    /** Token Authorization Rules Program */
    authorizationRulesProgram?: Address<TAccountAuthorizationRulesProgram>;
    /** Token Authorization Rules account */
    authorizationRules?: Address<TAccountAuthorizationRules>;
};
export declare function getMigrateInstruction<TAccountMetadata extends string, TAccountEdition extends string, TAccountToken extends string, TAccountTokenOwner extends string, TAccountMint extends string, TAccountPayer extends string, TAccountAuthority extends string, TAccountCollectionMetadata extends string, TAccountDelegateRecord extends string, TAccountTokenRecord extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string, TAccountSplTokenProgram extends string, TAccountAuthorizationRulesProgram extends string, TAccountAuthorizationRules extends string>(input: MigrateInput<TAccountMetadata, TAccountEdition, TAccountToken, TAccountTokenOwner, TAccountMint, TAccountPayer, TAccountAuthority, TAccountCollectionMetadata, TAccountDelegateRecord, TAccountTokenRecord, TAccountSystemProgram, TAccountSysvarInstructions, TAccountSplTokenProgram, TAccountAuthorizationRulesProgram, TAccountAuthorizationRules>): MigrateInstruction<typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetadata, TAccountEdition, TAccountToken, TAccountTokenOwner, TAccountMint, TAccountPayer, TAccountAuthority, TAccountCollectionMetadata, TAccountDelegateRecord, TAccountTokenRecord, TAccountSystemProgram, TAccountSysvarInstructions, TAccountSplTokenProgram, TAccountAuthorizationRulesProgram, TAccountAuthorizationRules>;
export type ParsedMigrateInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Metadata account */
        metadata: TAccountMetas[0];
        /** Edition account */
        edition: TAccountMetas[1];
        /** Token account */
        token: TAccountMetas[2];
        /** Token account owner */
        tokenOwner: TAccountMetas[3];
        /** Mint account */
        mint: TAccountMetas[4];
        /** Payer */
        payer: TAccountMetas[5];
        /** Update authority */
        authority: TAccountMetas[6];
        /** Collection metadata account */
        collectionMetadata: TAccountMetas[7];
        /** Delegate record account */
        delegateRecord: TAccountMetas[8];
        /** Token record account */
        tokenRecord: TAccountMetas[9];
        /** System program */
        systemProgram: TAccountMetas[10];
        /** Instruction sysvar account */
        sysvarInstructions: TAccountMetas[11];
        /** SPL Token Program */
        splTokenProgram: TAccountMetas[12];
        /** Token Authorization Rules Program */
        authorizationRulesProgram?: TAccountMetas[13] | undefined;
        /** Token Authorization Rules account */
        authorizationRules?: TAccountMetas[14] | undefined;
    };
    data: MigrateInstructionData;
};
export declare function parseMigrateInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedMigrateInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=migrate.d.ts.map