/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TOKEN_METADATA_PROGRAM_ADDRESS } from '../programs';
import { type TransferArgs, type TransferArgsArgs } from '../types';
export type TransferInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountToken extends string | IAccountMeta<string> = string, TAccountTokenOwner extends string | IAccountMeta<string> = string, TAccountDestination extends string | IAccountMeta<string> = string, TAccountDestinationOwner extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountEdition extends string | IAccountMeta<string> = string, TAccountOwnerTokenRecord extends string | IAccountMeta<string> = string, TAccountDestinationTokenRecord extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountSysvarInstructions extends string | IAccountMeta<string> = 'Sysvar1nstructions1111111111111111111111111', TAccountSplTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TAccountSplAtaProgram extends string | IAccountMeta<string> = 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL', TAccountAuthorizationRulesProgram extends string | IAccountMeta<string> = string, TAccountAuthorizationRules extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountToken extends string ? WritableAccount<TAccountToken> : TAccountToken,
    TAccountTokenOwner extends string ? ReadonlyAccount<TAccountTokenOwner> : TAccountTokenOwner,
    TAccountDestination extends string ? WritableAccount<TAccountDestination> : TAccountDestination,
    TAccountDestinationOwner extends string ? ReadonlyAccount<TAccountDestinationOwner> : TAccountDestinationOwner,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountEdition extends string ? ReadonlyAccount<TAccountEdition> : TAccountEdition,
    TAccountOwnerTokenRecord extends string ? WritableAccount<TAccountOwnerTokenRecord> : TAccountOwnerTokenRecord,
    TAccountDestinationTokenRecord extends string ? WritableAccount<TAccountDestinationTokenRecord> : TAccountDestinationTokenRecord,
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountSysvarInstructions extends string ? ReadonlyAccount<TAccountSysvarInstructions> : TAccountSysvarInstructions,
    TAccountSplTokenProgram extends string ? ReadonlyAccount<TAccountSplTokenProgram> : TAccountSplTokenProgram,
    TAccountSplAtaProgram extends string ? ReadonlyAccount<TAccountSplAtaProgram> : TAccountSplAtaProgram,
    TAccountAuthorizationRulesProgram extends string ? ReadonlyAccount<TAccountAuthorizationRulesProgram> : TAccountAuthorizationRulesProgram,
    TAccountAuthorizationRules extends string ? ReadonlyAccount<TAccountAuthorizationRules> : TAccountAuthorizationRules,
    ...TRemainingAccounts
]>;
export type TransferInstructionData = {
    discriminator: number;
    transferArgs: TransferArgs;
};
export type TransferInstructionDataArgs = {
    transferArgs: TransferArgsArgs;
};
export declare function getTransferInstructionDataEncoder(): Encoder<TransferInstructionDataArgs>;
export declare function getTransferInstructionDataDecoder(): Decoder<TransferInstructionData>;
export declare function getTransferInstructionDataCodec(): Codec<TransferInstructionDataArgs, TransferInstructionData>;
export type TransferInput<TAccountToken extends string = string, TAccountTokenOwner extends string = string, TAccountDestination extends string = string, TAccountDestinationOwner extends string = string, TAccountMint extends string = string, TAccountMetadata extends string = string, TAccountEdition extends string = string, TAccountOwnerTokenRecord extends string = string, TAccountDestinationTokenRecord extends string = string, TAccountAuthority extends string = string, TAccountPayer extends string = string, TAccountSystemProgram extends string = string, TAccountSysvarInstructions extends string = string, TAccountSplTokenProgram extends string = string, TAccountSplAtaProgram extends string = string, TAccountAuthorizationRulesProgram extends string = string, TAccountAuthorizationRules extends string = string> = {
    /** Token account */
    token: Address<TAccountToken>;
    /** Token account owner */
    tokenOwner: Address<TAccountTokenOwner>;
    /** Destination token account */
    destination: Address<TAccountDestination>;
    /** Destination token account owner */
    destinationOwner: Address<TAccountDestinationOwner>;
    /** Mint of token asset */
    mint: Address<TAccountMint>;
    /** Metadata (pda of ['metadata', program id, mint id]) */
    metadata: Address<TAccountMetadata>;
    /** Edition of token asset */
    edition?: Address<TAccountEdition>;
    /** Owner token record account */
    ownerTokenRecord?: Address<TAccountOwnerTokenRecord>;
    /** Destination token record account */
    destinationTokenRecord?: Address<TAccountDestinationTokenRecord>;
    /** Transfer authority (token owner or delegate) */
    authority: TransactionSigner<TAccountAuthority>;
    /** Payer */
    payer: TransactionSigner<TAccountPayer>;
    /** System Program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Instructions sysvar account */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    /** SPL Token Program */
    splTokenProgram?: Address<TAccountSplTokenProgram>;
    /** SPL Associated Token Account program */
    splAtaProgram?: Address<TAccountSplAtaProgram>;
    /** Token Authorization Rules Program */
    authorizationRulesProgram?: Address<TAccountAuthorizationRulesProgram>;
    /** Token Authorization Rules account */
    authorizationRules?: Address<TAccountAuthorizationRules>;
    transferArgs: TransferInstructionDataArgs['transferArgs'];
};
export declare function getTransferInstruction<TAccountToken extends string, TAccountTokenOwner extends string, TAccountDestination extends string, TAccountDestinationOwner extends string, TAccountMint extends string, TAccountMetadata extends string, TAccountEdition extends string, TAccountOwnerTokenRecord extends string, TAccountDestinationTokenRecord extends string, TAccountAuthority extends string, TAccountPayer extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string, TAccountSplTokenProgram extends string, TAccountSplAtaProgram extends string, TAccountAuthorizationRulesProgram extends string, TAccountAuthorizationRules extends string>(input: TransferInput<TAccountToken, TAccountTokenOwner, TAccountDestination, TAccountDestinationOwner, TAccountMint, TAccountMetadata, TAccountEdition, TAccountOwnerTokenRecord, TAccountDestinationTokenRecord, TAccountAuthority, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions, TAccountSplTokenProgram, TAccountSplAtaProgram, TAccountAuthorizationRulesProgram, TAccountAuthorizationRules>): TransferInstruction<typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountToken, TAccountTokenOwner, TAccountDestination, TAccountDestinationOwner, TAccountMint, TAccountMetadata, TAccountEdition, TAccountOwnerTokenRecord, TAccountDestinationTokenRecord, TAccountAuthority, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions, TAccountSplTokenProgram, TAccountSplAtaProgram, TAccountAuthorizationRulesProgram, TAccountAuthorizationRules>;
export type ParsedTransferInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Token account */
        token: TAccountMetas[0];
        /** Token account owner */
        tokenOwner: TAccountMetas[1];
        /** Destination token account */
        destination: TAccountMetas[2];
        /** Destination token account owner */
        destinationOwner: TAccountMetas[3];
        /** Mint of token asset */
        mint: TAccountMetas[4];
        /** Metadata (pda of ['metadata', program id, mint id]) */
        metadata: TAccountMetas[5];
        /** Edition of token asset */
        edition?: TAccountMetas[6] | undefined;
        /** Owner token record account */
        ownerTokenRecord?: TAccountMetas[7] | undefined;
        /** Destination token record account */
        destinationTokenRecord?: TAccountMetas[8] | undefined;
        /** Transfer authority (token owner or delegate) */
        authority: TAccountMetas[9];
        /** Payer */
        payer: TAccountMetas[10];
        /** System Program */
        systemProgram: TAccountMetas[11];
        /** Instructions sysvar account */
        sysvarInstructions: TAccountMetas[12];
        /** SPL Token Program */
        splTokenProgram: TAccountMetas[13];
        /** SPL Associated Token Account program */
        splAtaProgram: TAccountMetas[14];
        /** Token Authorization Rules Program */
        authorizationRulesProgram?: TAccountMetas[15] | undefined;
        /** Token Authorization Rules account */
        authorizationRules?: TAccountMetas[16] | undefined;
    };
    data: TransferInstructionData;
};
export declare function parseTransferInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedTransferInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=transfer.d.ts.map