/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TOKEN_METADATA_PROGRAM_ADDRESS } from '../programs';
export type UnverifySizedCollectionItemInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountCollectionAuthority extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountCollectionMint extends string | IAccountMeta<string> = string, TAccountCollection extends string | IAccountMeta<string> = string, TAccountCollectionMasterEditionAccount extends string | IAccountMeta<string> = string, TAccountCollectionAuthorityRecord extends string | IAccountMeta<string> | undefined = undefined, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountCollectionAuthority extends string ? ReadonlySignerAccount<TAccountCollectionAuthority> & IAccountSignerMeta<TAccountCollectionAuthority> : TAccountCollectionAuthority,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountCollectionMint extends string ? ReadonlyAccount<TAccountCollectionMint> : TAccountCollectionMint,
    TAccountCollection extends string ? WritableAccount<TAccountCollection> : TAccountCollection,
    TAccountCollectionMasterEditionAccount extends string ? ReadonlyAccount<TAccountCollectionMasterEditionAccount> : TAccountCollectionMasterEditionAccount,
    ...(TAccountCollectionAuthorityRecord extends undefined ? [] : [
        TAccountCollectionAuthorityRecord extends string ? ReadonlyAccount<TAccountCollectionAuthorityRecord> : TAccountCollectionAuthorityRecord
    ]),
    ...TRemainingAccounts
]>;
export type UnverifySizedCollectionItemInstructionData = {
    discriminator: number;
};
export type UnverifySizedCollectionItemInstructionDataArgs = {};
export declare function getUnverifySizedCollectionItemInstructionDataEncoder(): Encoder<UnverifySizedCollectionItemInstructionDataArgs>;
export declare function getUnverifySizedCollectionItemInstructionDataDecoder(): Decoder<UnverifySizedCollectionItemInstructionData>;
export declare function getUnverifySizedCollectionItemInstructionDataCodec(): Codec<UnverifySizedCollectionItemInstructionDataArgs, UnverifySizedCollectionItemInstructionData>;
export type UnverifySizedCollectionItemInput<TAccountMetadata extends string = string, TAccountCollectionAuthority extends string = string, TAccountPayer extends string = string, TAccountCollectionMint extends string = string, TAccountCollection extends string = string, TAccountCollectionMasterEditionAccount extends string = string, TAccountCollectionAuthorityRecord extends string = string> = {
    /** Metadata account */
    metadata: Address<TAccountMetadata>;
    /** Collection Authority */
    collectionAuthority: TransactionSigner<TAccountCollectionAuthority>;
    /** payer */
    payer: TransactionSigner<TAccountPayer>;
    /** Mint of the Collection */
    collectionMint: Address<TAccountCollectionMint>;
    /** Metadata Account of the Collection */
    collection: Address<TAccountCollection>;
    /** MasterEdition2 Account of the Collection Token */
    collectionMasterEditionAccount: Address<TAccountCollectionMasterEditionAccount>;
    /** Collection Authority Record PDA */
    collectionAuthorityRecord?: Address<TAccountCollectionAuthorityRecord>;
};
export declare function getUnverifySizedCollectionItemInstruction<TAccountMetadata extends string, TAccountCollectionAuthority extends string, TAccountPayer extends string, TAccountCollectionMint extends string, TAccountCollection extends string, TAccountCollectionMasterEditionAccount extends string, TAccountCollectionAuthorityRecord extends string>(input: UnverifySizedCollectionItemInput<TAccountMetadata, TAccountCollectionAuthority, TAccountPayer, TAccountCollectionMint, TAccountCollection, TAccountCollectionMasterEditionAccount, TAccountCollectionAuthorityRecord>): UnverifySizedCollectionItemInstruction<typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetadata, TAccountCollectionAuthority, TAccountPayer, TAccountCollectionMint, TAccountCollection, TAccountCollectionMasterEditionAccount, TAccountCollectionAuthorityRecord>;
export type ParsedUnverifySizedCollectionItemInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Metadata account */
        metadata: TAccountMetas[0];
        /** Collection Authority */
        collectionAuthority: TAccountMetas[1];
        /** payer */
        payer: TAccountMetas[2];
        /** Mint of the Collection */
        collectionMint: TAccountMetas[3];
        /** Metadata Account of the Collection */
        collection: TAccountMetas[4];
        /** MasterEdition2 Account of the Collection Token */
        collectionMasterEditionAccount: TAccountMetas[5];
        /** Collection Authority Record PDA */
        collectionAuthorityRecord?: TAccountMetas[6] | undefined;
    };
    data: UnverifySizedCollectionItemInstructionData;
};
export declare function parseUnverifySizedCollectionItemInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedUnverifySizedCollectionItemInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=unverifySizedCollectionItem.d.ts.map