/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TOKEN_METADATA_PROGRAM_ADDRESS } from '../programs';
import { type UpdateArgs, type UpdateArgsArgs } from '../types';
export type UpdateInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountDelegateRecord extends string | IAccountMeta<string> = string, TAccountToken extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountEdition extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountSysvarInstructions extends string | IAccountMeta<string> = 'Sysvar1nstructions1111111111111111111111111', TAccountAuthorizationRulesProgram extends string | IAccountMeta<string> = string, TAccountAuthorizationRules extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountDelegateRecord extends string ? ReadonlyAccount<TAccountDelegateRecord> : TAccountDelegateRecord,
    TAccountToken extends string ? ReadonlyAccount<TAccountToken> : TAccountToken,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountEdition extends string ? ReadonlyAccount<TAccountEdition> : TAccountEdition,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountSysvarInstructions extends string ? ReadonlyAccount<TAccountSysvarInstructions> : TAccountSysvarInstructions,
    TAccountAuthorizationRulesProgram extends string ? ReadonlyAccount<TAccountAuthorizationRulesProgram> : TAccountAuthorizationRulesProgram,
    TAccountAuthorizationRules extends string ? ReadonlyAccount<TAccountAuthorizationRules> : TAccountAuthorizationRules,
    ...TRemainingAccounts
]>;
export type UpdateInstructionData = {
    discriminator: number;
    updateArgs: UpdateArgs;
};
export type UpdateInstructionDataArgs = {
    updateArgs: UpdateArgsArgs;
};
export declare function getUpdateInstructionDataEncoder(): Encoder<UpdateInstructionDataArgs>;
export declare function getUpdateInstructionDataDecoder(): Decoder<UpdateInstructionData>;
export declare function getUpdateInstructionDataCodec(): Codec<UpdateInstructionDataArgs, UpdateInstructionData>;
export type UpdateInput<TAccountAuthority extends string = string, TAccountDelegateRecord extends string = string, TAccountToken extends string = string, TAccountMint extends string = string, TAccountMetadata extends string = string, TAccountEdition extends string = string, TAccountPayer extends string = string, TAccountSystemProgram extends string = string, TAccountSysvarInstructions extends string = string, TAccountAuthorizationRulesProgram extends string = string, TAccountAuthorizationRules extends string = string> = {
    /** Update authority or delegate */
    authority: TransactionSigner<TAccountAuthority>;
    /** Delegate record PDA */
    delegateRecord?: Address<TAccountDelegateRecord>;
    /** Token account */
    token?: Address<TAccountToken>;
    /** Mint account */
    mint: Address<TAccountMint>;
    /** Metadata account */
    metadata: Address<TAccountMetadata>;
    /** Edition account */
    edition?: Address<TAccountEdition>;
    /** Payer */
    payer: TransactionSigner<TAccountPayer>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Instructions sysvar account */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    /** Token Authorization Rules Program */
    authorizationRulesProgram?: Address<TAccountAuthorizationRulesProgram>;
    /** Token Authorization Rules account */
    authorizationRules?: Address<TAccountAuthorizationRules>;
    updateArgs: UpdateInstructionDataArgs['updateArgs'];
};
export declare function getUpdateInstruction<TAccountAuthority extends string, TAccountDelegateRecord extends string, TAccountToken extends string, TAccountMint extends string, TAccountMetadata extends string, TAccountEdition extends string, TAccountPayer extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string, TAccountAuthorizationRulesProgram extends string, TAccountAuthorizationRules extends string>(input: UpdateInput<TAccountAuthority, TAccountDelegateRecord, TAccountToken, TAccountMint, TAccountMetadata, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions, TAccountAuthorizationRulesProgram, TAccountAuthorizationRules>): UpdateInstruction<typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountAuthority, TAccountDelegateRecord, TAccountToken, TAccountMint, TAccountMetadata, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions, TAccountAuthorizationRulesProgram, TAccountAuthorizationRules>;
export type ParsedUpdateInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Update authority or delegate */
        authority: TAccountMetas[0];
        /** Delegate record PDA */
        delegateRecord?: TAccountMetas[1] | undefined;
        /** Token account */
        token?: TAccountMetas[2] | undefined;
        /** Mint account */
        mint: TAccountMetas[3];
        /** Metadata account */
        metadata: TAccountMetas[4];
        /** Edition account */
        edition?: TAccountMetas[5] | undefined;
        /** Payer */
        payer: TAccountMetas[6];
        /** System program */
        systemProgram: TAccountMetas[7];
        /** Instructions sysvar account */
        sysvarInstructions: TAccountMetas[8];
        /** Token Authorization Rules Program */
        authorizationRulesProgram?: TAccountMetas[9] | undefined;
        /** Token Authorization Rules account */
        authorizationRules?: TAccountMetas[10] | undefined;
    };
    data: UpdateInstructionData;
};
export declare function parseUpdateInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedUpdateInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=update.d.ts.map