/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount } from '@solana/web3.js';
import { TOKEN_METADATA_PROGRAM_ADDRESS } from '../programs';
import { type UseArgs, type UseArgsArgs } from '../types';
export type UseInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountDelegateRecord extends string | IAccountMeta<string> = string, TAccountToken extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountEdition extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountSysvarInstructions extends string | IAccountMeta<string> = 'Sysvar1nstructions1111111111111111111111111', TAccountSplTokenProgram extends string | IAccountMeta<string> = string, TAccountAuthorizationRulesProgram extends string | IAccountMeta<string> = string, TAccountAuthorizationRules extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountDelegateRecord extends string ? WritableAccount<TAccountDelegateRecord> : TAccountDelegateRecord,
    TAccountToken extends string ? WritableAccount<TAccountToken> : TAccountToken,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountEdition extends string ? WritableAccount<TAccountEdition> : TAccountEdition,
    TAccountPayer extends string ? ReadonlySignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountSysvarInstructions extends string ? ReadonlyAccount<TAccountSysvarInstructions> : TAccountSysvarInstructions,
    TAccountSplTokenProgram extends string ? ReadonlyAccount<TAccountSplTokenProgram> : TAccountSplTokenProgram,
    TAccountAuthorizationRulesProgram extends string ? ReadonlyAccount<TAccountAuthorizationRulesProgram> : TAccountAuthorizationRulesProgram,
    TAccountAuthorizationRules extends string ? ReadonlyAccount<TAccountAuthorizationRules> : TAccountAuthorizationRules,
    ...TRemainingAccounts
]>;
export type UseInstructionData = {
    discriminator: number;
    useArgs: UseArgs;
};
export type UseInstructionDataArgs = {
    useArgs: UseArgsArgs;
};
export declare function getUseInstructionDataEncoder(): Encoder<UseInstructionDataArgs>;
export declare function getUseInstructionDataDecoder(): Decoder<UseInstructionData>;
export declare function getUseInstructionDataCodec(): Codec<UseInstructionDataArgs, UseInstructionData>;
export type UseInput<TAccountAuthority extends string = string, TAccountDelegateRecord extends string = string, TAccountToken extends string = string, TAccountMint extends string = string, TAccountMetadata extends string = string, TAccountEdition extends string = string, TAccountPayer extends string = string, TAccountSystemProgram extends string = string, TAccountSysvarInstructions extends string = string, TAccountSplTokenProgram extends string = string, TAccountAuthorizationRulesProgram extends string = string, TAccountAuthorizationRules extends string = string> = {
    /** Token owner or delegate */
    authority: TransactionSigner<TAccountAuthority>;
    /** Delegate record PDA */
    delegateRecord?: Address<TAccountDelegateRecord>;
    /** Token account */
    token?: Address<TAccountToken>;
    /** Mint account */
    mint: Address<TAccountMint>;
    /** Metadata account */
    metadata: Address<TAccountMetadata>;
    /** Edition account */
    edition?: Address<TAccountEdition>;
    /** Payer */
    payer: TransactionSigner<TAccountPayer>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** System program */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    /** SPL Token Program */
    splTokenProgram?: Address<TAccountSplTokenProgram>;
    /** Token Authorization Rules Program */
    authorizationRulesProgram?: Address<TAccountAuthorizationRulesProgram>;
    /** Token Authorization Rules account */
    authorizationRules?: Address<TAccountAuthorizationRules>;
    useArgs: UseInstructionDataArgs['useArgs'];
};
export declare function getUseInstruction<TAccountAuthority extends string, TAccountDelegateRecord extends string, TAccountToken extends string, TAccountMint extends string, TAccountMetadata extends string, TAccountEdition extends string, TAccountPayer extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string, TAccountSplTokenProgram extends string, TAccountAuthorizationRulesProgram extends string, TAccountAuthorizationRules extends string>(input: UseInput<TAccountAuthority, TAccountDelegateRecord, TAccountToken, TAccountMint, TAccountMetadata, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions, TAccountSplTokenProgram, TAccountAuthorizationRulesProgram, TAccountAuthorizationRules>): UseInstruction<typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountAuthority, TAccountDelegateRecord, TAccountToken, TAccountMint, TAccountMetadata, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions, TAccountSplTokenProgram, TAccountAuthorizationRulesProgram, TAccountAuthorizationRules>;
export type ParsedUseInstruction<TProgram extends string = typeof TOKEN_METADATA_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Token owner or delegate */
        authority: TAccountMetas[0];
        /** Delegate record PDA */
        delegateRecord?: TAccountMetas[1] | undefined;
        /** Token account */
        token?: TAccountMetas[2] | undefined;
        /** Mint account */
        mint: TAccountMetas[3];
        /** Metadata account */
        metadata: TAccountMetas[4];
        /** Edition account */
        edition?: TAccountMetas[5] | undefined;
        /** Payer */
        payer: TAccountMetas[6];
        /** System program */
        systemProgram: TAccountMetas[7];
        /** System program */
        sysvarInstructions: TAccountMetas[8];
        /** SPL Token Program */
        splTokenProgram?: TAccountMetas[9] | undefined;
        /** Token Authorization Rules Program */
        authorizationRulesProgram?: TAccountMetas[10] | undefined;
        /** Token Authorization Rules account */
        authorizationRules?: TAccountMetas[11] | undefined;
    };
    data: UseInstructionData;
};
export declare function parseUseInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedUseInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=use.d.ts.map