import { getEnumEncoder, getEnumDecoder, combineCodec, getStructEncoder, getStructDecoder, getDiscriminatedUnionEncoder, getU64Encoder, getDiscriminatedUnionDecoder, getU64Decoder, getBooleanEncoder, getAddressEncoder, getBooleanDecoder, getAddressDecoder, getArrayEncoder, getU8Encoder, getArrayDecoder, getU8Decoder, getUnitEncoder, getTupleEncoder, getUnitDecoder, getTupleDecoder, addEncoderSizePrefix, getUtf8Encoder, getU32Encoder, getU16Encoder, getOptionEncoder, addDecoderSizePrefix, getUtf8Decoder, getU32Decoder, getU16Decoder, getOptionDecoder, getMapEncoder, getMapDecoder, fixEncoderSize, getBytesEncoder, fixDecoderSize, getBytesDecoder, decodeAccount, assertAccountExists, fetchEncodedAccount, assertAccountsExist, fetchEncodedAccounts, getProgramDerivedAddress, containsBytes, isProgramError, transformEncoder, pipe, appendTransactionMessageInstruction, generateKeyPairSigner, some, none, createTransactionMessage, setTransactionMessageFeePayerSigner, setTransactionMessageLifetimeUsingBlockhash, AccountRole, upgradeRoleToSigner, isTransactionSigner as isTransactionSigner$1 } from '@solana/web3.js';
import { findAssociatedTokenPda, getMintToInstruction } from '@solana-program/token';
import { createDefaultTransaction, signAndSendTransaction, createMint, createAta, MPL_TOKEN_METADATA_PROGRAM_ID, TOKEN_PROGRAM_ID, ASSOCIATED_TOKEN_ACCOUNTS_PROGRAM_ID } from '@tensor-foundation/test-helpers';

// src/generated/accounts/collectionAuthorityRecord.ts
var AuthorityType = /* @__PURE__ */ ((AuthorityType2) => {
  AuthorityType2[AuthorityType2["None"] = 0] = "None";
  AuthorityType2[AuthorityType2["Metadata"] = 1] = "Metadata";
  AuthorityType2[AuthorityType2["Holder"] = 2] = "Holder";
  AuthorityType2[AuthorityType2["MetadataDelegate"] = 3] = "MetadataDelegate";
  AuthorityType2[AuthorityType2["TokenDelegate"] = 4] = "TokenDelegate";
  return AuthorityType2;
})(AuthorityType || {});
function getAuthorityTypeEncoder() {
  return getEnumEncoder(AuthorityType);
}
function getAuthorityTypeDecoder() {
  return getEnumDecoder(AuthorityType);
}
function getAuthorityTypeCodec() {
  return combineCodec(getAuthorityTypeEncoder(), getAuthorityTypeDecoder());
}
function getAuthorizationDataEncoder() {
  return getStructEncoder([["payload", getPayloadEncoder()]]);
}
function getAuthorizationDataDecoder() {
  return getStructDecoder([["payload", getPayloadDecoder()]]);
}
function getAuthorizationDataCodec() {
  return combineCodec(
    getAuthorizationDataEncoder(),
    getAuthorizationDataDecoder()
  );
}
function getBurnArgsEncoder() {
  return getDiscriminatedUnionEncoder([
    ["V1", getStructEncoder([["amount", getU64Encoder()]])]
  ]);
}
function getBurnArgsDecoder() {
  return getDiscriminatedUnionDecoder([
    ["V1", getStructDecoder([["amount", getU64Decoder()]])]
  ]);
}
function getBurnArgsCodec() {
  return combineCodec(getBurnArgsEncoder(), getBurnArgsDecoder());
}
function burnArgs(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isBurnArgs(kind, value) {
  return value.__kind === kind;
}
function getCollectionEncoder() {
  return getStructEncoder([
    ["verified", getBooleanEncoder()],
    ["key", getAddressEncoder()]
  ]);
}
function getCollectionDecoder() {
  return getStructDecoder([
    ["verified", getBooleanDecoder()],
    ["key", getAddressDecoder()]
  ]);
}
function getCollectionCodec() {
  return combineCodec(getCollectionEncoder(), getCollectionDecoder());
}
function getCollectionDetailsEncoder() {
  return getDiscriminatedUnionEncoder([
    ["V1", getStructEncoder([["size", getU64Encoder()]])],
    [
      "V2",
      getStructEncoder([
        ["padding", getArrayEncoder(getU8Encoder(), { size: 8 })]
      ])
    ]
  ]);
}
function getCollectionDetailsDecoder() {
  return getDiscriminatedUnionDecoder([
    ["V1", getStructDecoder([["size", getU64Decoder()]])],
    [
      "V2",
      getStructDecoder([
        ["padding", getArrayDecoder(getU8Decoder(), { size: 8 })]
      ])
    ]
  ]);
}
function getCollectionDetailsCodec() {
  return combineCodec(
    getCollectionDetailsEncoder(),
    getCollectionDetailsDecoder()
  );
}
function collectionDetails(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isCollectionDetails(kind, value) {
  return value.__kind === kind;
}
function getCollectionDetailsToggleEncoder() {
  return getDiscriminatedUnionEncoder([
    ["None", getUnitEncoder()],
    ["Clear", getUnitEncoder()],
    [
      "Set",
      getStructEncoder([
        ["fields", getTupleEncoder([getCollectionDetailsEncoder()])]
      ])
    ]
  ]);
}
function getCollectionDetailsToggleDecoder() {
  return getDiscriminatedUnionDecoder([
    ["None", getUnitDecoder()],
    ["Clear", getUnitDecoder()],
    [
      "Set",
      getStructDecoder([
        ["fields", getTupleDecoder([getCollectionDetailsDecoder()])]
      ])
    ]
  ]);
}
function getCollectionDetailsToggleCodec() {
  return combineCodec(
    getCollectionDetailsToggleEncoder(),
    getCollectionDetailsToggleDecoder()
  );
}
function collectionDetailsToggle(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isCollectionDetailsToggle(kind, value) {
  return value.__kind === kind;
}
function getCollectionToggleEncoder() {
  return getDiscriminatedUnionEncoder([
    ["None", getUnitEncoder()],
    ["Clear", getUnitEncoder()],
    [
      "Set",
      getStructEncoder([["fields", getTupleEncoder([getCollectionEncoder()])]])
    ]
  ]);
}
function getCollectionToggleDecoder() {
  return getDiscriminatedUnionDecoder([
    ["None", getUnitDecoder()],
    ["Clear", getUnitDecoder()],
    [
      "Set",
      getStructDecoder([["fields", getTupleDecoder([getCollectionDecoder()])]])
    ]
  ]);
}
function getCollectionToggleCodec() {
  return combineCodec(
    getCollectionToggleEncoder(),
    getCollectionToggleDecoder()
  );
}
function collectionToggle(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isCollectionToggle(kind, value) {
  return value.__kind === kind;
}
function getCreateArgsEncoder() {
  return getDiscriminatedUnionEncoder([
    [
      "V1",
      getStructEncoder([
        ["name", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
        ["symbol", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
        ["uri", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
        ["sellerFeeBasisPoints", getU16Encoder()],
        ["creators", getOptionEncoder(getArrayEncoder(getCreatorEncoder()))],
        ["primarySaleHappened", getBooleanEncoder()],
        ["isMutable", getBooleanEncoder()],
        ["tokenStandard", getTokenStandardEncoder()],
        ["collection", getOptionEncoder(getCollectionEncoder())],
        ["uses", getOptionEncoder(getUsesEncoder())],
        ["collectionDetails", getOptionEncoder(getCollectionDetailsEncoder())],
        ["ruleSet", getOptionEncoder(getAddressEncoder())],
        ["decimals", getOptionEncoder(getU8Encoder())],
        ["printSupply", getOptionEncoder(getPrintSupplyEncoder())]
      ])
    ]
  ]);
}
function getCreateArgsDecoder() {
  return getDiscriminatedUnionDecoder([
    [
      "V1",
      getStructDecoder([
        ["name", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
        ["symbol", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
        ["uri", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
        ["sellerFeeBasisPoints", getU16Decoder()],
        ["creators", getOptionDecoder(getArrayDecoder(getCreatorDecoder()))],
        ["primarySaleHappened", getBooleanDecoder()],
        ["isMutable", getBooleanDecoder()],
        ["tokenStandard", getTokenStandardDecoder()],
        ["collection", getOptionDecoder(getCollectionDecoder())],
        ["uses", getOptionDecoder(getUsesDecoder())],
        ["collectionDetails", getOptionDecoder(getCollectionDetailsDecoder())],
        ["ruleSet", getOptionDecoder(getAddressDecoder())],
        ["decimals", getOptionDecoder(getU8Decoder())],
        ["printSupply", getOptionDecoder(getPrintSupplyDecoder())]
      ])
    ]
  ]);
}
function getCreateArgsCodec() {
  return combineCodec(getCreateArgsEncoder(), getCreateArgsDecoder());
}
function createArgs(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isCreateArgs(kind, value) {
  return value.__kind === kind;
}
function getCreatorEncoder() {
  return getStructEncoder([
    ["address", getAddressEncoder()],
    ["verified", getBooleanEncoder()],
    ["share", getU8Encoder()]
  ]);
}
function getCreatorDecoder() {
  return getStructDecoder([
    ["address", getAddressDecoder()],
    ["verified", getBooleanDecoder()],
    ["share", getU8Decoder()]
  ]);
}
function getCreatorCodec() {
  return combineCodec(getCreatorEncoder(), getCreatorDecoder());
}
function getDataEncoder() {
  return getStructEncoder([
    ["name", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
    ["symbol", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
    ["uri", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
    ["sellerFeeBasisPoints", getU16Encoder()],
    ["creators", getOptionEncoder(getArrayEncoder(getCreatorEncoder()))]
  ]);
}
function getDataDecoder() {
  return getStructDecoder([
    ["name", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["symbol", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["uri", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["sellerFeeBasisPoints", getU16Decoder()],
    ["creators", getOptionDecoder(getArrayDecoder(getCreatorDecoder()))]
  ]);
}
function getDataCodec() {
  return combineCodec(getDataEncoder(), getDataDecoder());
}
function getDataV2Encoder() {
  return getStructEncoder([
    ["name", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
    ["symbol", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
    ["uri", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
    ["sellerFeeBasisPoints", getU16Encoder()],
    ["creators", getOptionEncoder(getArrayEncoder(getCreatorEncoder()))],
    ["collection", getOptionEncoder(getCollectionEncoder())],
    ["uses", getOptionEncoder(getUsesEncoder())]
  ]);
}
function getDataV2Decoder() {
  return getStructDecoder([
    ["name", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["symbol", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["uri", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["sellerFeeBasisPoints", getU16Decoder()],
    ["creators", getOptionDecoder(getArrayDecoder(getCreatorDecoder()))],
    ["collection", getOptionDecoder(getCollectionDecoder())],
    ["uses", getOptionDecoder(getUsesDecoder())]
  ]);
}
function getDataV2Codec() {
  return combineCodec(getDataV2Encoder(), getDataV2Decoder());
}
function getDelegateArgsEncoder() {
  return getDiscriminatedUnionEncoder([
    [
      "CollectionV1",
      getStructEncoder([
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ],
    [
      "SaleV1",
      getStructEncoder([
        ["amount", getU64Encoder()],
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ],
    [
      "TransferV1",
      getStructEncoder([
        ["amount", getU64Encoder()],
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ],
    [
      "DataV1",
      getStructEncoder([
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ],
    [
      "UtilityV1",
      getStructEncoder([
        ["amount", getU64Encoder()],
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ],
    [
      "StakingV1",
      getStructEncoder([
        ["amount", getU64Encoder()],
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ],
    ["StandardV1", getStructEncoder([["amount", getU64Encoder()]])],
    [
      "LockedTransferV1",
      getStructEncoder([
        ["amount", getU64Encoder()],
        ["lockedAddress", getAddressEncoder()],
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ],
    [
      "ProgrammableConfigV1",
      getStructEncoder([
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ],
    [
      "AuthorityItemV1",
      getStructEncoder([
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ],
    [
      "DataItemV1",
      getStructEncoder([
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ],
    [
      "CollectionItemV1",
      getStructEncoder([
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ],
    [
      "ProgrammableConfigItemV1",
      getStructEncoder([
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ],
    [
      "PrintDelegateV1",
      getStructEncoder([
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ]
  ]);
}
function getDelegateArgsDecoder() {
  return getDiscriminatedUnionDecoder([
    [
      "CollectionV1",
      getStructDecoder([
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ],
    [
      "SaleV1",
      getStructDecoder([
        ["amount", getU64Decoder()],
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ],
    [
      "TransferV1",
      getStructDecoder([
        ["amount", getU64Decoder()],
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ],
    [
      "DataV1",
      getStructDecoder([
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ],
    [
      "UtilityV1",
      getStructDecoder([
        ["amount", getU64Decoder()],
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ],
    [
      "StakingV1",
      getStructDecoder([
        ["amount", getU64Decoder()],
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ],
    ["StandardV1", getStructDecoder([["amount", getU64Decoder()]])],
    [
      "LockedTransferV1",
      getStructDecoder([
        ["amount", getU64Decoder()],
        ["lockedAddress", getAddressDecoder()],
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ],
    [
      "ProgrammableConfigV1",
      getStructDecoder([
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ],
    [
      "AuthorityItemV1",
      getStructDecoder([
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ],
    [
      "DataItemV1",
      getStructDecoder([
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ],
    [
      "CollectionItemV1",
      getStructDecoder([
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ],
    [
      "ProgrammableConfigItemV1",
      getStructDecoder([
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ],
    [
      "PrintDelegateV1",
      getStructDecoder([
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ]
  ]);
}
function getDelegateArgsCodec() {
  return combineCodec(getDelegateArgsEncoder(), getDelegateArgsDecoder());
}
function delegateArgs(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isDelegateArgs(kind, value) {
  return value.__kind === kind;
}
function getEscrowAuthorityEncoder() {
  return getDiscriminatedUnionEncoder([
    ["TokenOwner", getUnitEncoder()],
    [
      "Creator",
      getStructEncoder([["fields", getTupleEncoder([getAddressEncoder()])]])
    ]
  ]);
}
function getEscrowAuthorityDecoder() {
  return getDiscriminatedUnionDecoder([
    ["TokenOwner", getUnitDecoder()],
    [
      "Creator",
      getStructDecoder([["fields", getTupleDecoder([getAddressDecoder()])]])
    ]
  ]);
}
function getEscrowAuthorityCodec() {
  return combineCodec(getEscrowAuthorityEncoder(), getEscrowAuthorityDecoder());
}
function escrowAuthority(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isEscrowAuthority(kind, value) {
  return value.__kind === kind;
}
var HolderDelegateRole = /* @__PURE__ */ ((HolderDelegateRole2) => {
  HolderDelegateRole2[HolderDelegateRole2["PrintDelegate"] = 0] = "PrintDelegate";
  return HolderDelegateRole2;
})(HolderDelegateRole || {});
function getHolderDelegateRoleEncoder() {
  return getEnumEncoder(HolderDelegateRole);
}
function getHolderDelegateRoleDecoder() {
  return getEnumDecoder(HolderDelegateRole);
}
function getHolderDelegateRoleCodec() {
  return combineCodec(
    getHolderDelegateRoleEncoder(),
    getHolderDelegateRoleDecoder()
  );
}
var Key = /* @__PURE__ */ ((Key2) => {
  Key2[Key2["Uninitialized"] = 0] = "Uninitialized";
  Key2[Key2["EditionV1"] = 1] = "EditionV1";
  Key2[Key2["MasterEditionV1"] = 2] = "MasterEditionV1";
  Key2[Key2["ReservationListV1"] = 3] = "ReservationListV1";
  Key2[Key2["MetadataV1"] = 4] = "MetadataV1";
  Key2[Key2["ReservationListV2"] = 5] = "ReservationListV2";
  Key2[Key2["MasterEditionV2"] = 6] = "MasterEditionV2";
  Key2[Key2["EditionMarker"] = 7] = "EditionMarker";
  Key2[Key2["UseAuthorityRecord"] = 8] = "UseAuthorityRecord";
  Key2[Key2["CollectionAuthorityRecord"] = 9] = "CollectionAuthorityRecord";
  Key2[Key2["TokenOwnedEscrow"] = 10] = "TokenOwnedEscrow";
  Key2[Key2["TokenRecord"] = 11] = "TokenRecord";
  Key2[Key2["MetadataDelegate"] = 12] = "MetadataDelegate";
  Key2[Key2["EditionMarkerV2"] = 13] = "EditionMarkerV2";
  Key2[Key2["HolderDelegate"] = 14] = "HolderDelegate";
  return Key2;
})(Key || {});
function getKeyEncoder() {
  return getEnumEncoder(Key);
}
function getKeyDecoder() {
  return getEnumDecoder(Key);
}
function getKeyCodec() {
  return combineCodec(getKeyEncoder(), getKeyDecoder());
}
function getLockArgsEncoder() {
  return getDiscriminatedUnionEncoder([
    [
      "V1",
      getStructEncoder([
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ]
  ]);
}
function getLockArgsDecoder() {
  return getDiscriminatedUnionDecoder([
    [
      "V1",
      getStructDecoder([
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ]
  ]);
}
function getLockArgsCodec() {
  return combineCodec(getLockArgsEncoder(), getLockArgsDecoder());
}
function lockArgs(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isLockArgs(kind, value) {
  return value.__kind === kind;
}
var MetadataDelegateRole = /* @__PURE__ */ ((MetadataDelegateRole2) => {
  MetadataDelegateRole2[MetadataDelegateRole2["AuthorityItem"] = 0] = "AuthorityItem";
  MetadataDelegateRole2[MetadataDelegateRole2["Collection"] = 1] = "Collection";
  MetadataDelegateRole2[MetadataDelegateRole2["Use"] = 2] = "Use";
  MetadataDelegateRole2[MetadataDelegateRole2["Data"] = 3] = "Data";
  MetadataDelegateRole2[MetadataDelegateRole2["ProgrammableConfig"] = 4] = "ProgrammableConfig";
  MetadataDelegateRole2[MetadataDelegateRole2["DataItem"] = 5] = "DataItem";
  MetadataDelegateRole2[MetadataDelegateRole2["CollectionItem"] = 6] = "CollectionItem";
  MetadataDelegateRole2[MetadataDelegateRole2["ProgrammableConfigItem"] = 7] = "ProgrammableConfigItem";
  return MetadataDelegateRole2;
})(MetadataDelegateRole || {});
function getMetadataDelegateRoleEncoder() {
  return getEnumEncoder(MetadataDelegateRole);
}
function getMetadataDelegateRoleDecoder() {
  return getEnumDecoder(MetadataDelegateRole);
}
function getMetadataDelegateRoleCodec() {
  return combineCodec(
    getMetadataDelegateRoleEncoder(),
    getMetadataDelegateRoleDecoder()
  );
}
var MigrationType = /* @__PURE__ */ ((MigrationType2) => {
  MigrationType2[MigrationType2["CollectionV1"] = 0] = "CollectionV1";
  MigrationType2[MigrationType2["ProgrammableV1"] = 1] = "ProgrammableV1";
  return MigrationType2;
})(MigrationType || {});
function getMigrationTypeEncoder() {
  return getEnumEncoder(MigrationType);
}
function getMigrationTypeDecoder() {
  return getEnumDecoder(MigrationType);
}
function getMigrationTypeCodec() {
  return combineCodec(getMigrationTypeEncoder(), getMigrationTypeDecoder());
}
function getMintArgsEncoder() {
  return getDiscriminatedUnionEncoder([
    [
      "V1",
      getStructEncoder([
        ["amount", getU64Encoder()],
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ]
  ]);
}
function getMintArgsDecoder() {
  return getDiscriminatedUnionDecoder([
    [
      "V1",
      getStructDecoder([
        ["amount", getU64Decoder()],
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ]
  ]);
}
function getMintArgsCodec() {
  return combineCodec(getMintArgsEncoder(), getMintArgsDecoder());
}
function mintArgs(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isMintArgs(kind, value) {
  return value.__kind === kind;
}
function getMintNewEditionFromMasterEditionViaTokenArgsEncoder() {
  return getStructEncoder([["edition", getU64Encoder()]]);
}
function getMintNewEditionFromMasterEditionViaTokenArgsDecoder() {
  return getStructDecoder([["edition", getU64Decoder()]]);
}
function getMintNewEditionFromMasterEditionViaTokenArgsCodec() {
  return combineCodec(
    getMintNewEditionFromMasterEditionViaTokenArgsEncoder(),
    getMintNewEditionFromMasterEditionViaTokenArgsDecoder()
  );
}
function getPayloadEncoder() {
  return getStructEncoder([
    [
      "map",
      getMapEncoder(
        addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder()),
        getPayloadTypeEncoder()
      )
    ]
  ]);
}
function getPayloadDecoder() {
  return getStructDecoder([
    [
      "map",
      getMapDecoder(
        addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder()),
        getPayloadTypeDecoder()
      )
    ]
  ]);
}
function getPayloadCodec() {
  return combineCodec(getPayloadEncoder(), getPayloadDecoder());
}
var PayloadKey = /* @__PURE__ */ ((PayloadKey2) => {
  PayloadKey2[PayloadKey2["Amount"] = 0] = "Amount";
  PayloadKey2[PayloadKey2["Authority"] = 1] = "Authority";
  PayloadKey2[PayloadKey2["AuthoritySeeds"] = 2] = "AuthoritySeeds";
  PayloadKey2[PayloadKey2["Delegate"] = 3] = "Delegate";
  PayloadKey2[PayloadKey2["DelegateSeeds"] = 4] = "DelegateSeeds";
  PayloadKey2[PayloadKey2["Destination"] = 5] = "Destination";
  PayloadKey2[PayloadKey2["DestinationSeeds"] = 6] = "DestinationSeeds";
  PayloadKey2[PayloadKey2["Holder"] = 7] = "Holder";
  PayloadKey2[PayloadKey2["Source"] = 8] = "Source";
  PayloadKey2[PayloadKey2["SourceSeeds"] = 9] = "SourceSeeds";
  return PayloadKey2;
})(PayloadKey || {});
function getPayloadKeyEncoder() {
  return getEnumEncoder(PayloadKey);
}
function getPayloadKeyDecoder() {
  return getEnumDecoder(PayloadKey);
}
function getPayloadKeyCodec() {
  return combineCodec(getPayloadKeyEncoder(), getPayloadKeyDecoder());
}
function getPayloadTypeEncoder() {
  return getDiscriminatedUnionEncoder([
    [
      "Pubkey",
      getStructEncoder([["fields", getTupleEncoder([getAddressEncoder()])]])
    ],
    [
      "Seeds",
      getStructEncoder([["fields", getTupleEncoder([getSeedsVecEncoder()])]])
    ],
    [
      "MerkleProof",
      getStructEncoder([["fields", getTupleEncoder([getProofInfoEncoder()])]])
    ],
    [
      "Number",
      getStructEncoder([["fields", getTupleEncoder([getU64Encoder()])]])
    ]
  ]);
}
function getPayloadTypeDecoder() {
  return getDiscriminatedUnionDecoder([
    [
      "Pubkey",
      getStructDecoder([["fields", getTupleDecoder([getAddressDecoder()])]])
    ],
    [
      "Seeds",
      getStructDecoder([["fields", getTupleDecoder([getSeedsVecDecoder()])]])
    ],
    [
      "MerkleProof",
      getStructDecoder([["fields", getTupleDecoder([getProofInfoDecoder()])]])
    ],
    [
      "Number",
      getStructDecoder([["fields", getTupleDecoder([getU64Decoder()])]])
    ]
  ]);
}
function getPayloadTypeCodec() {
  return combineCodec(getPayloadTypeEncoder(), getPayloadTypeDecoder());
}
function payloadType(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isPayloadType(kind, value) {
  return value.__kind === kind;
}
function getPrintArgsEncoder() {
  return getDiscriminatedUnionEncoder([
    ["V1", getStructEncoder([["edition", getU64Encoder()]])],
    ["V2", getStructEncoder([["edition", getU64Encoder()]])]
  ]);
}
function getPrintArgsDecoder() {
  return getDiscriminatedUnionDecoder([
    ["V1", getStructDecoder([["edition", getU64Decoder()]])],
    ["V2", getStructDecoder([["edition", getU64Decoder()]])]
  ]);
}
function getPrintArgsCodec() {
  return combineCodec(getPrintArgsEncoder(), getPrintArgsDecoder());
}
function printArgs(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isPrintArgs(kind, value) {
  return value.__kind === kind;
}
function getPrintSupplyEncoder() {
  return getDiscriminatedUnionEncoder([
    ["Zero", getUnitEncoder()],
    [
      "Limited",
      getStructEncoder([["fields", getTupleEncoder([getU64Encoder()])]])
    ],
    ["Unlimited", getUnitEncoder()]
  ]);
}
function getPrintSupplyDecoder() {
  return getDiscriminatedUnionDecoder([
    ["Zero", getUnitDecoder()],
    [
      "Limited",
      getStructDecoder([["fields", getTupleDecoder([getU64Decoder()])]])
    ],
    ["Unlimited", getUnitDecoder()]
  ]);
}
function getPrintSupplyCodec() {
  return combineCodec(getPrintSupplyEncoder(), getPrintSupplyDecoder());
}
function printSupply(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isPrintSupply(kind, value) {
  return value.__kind === kind;
}
function getProgrammableConfigEncoder() {
  return getDiscriminatedUnionEncoder([
    [
      "V1",
      getStructEncoder([["ruleSet", getOptionEncoder(getAddressEncoder())]])
    ]
  ]);
}
function getProgrammableConfigDecoder() {
  return getDiscriminatedUnionDecoder([
    [
      "V1",
      getStructDecoder([["ruleSet", getOptionDecoder(getAddressDecoder())]])
    ]
  ]);
}
function getProgrammableConfigCodec() {
  return combineCodec(
    getProgrammableConfigEncoder(),
    getProgrammableConfigDecoder()
  );
}
function programmableConfig(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isProgrammableConfig(kind, value) {
  return value.__kind === kind;
}
function getProofInfoEncoder() {
  return getStructEncoder([
    ["proof", getArrayEncoder(fixEncoderSize(getBytesEncoder(), 32))]
  ]);
}
function getProofInfoDecoder() {
  return getStructDecoder([
    ["proof", getArrayDecoder(fixDecoderSize(getBytesDecoder(), 32))]
  ]);
}
function getProofInfoCodec() {
  return combineCodec(getProofInfoEncoder(), getProofInfoDecoder());
}
function getReservationEncoder() {
  return getStructEncoder([
    ["address", getAddressEncoder()],
    ["spotsRemaining", getU64Encoder()],
    ["totalSpots", getU64Encoder()]
  ]);
}
function getReservationDecoder() {
  return getStructDecoder([
    ["address", getAddressDecoder()],
    ["spotsRemaining", getU64Decoder()],
    ["totalSpots", getU64Decoder()]
  ]);
}
function getReservationCodec() {
  return combineCodec(getReservationEncoder(), getReservationDecoder());
}
function getReservationV1Encoder() {
  return getStructEncoder([
    ["address", getAddressEncoder()],
    ["spotsRemaining", getU8Encoder()],
    ["totalSpots", getU8Encoder()]
  ]);
}
function getReservationV1Decoder() {
  return getStructDecoder([
    ["address", getAddressDecoder()],
    ["spotsRemaining", getU8Decoder()],
    ["totalSpots", getU8Decoder()]
  ]);
}
function getReservationV1Codec() {
  return combineCodec(getReservationV1Encoder(), getReservationV1Decoder());
}
var RevokeArgs = /* @__PURE__ */ ((RevokeArgs2) => {
  RevokeArgs2[RevokeArgs2["CollectionV1"] = 0] = "CollectionV1";
  RevokeArgs2[RevokeArgs2["SaleV1"] = 1] = "SaleV1";
  RevokeArgs2[RevokeArgs2["TransferV1"] = 2] = "TransferV1";
  RevokeArgs2[RevokeArgs2["DataV1"] = 3] = "DataV1";
  RevokeArgs2[RevokeArgs2["UtilityV1"] = 4] = "UtilityV1";
  RevokeArgs2[RevokeArgs2["StakingV1"] = 5] = "StakingV1";
  RevokeArgs2[RevokeArgs2["StandardV1"] = 6] = "StandardV1";
  RevokeArgs2[RevokeArgs2["LockedTransferV1"] = 7] = "LockedTransferV1";
  RevokeArgs2[RevokeArgs2["ProgrammableConfigV1"] = 8] = "ProgrammableConfigV1";
  RevokeArgs2[RevokeArgs2["MigrationV1"] = 9] = "MigrationV1";
  RevokeArgs2[RevokeArgs2["AuthorityItemV1"] = 10] = "AuthorityItemV1";
  RevokeArgs2[RevokeArgs2["DataItemV1"] = 11] = "DataItemV1";
  RevokeArgs2[RevokeArgs2["CollectionItemV1"] = 12] = "CollectionItemV1";
  RevokeArgs2[RevokeArgs2["ProgrammableConfigItemV1"] = 13] = "ProgrammableConfigItemV1";
  RevokeArgs2[RevokeArgs2["PrintDelegateV1"] = 14] = "PrintDelegateV1";
  return RevokeArgs2;
})(RevokeArgs || {});
function getRevokeArgsEncoder() {
  return getEnumEncoder(RevokeArgs);
}
function getRevokeArgsDecoder() {
  return getEnumDecoder(RevokeArgs);
}
function getRevokeArgsCodec() {
  return combineCodec(getRevokeArgsEncoder(), getRevokeArgsDecoder());
}
function getRuleSetToggleEncoder() {
  return getDiscriminatedUnionEncoder([
    ["None", getUnitEncoder()],
    ["Clear", getUnitEncoder()],
    [
      "Set",
      getStructEncoder([["fields", getTupleEncoder([getAddressEncoder()])]])
    ]
  ]);
}
function getRuleSetToggleDecoder() {
  return getDiscriminatedUnionDecoder([
    ["None", getUnitDecoder()],
    ["Clear", getUnitDecoder()],
    [
      "Set",
      getStructDecoder([["fields", getTupleDecoder([getAddressDecoder()])]])
    ]
  ]);
}
function getRuleSetToggleCodec() {
  return combineCodec(getRuleSetToggleEncoder(), getRuleSetToggleDecoder());
}
function ruleSetToggle(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isRuleSetToggle(kind, value) {
  return value.__kind === kind;
}
function getSeedsVecEncoder() {
  return getStructEncoder([
    [
      "seeds",
      getArrayEncoder(addEncoderSizePrefix(getBytesEncoder(), getU32Encoder()))
    ]
  ]);
}
function getSeedsVecDecoder() {
  return getStructDecoder([
    [
      "seeds",
      getArrayDecoder(addDecoderSizePrefix(getBytesDecoder(), getU32Decoder()))
    ]
  ]);
}
function getSeedsVecCodec() {
  return combineCodec(getSeedsVecEncoder(), getSeedsVecDecoder());
}
function getSetCollectionSizeArgsEncoder() {
  return getStructEncoder([["size", getU64Encoder()]]);
}
function getSetCollectionSizeArgsDecoder() {
  return getStructDecoder([["size", getU64Decoder()]]);
}
function getSetCollectionSizeArgsCodec() {
  return combineCodec(
    getSetCollectionSizeArgsEncoder(),
    getSetCollectionSizeArgsDecoder()
  );
}
var TokenDelegateRole = /* @__PURE__ */ ((TokenDelegateRole2) => {
  TokenDelegateRole2[TokenDelegateRole2["Sale"] = 0] = "Sale";
  TokenDelegateRole2[TokenDelegateRole2["Transfer"] = 1] = "Transfer";
  TokenDelegateRole2[TokenDelegateRole2["Utility"] = 2] = "Utility";
  TokenDelegateRole2[TokenDelegateRole2["Staking"] = 3] = "Staking";
  TokenDelegateRole2[TokenDelegateRole2["Standard"] = 4] = "Standard";
  TokenDelegateRole2[TokenDelegateRole2["LockedTransfer"] = 5] = "LockedTransfer";
  TokenDelegateRole2[TokenDelegateRole2["Migration"] = 6] = "Migration";
  return TokenDelegateRole2;
})(TokenDelegateRole || {});
function getTokenDelegateRoleEncoder() {
  return getEnumEncoder(TokenDelegateRole);
}
function getTokenDelegateRoleDecoder() {
  return getEnumDecoder(TokenDelegateRole);
}
function getTokenDelegateRoleCodec() {
  return combineCodec(
    getTokenDelegateRoleEncoder(),
    getTokenDelegateRoleDecoder()
  );
}
var TokenStandard = /* @__PURE__ */ ((TokenStandard2) => {
  TokenStandard2[TokenStandard2["NonFungible"] = 0] = "NonFungible";
  TokenStandard2[TokenStandard2["FungibleAsset"] = 1] = "FungibleAsset";
  TokenStandard2[TokenStandard2["Fungible"] = 2] = "Fungible";
  TokenStandard2[TokenStandard2["NonFungibleEdition"] = 3] = "NonFungibleEdition";
  TokenStandard2[TokenStandard2["ProgrammableNonFungible"] = 4] = "ProgrammableNonFungible";
  TokenStandard2[TokenStandard2["ProgrammableNonFungibleEdition"] = 5] = "ProgrammableNonFungibleEdition";
  return TokenStandard2;
})(TokenStandard || {});
function getTokenStandardEncoder() {
  return getEnumEncoder(TokenStandard);
}
function getTokenStandardDecoder() {
  return getEnumDecoder(TokenStandard);
}
function getTokenStandardCodec() {
  return combineCodec(getTokenStandardEncoder(), getTokenStandardDecoder());
}
var TokenState = /* @__PURE__ */ ((TokenState2) => {
  TokenState2[TokenState2["Unlocked"] = 0] = "Unlocked";
  TokenState2[TokenState2["Locked"] = 1] = "Locked";
  TokenState2[TokenState2["Listed"] = 2] = "Listed";
  return TokenState2;
})(TokenState || {});
function getTokenStateEncoder() {
  return getEnumEncoder(TokenState);
}
function getTokenStateDecoder() {
  return getEnumDecoder(TokenState);
}
function getTokenStateCodec() {
  return combineCodec(getTokenStateEncoder(), getTokenStateDecoder());
}
function getTransferArgsEncoder() {
  return getDiscriminatedUnionEncoder([
    [
      "V1",
      getStructEncoder([
        ["amount", getU64Encoder()],
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ]
  ]);
}
function getTransferArgsDecoder() {
  return getDiscriminatedUnionDecoder([
    [
      "V1",
      getStructDecoder([
        ["amount", getU64Decoder()],
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ]
  ]);
}
function getTransferArgsCodec() {
  return combineCodec(getTransferArgsEncoder(), getTransferArgsDecoder());
}
function transferArgs(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isTransferArgs(kind, value) {
  return value.__kind === kind;
}
function getUnlockArgsEncoder() {
  return getDiscriminatedUnionEncoder([
    [
      "V1",
      getStructEncoder([
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ]
  ]);
}
function getUnlockArgsDecoder() {
  return getDiscriminatedUnionDecoder([
    [
      "V1",
      getStructDecoder([
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ]
  ]);
}
function getUnlockArgsCodec() {
  return combineCodec(getUnlockArgsEncoder(), getUnlockArgsDecoder());
}
function unlockArgs(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isUnlockArgs(kind, value) {
  return value.__kind === kind;
}
function getUpdateArgsEncoder() {
  return getDiscriminatedUnionEncoder([
    [
      "V1",
      getStructEncoder([
        ["newUpdateAuthority", getOptionEncoder(getAddressEncoder())],
        ["data", getOptionEncoder(getDataEncoder())],
        ["primarySaleHappened", getOptionEncoder(getBooleanEncoder())],
        ["isMutable", getOptionEncoder(getBooleanEncoder())],
        ["collection", getCollectionToggleEncoder()],
        ["collectionDetails", getCollectionDetailsToggleEncoder()],
        ["uses", getUsesToggleEncoder()],
        ["ruleSet", getRuleSetToggleEncoder()],
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ],
    [
      "AsUpdateAuthorityV2",
      getStructEncoder([
        ["newUpdateAuthority", getOptionEncoder(getAddressEncoder())],
        ["data", getOptionEncoder(getDataEncoder())],
        ["primarySaleHappened", getOptionEncoder(getBooleanEncoder())],
        ["isMutable", getOptionEncoder(getBooleanEncoder())],
        ["collection", getCollectionToggleEncoder()],
        ["collectionDetails", getCollectionDetailsToggleEncoder()],
        ["uses", getUsesToggleEncoder()],
        ["ruleSet", getRuleSetToggleEncoder()],
        ["tokenStandard", getOptionEncoder(getTokenStandardEncoder())],
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ],
    [
      "AsAuthorityItemDelegateV2",
      getStructEncoder([
        ["newUpdateAuthority", getOptionEncoder(getAddressEncoder())],
        ["primarySaleHappened", getOptionEncoder(getBooleanEncoder())],
        ["isMutable", getOptionEncoder(getBooleanEncoder())],
        ["tokenStandard", getOptionEncoder(getTokenStandardEncoder())],
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ],
    [
      "AsCollectionDelegateV2",
      getStructEncoder([
        ["collection", getCollectionToggleEncoder()],
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ],
    [
      "AsDataDelegateV2",
      getStructEncoder([
        ["data", getOptionEncoder(getDataEncoder())],
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ],
    [
      "AsProgrammableConfigDelegateV2",
      getStructEncoder([
        ["ruleSet", getRuleSetToggleEncoder()],
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ],
    [
      "AsDataItemDelegateV2",
      getStructEncoder([
        ["data", getOptionEncoder(getDataEncoder())],
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ],
    [
      "AsCollectionItemDelegateV2",
      getStructEncoder([
        ["collection", getCollectionToggleEncoder()],
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ],
    [
      "AsProgrammableConfigItemDelegateV2",
      getStructEncoder([
        ["ruleSet", getRuleSetToggleEncoder()],
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ]
  ]);
}
function getUpdateArgsDecoder() {
  return getDiscriminatedUnionDecoder([
    [
      "V1",
      getStructDecoder([
        ["newUpdateAuthority", getOptionDecoder(getAddressDecoder())],
        ["data", getOptionDecoder(getDataDecoder())],
        ["primarySaleHappened", getOptionDecoder(getBooleanDecoder())],
        ["isMutable", getOptionDecoder(getBooleanDecoder())],
        ["collection", getCollectionToggleDecoder()],
        ["collectionDetails", getCollectionDetailsToggleDecoder()],
        ["uses", getUsesToggleDecoder()],
        ["ruleSet", getRuleSetToggleDecoder()],
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ],
    [
      "AsUpdateAuthorityV2",
      getStructDecoder([
        ["newUpdateAuthority", getOptionDecoder(getAddressDecoder())],
        ["data", getOptionDecoder(getDataDecoder())],
        ["primarySaleHappened", getOptionDecoder(getBooleanDecoder())],
        ["isMutable", getOptionDecoder(getBooleanDecoder())],
        ["collection", getCollectionToggleDecoder()],
        ["collectionDetails", getCollectionDetailsToggleDecoder()],
        ["uses", getUsesToggleDecoder()],
        ["ruleSet", getRuleSetToggleDecoder()],
        ["tokenStandard", getOptionDecoder(getTokenStandardDecoder())],
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ],
    [
      "AsAuthorityItemDelegateV2",
      getStructDecoder([
        ["newUpdateAuthority", getOptionDecoder(getAddressDecoder())],
        ["primarySaleHappened", getOptionDecoder(getBooleanDecoder())],
        ["isMutable", getOptionDecoder(getBooleanDecoder())],
        ["tokenStandard", getOptionDecoder(getTokenStandardDecoder())],
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ],
    [
      "AsCollectionDelegateV2",
      getStructDecoder([
        ["collection", getCollectionToggleDecoder()],
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ],
    [
      "AsDataDelegateV2",
      getStructDecoder([
        ["data", getOptionDecoder(getDataDecoder())],
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ],
    [
      "AsProgrammableConfigDelegateV2",
      getStructDecoder([
        ["ruleSet", getRuleSetToggleDecoder()],
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ],
    [
      "AsDataItemDelegateV2",
      getStructDecoder([
        ["data", getOptionDecoder(getDataDecoder())],
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ],
    [
      "AsCollectionItemDelegateV2",
      getStructDecoder([
        ["collection", getCollectionToggleDecoder()],
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ],
    [
      "AsProgrammableConfigItemDelegateV2",
      getStructDecoder([
        ["ruleSet", getRuleSetToggleDecoder()],
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ]
  ]);
}
function getUpdateArgsCodec() {
  return combineCodec(getUpdateArgsEncoder(), getUpdateArgsDecoder());
}
function updateArgs(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isUpdateArgs(kind, value) {
  return value.__kind === kind;
}
function getUseArgsEncoder() {
  return getDiscriminatedUnionEncoder([
    [
      "V1",
      getStructEncoder([
        ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
      ])
    ]
  ]);
}
function getUseArgsDecoder() {
  return getDiscriminatedUnionDecoder([
    [
      "V1",
      getStructDecoder([
        ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
      ])
    ]
  ]);
}
function getUseArgsCodec() {
  return combineCodec(getUseArgsEncoder(), getUseArgsDecoder());
}
function useArgs(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isUseArgs(kind, value) {
  return value.__kind === kind;
}
var UseMethod = /* @__PURE__ */ ((UseMethod2) => {
  UseMethod2[UseMethod2["Burn"] = 0] = "Burn";
  UseMethod2[UseMethod2["Multiple"] = 1] = "Multiple";
  UseMethod2[UseMethod2["Single"] = 2] = "Single";
  return UseMethod2;
})(UseMethod || {});
function getUseMethodEncoder() {
  return getEnumEncoder(UseMethod);
}
function getUseMethodDecoder() {
  return getEnumDecoder(UseMethod);
}
function getUseMethodCodec() {
  return combineCodec(getUseMethodEncoder(), getUseMethodDecoder());
}
function getUsesEncoder() {
  return getStructEncoder([
    ["useMethod", getUseMethodEncoder()],
    ["remaining", getU64Encoder()],
    ["total", getU64Encoder()]
  ]);
}
function getUsesDecoder() {
  return getStructDecoder([
    ["useMethod", getUseMethodDecoder()],
    ["remaining", getU64Decoder()],
    ["total", getU64Decoder()]
  ]);
}
function getUsesCodec() {
  return combineCodec(getUsesEncoder(), getUsesDecoder());
}
function getUsesToggleEncoder() {
  return getDiscriminatedUnionEncoder([
    ["None", getUnitEncoder()],
    ["Clear", getUnitEncoder()],
    [
      "Set",
      getStructEncoder([["fields", getTupleEncoder([getUsesEncoder()])]])
    ]
  ]);
}
function getUsesToggleDecoder() {
  return getDiscriminatedUnionDecoder([
    ["None", getUnitDecoder()],
    ["Clear", getUnitDecoder()],
    [
      "Set",
      getStructDecoder([["fields", getTupleDecoder([getUsesDecoder()])]])
    ]
  ]);
}
function getUsesToggleCodec() {
  return combineCodec(getUsesToggleEncoder(), getUsesToggleDecoder());
}
function usesToggle(kind, data) {
  return Array.isArray(data) ? { __kind: kind, fields: data } : { __kind: kind, ...data ?? {} };
}
function isUsesToggle(kind, value) {
  return value.__kind === kind;
}
var VerificationArgs = /* @__PURE__ */ ((VerificationArgs2) => {
  VerificationArgs2[VerificationArgs2["CreatorV1"] = 0] = "CreatorV1";
  VerificationArgs2[VerificationArgs2["CollectionV1"] = 1] = "CollectionV1";
  return VerificationArgs2;
})(VerificationArgs || {});
function getVerificationArgsEncoder() {
  return getEnumEncoder(VerificationArgs);
}
function getVerificationArgsDecoder() {
  return getEnumDecoder(VerificationArgs);
}
function getVerificationArgsCodec() {
  return combineCodec(
    getVerificationArgsEncoder(),
    getVerificationArgsDecoder()
  );
}

// src/generated/accounts/collectionAuthorityRecord.ts
function getCollectionAuthorityRecordEncoder() {
  return getStructEncoder([
    ["key", getKeyEncoder()],
    ["bump", getU8Encoder()],
    ["updateAuthority", getOptionEncoder(getAddressEncoder())]
  ]);
}
function getCollectionAuthorityRecordDecoder() {
  return getStructDecoder([
    ["key", getKeyDecoder()],
    ["bump", getU8Decoder()],
    ["updateAuthority", getOptionDecoder(getAddressDecoder())]
  ]);
}
function getCollectionAuthorityRecordCodec() {
  return combineCodec(
    getCollectionAuthorityRecordEncoder(),
    getCollectionAuthorityRecordDecoder()
  );
}
function decodeCollectionAuthorityRecord(encodedAccount) {
  return decodeAccount(
    encodedAccount,
    getCollectionAuthorityRecordDecoder()
  );
}
async function fetchCollectionAuthorityRecord(rpc, address, config) {
  const maybeAccount = await fetchMaybeCollectionAuthorityRecord(
    rpc,
    address,
    config
  );
  assertAccountExists(maybeAccount);
  return maybeAccount;
}
async function fetchMaybeCollectionAuthorityRecord(rpc, address, config) {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeCollectionAuthorityRecord(maybeAccount);
}
async function fetchAllCollectionAuthorityRecord(rpc, addresses, config) {
  const maybeAccounts = await fetchAllMaybeCollectionAuthorityRecord(
    rpc,
    addresses,
    config
  );
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}
async function fetchAllMaybeCollectionAuthorityRecord(rpc, addresses, config) {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map(
    (maybeAccount) => decodeCollectionAuthorityRecord(maybeAccount)
  );
}
function getEditionEncoder() {
  return getStructEncoder([
    ["key", getKeyEncoder()],
    ["parent", getAddressEncoder()],
    ["edition", getU64Encoder()]
  ]);
}
function getEditionDecoder() {
  return getStructDecoder([
    ["key", getKeyDecoder()],
    ["parent", getAddressDecoder()],
    ["edition", getU64Decoder()]
  ]);
}
function getEditionCodec() {
  return combineCodec(getEditionEncoder(), getEditionDecoder());
}
function decodeEdition(encodedAccount) {
  return decodeAccount(
    encodedAccount,
    getEditionDecoder()
  );
}
async function fetchEdition(rpc, address, config) {
  const maybeAccount = await fetchMaybeEdition(rpc, address, config);
  assertAccountExists(maybeAccount);
  return maybeAccount;
}
async function fetchMaybeEdition(rpc, address, config) {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeEdition(maybeAccount);
}
async function fetchAllEdition(rpc, addresses, config) {
  const maybeAccounts = await fetchAllMaybeEdition(rpc, addresses, config);
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}
async function fetchAllMaybeEdition(rpc, addresses, config) {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map((maybeAccount) => decodeEdition(maybeAccount));
}
function getEditionSize() {
  return 41;
}
function getEditionMarkerEncoder() {
  return getStructEncoder([
    ["key", getKeyEncoder()],
    ["ledger", getArrayEncoder(getU8Encoder(), { size: 31 })]
  ]);
}
function getEditionMarkerDecoder() {
  return getStructDecoder([
    ["key", getKeyDecoder()],
    ["ledger", getArrayDecoder(getU8Decoder(), { size: 31 })]
  ]);
}
function getEditionMarkerCodec() {
  return combineCodec(getEditionMarkerEncoder(), getEditionMarkerDecoder());
}
function decodeEditionMarker(encodedAccount) {
  return decodeAccount(
    encodedAccount,
    getEditionMarkerDecoder()
  );
}
async function fetchEditionMarker(rpc, address, config) {
  const maybeAccount = await fetchMaybeEditionMarker(rpc, address, config);
  assertAccountExists(maybeAccount);
  return maybeAccount;
}
async function fetchMaybeEditionMarker(rpc, address, config) {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeEditionMarker(maybeAccount);
}
async function fetchAllEditionMarker(rpc, addresses, config) {
  const maybeAccounts = await fetchAllMaybeEditionMarker(
    rpc,
    addresses,
    config
  );
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}
async function fetchAllMaybeEditionMarker(rpc, addresses, config) {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map((maybeAccount) => decodeEditionMarker(maybeAccount));
}
function getEditionMarkerSize() {
  return 32;
}
function getEditionMarkerV2Encoder() {
  return getStructEncoder([
    ["key", getKeyEncoder()],
    ["ledger", addEncoderSizePrefix(getBytesEncoder(), getU32Encoder())]
  ]);
}
function getEditionMarkerV2Decoder() {
  return getStructDecoder([
    ["key", getKeyDecoder()],
    ["ledger", addDecoderSizePrefix(getBytesDecoder(), getU32Decoder())]
  ]);
}
function getEditionMarkerV2Codec() {
  return combineCodec(getEditionMarkerV2Encoder(), getEditionMarkerV2Decoder());
}
function decodeEditionMarkerV2(encodedAccount) {
  return decodeAccount(
    encodedAccount,
    getEditionMarkerV2Decoder()
  );
}
async function fetchEditionMarkerV2(rpc, address, config) {
  const maybeAccount = await fetchMaybeEditionMarkerV2(rpc, address, config);
  assertAccountExists(maybeAccount);
  return maybeAccount;
}
async function fetchMaybeEditionMarkerV2(rpc, address, config) {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeEditionMarkerV2(maybeAccount);
}
async function fetchAllEditionMarkerV2(rpc, addresses, config) {
  const maybeAccounts = await fetchAllMaybeEditionMarkerV2(
    rpc,
    addresses,
    config
  );
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}
async function fetchAllMaybeEditionMarkerV2(rpc, addresses, config) {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map(
    (maybeAccount) => decodeEditionMarkerV2(maybeAccount)
  );
}
function getHolderDelegateRecordEncoder() {
  return getStructEncoder([
    ["key", getKeyEncoder()],
    ["bump", getU8Encoder()],
    ["mint", getAddressEncoder()],
    ["delegate", getAddressEncoder()],
    ["updateAuthority", getAddressEncoder()]
  ]);
}
function getHolderDelegateRecordDecoder() {
  return getStructDecoder([
    ["key", getKeyDecoder()],
    ["bump", getU8Decoder()],
    ["mint", getAddressDecoder()],
    ["delegate", getAddressDecoder()],
    ["updateAuthority", getAddressDecoder()]
  ]);
}
function getHolderDelegateRecordCodec() {
  return combineCodec(
    getHolderDelegateRecordEncoder(),
    getHolderDelegateRecordDecoder()
  );
}
function decodeHolderDelegateRecord(encodedAccount) {
  return decodeAccount(
    encodedAccount,
    getHolderDelegateRecordDecoder()
  );
}
async function fetchHolderDelegateRecord(rpc, address, config) {
  const maybeAccount = await fetchMaybeHolderDelegateRecord(
    rpc,
    address,
    config
  );
  assertAccountExists(maybeAccount);
  return maybeAccount;
}
async function fetchMaybeHolderDelegateRecord(rpc, address, config) {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeHolderDelegateRecord(maybeAccount);
}
async function fetchAllHolderDelegateRecord(rpc, addresses, config) {
  const maybeAccounts = await fetchAllMaybeHolderDelegateRecord(
    rpc,
    addresses,
    config
  );
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}
async function fetchAllMaybeHolderDelegateRecord(rpc, addresses, config) {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map(
    (maybeAccount) => decodeHolderDelegateRecord(maybeAccount)
  );
}
function getHolderDelegateRecordSize() {
  return 98;
}
async function findMasterEditionPda(seeds, config = {}) {
  const {
    programAddress = "metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s"
  } = config;
  return await getProgramDerivedAddress({
    programAddress,
    seeds: [
      getUtf8Encoder().encode("metadata"),
      getAddressEncoder().encode(programAddress),
      getAddressEncoder().encode(seeds.mint),
      getUtf8Encoder().encode("edition")
    ]
  });
}
async function findMetadataPda(seeds, config = {}) {
  const {
    programAddress = "metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s"
  } = config;
  return await getProgramDerivedAddress({
    programAddress,
    seeds: [
      getUtf8Encoder().encode("metadata"),
      getAddressEncoder().encode(programAddress),
      getAddressEncoder().encode(seeds.mint)
    ]
  });
}
async function findTokenRecordPda(seeds, config = {}) {
  const {
    programAddress = "metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s"
  } = config;
  return await getProgramDerivedAddress({
    programAddress,
    seeds: [
      getUtf8Encoder().encode("metadata"),
      getAddressEncoder().encode(programAddress),
      getAddressEncoder().encode(seeds.mint),
      getUtf8Encoder().encode("token_record"),
      getAddressEncoder().encode(seeds.token)
    ]
  });
}

// src/generated/accounts/masterEdition.ts
function getMasterEditionEncoder() {
  return getStructEncoder([
    ["key", getKeyEncoder()],
    ["supply", getU64Encoder()],
    ["maxSupply", getOptionEncoder(getU64Encoder())]
  ]);
}
function getMasterEditionDecoder() {
  return getStructDecoder([
    ["key", getKeyDecoder()],
    ["supply", getU64Decoder()],
    ["maxSupply", getOptionDecoder(getU64Decoder())]
  ]);
}
function getMasterEditionCodec() {
  return combineCodec(getMasterEditionEncoder(), getMasterEditionDecoder());
}
function decodeMasterEdition(encodedAccount) {
  return decodeAccount(
    encodedAccount,
    getMasterEditionDecoder()
  );
}
async function fetchMasterEdition(rpc, address, config) {
  const maybeAccount = await fetchMaybeMasterEdition(rpc, address, config);
  assertAccountExists(maybeAccount);
  return maybeAccount;
}
async function fetchMaybeMasterEdition(rpc, address, config) {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeMasterEdition(maybeAccount);
}
async function fetchAllMasterEdition(rpc, addresses, config) {
  const maybeAccounts = await fetchAllMaybeMasterEdition(
    rpc,
    addresses,
    config
  );
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}
async function fetchAllMaybeMasterEdition(rpc, addresses, config) {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map((maybeAccount) => decodeMasterEdition(maybeAccount));
}
async function fetchMasterEditionFromSeeds(rpc, seeds, config = {}) {
  const maybeAccount = await fetchMaybeMasterEditionFromSeeds(
    rpc,
    seeds,
    config
  );
  assertAccountExists(maybeAccount);
  return maybeAccount;
}
async function fetchMaybeMasterEditionFromSeeds(rpc, seeds, config = {}) {
  const { programAddress, ...fetchConfig } = config;
  const [address] = await findMasterEditionPda(seeds, { programAddress });
  return await fetchMaybeMasterEdition(rpc, address, fetchConfig);
}
function getMasterEditionV1Encoder() {
  return getStructEncoder([
    ["key", getKeyEncoder()],
    ["supply", getU64Encoder()],
    ["maxSupply", getOptionEncoder(getU64Encoder())],
    ["printingMint", getAddressEncoder()],
    ["oneTimePrintingAuthorizationMint", getAddressEncoder()]
  ]);
}
function getMasterEditionV1Decoder() {
  return getStructDecoder([
    ["key", getKeyDecoder()],
    ["supply", getU64Decoder()],
    ["maxSupply", getOptionDecoder(getU64Decoder())],
    ["printingMint", getAddressDecoder()],
    ["oneTimePrintingAuthorizationMint", getAddressDecoder()]
  ]);
}
function getMasterEditionV1Codec() {
  return combineCodec(getMasterEditionV1Encoder(), getMasterEditionV1Decoder());
}
function decodeMasterEditionV1(encodedAccount) {
  return decodeAccount(
    encodedAccount,
    getMasterEditionV1Decoder()
  );
}
async function fetchMasterEditionV1(rpc, address, config) {
  const maybeAccount = await fetchMaybeMasterEditionV1(rpc, address, config);
  assertAccountExists(maybeAccount);
  return maybeAccount;
}
async function fetchMaybeMasterEditionV1(rpc, address, config) {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeMasterEditionV1(maybeAccount);
}
async function fetchAllMasterEditionV1(rpc, addresses, config) {
  const maybeAccounts = await fetchAllMaybeMasterEditionV1(
    rpc,
    addresses,
    config
  );
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}
async function fetchAllMaybeMasterEditionV1(rpc, addresses, config) {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map(
    (maybeAccount) => decodeMasterEditionV1(maybeAccount)
  );
}
function getMetadataEncoder() {
  return getStructEncoder([
    ["key", getKeyEncoder()],
    ["updateAuthority", getAddressEncoder()],
    ["mint", getAddressEncoder()],
    ["name", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
    ["symbol", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
    ["uri", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
    ["sellerFeeBasisPoints", getU16Encoder()],
    ["creators", getOptionEncoder(getArrayEncoder(getCreatorEncoder()))],
    ["primarySaleHappened", getBooleanEncoder()],
    ["isMutable", getBooleanEncoder()],
    ["editionNonce", getOptionEncoder(getU8Encoder())],
    ["tokenStandard", getOptionEncoder(getTokenStandardEncoder())],
    ["collection", getOptionEncoder(getCollectionEncoder())],
    ["uses", getOptionEncoder(getUsesEncoder())],
    ["collectionDetails", getOptionEncoder(getCollectionDetailsEncoder())],
    ["programmableConfig", getOptionEncoder(getProgrammableConfigEncoder())]
  ]);
}
function getMetadataDecoder() {
  return getStructDecoder([
    ["key", getKeyDecoder()],
    ["updateAuthority", getAddressDecoder()],
    ["mint", getAddressDecoder()],
    ["name", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["symbol", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["uri", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["sellerFeeBasisPoints", getU16Decoder()],
    ["creators", getOptionDecoder(getArrayDecoder(getCreatorDecoder()))],
    ["primarySaleHappened", getBooleanDecoder()],
    ["isMutable", getBooleanDecoder()],
    ["editionNonce", getOptionDecoder(getU8Decoder())],
    ["tokenStandard", getOptionDecoder(getTokenStandardDecoder())],
    ["collection", getOptionDecoder(getCollectionDecoder())],
    ["uses", getOptionDecoder(getUsesDecoder())],
    ["collectionDetails", getOptionDecoder(getCollectionDetailsDecoder())],
    ["programmableConfig", getOptionDecoder(getProgrammableConfigDecoder())]
  ]);
}
function getMetadataCodec() {
  return combineCodec(getMetadataEncoder(), getMetadataDecoder());
}
function decodeMetadata(encodedAccount) {
  return decodeAccount(
    encodedAccount,
    getMetadataDecoder()
  );
}
async function fetchMetadata(rpc, address, config) {
  const maybeAccount = await fetchMaybeMetadata(rpc, address, config);
  assertAccountExists(maybeAccount);
  return maybeAccount;
}
async function fetchMaybeMetadata(rpc, address, config) {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeMetadata(maybeAccount);
}
async function fetchAllMetadata(rpc, addresses, config) {
  const maybeAccounts = await fetchAllMaybeMetadata(rpc, addresses, config);
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}
async function fetchAllMaybeMetadata(rpc, addresses, config) {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map((maybeAccount) => decodeMetadata(maybeAccount));
}
async function fetchMetadataFromSeeds(rpc, seeds, config = {}) {
  const maybeAccount = await fetchMaybeMetadataFromSeeds(rpc, seeds, config);
  assertAccountExists(maybeAccount);
  return maybeAccount;
}
async function fetchMaybeMetadataFromSeeds(rpc, seeds, config = {}) {
  const { programAddress, ...fetchConfig } = config;
  const [address] = await findMetadataPda(seeds, { programAddress });
  return await fetchMaybeMetadata(rpc, address, fetchConfig);
}
function getMetadataDelegateRecordEncoder() {
  return getStructEncoder([
    ["key", getKeyEncoder()],
    ["bump", getU8Encoder()],
    ["mint", getAddressEncoder()],
    ["delegate", getAddressEncoder()],
    ["updateAuthority", getAddressEncoder()]
  ]);
}
function getMetadataDelegateRecordDecoder() {
  return getStructDecoder([
    ["key", getKeyDecoder()],
    ["bump", getU8Decoder()],
    ["mint", getAddressDecoder()],
    ["delegate", getAddressDecoder()],
    ["updateAuthority", getAddressDecoder()]
  ]);
}
function getMetadataDelegateRecordCodec() {
  return combineCodec(
    getMetadataDelegateRecordEncoder(),
    getMetadataDelegateRecordDecoder()
  );
}
function decodeMetadataDelegateRecord(encodedAccount) {
  return decodeAccount(
    encodedAccount,
    getMetadataDelegateRecordDecoder()
  );
}
async function fetchMetadataDelegateRecord(rpc, address, config) {
  const maybeAccount = await fetchMaybeMetadataDelegateRecord(
    rpc,
    address,
    config
  );
  assertAccountExists(maybeAccount);
  return maybeAccount;
}
async function fetchMaybeMetadataDelegateRecord(rpc, address, config) {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeMetadataDelegateRecord(maybeAccount);
}
async function fetchAllMetadataDelegateRecord(rpc, addresses, config) {
  const maybeAccounts = await fetchAllMaybeMetadataDelegateRecord(
    rpc,
    addresses,
    config
  );
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}
async function fetchAllMaybeMetadataDelegateRecord(rpc, addresses, config) {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map(
    (maybeAccount) => decodeMetadataDelegateRecord(maybeAccount)
  );
}
function getMetadataDelegateRecordSize() {
  return 98;
}
function getReservationListV1Encoder() {
  return getStructEncoder([
    ["key", getKeyEncoder()],
    ["masterEdition", getAddressEncoder()],
    ["supplySnapshot", getOptionEncoder(getU64Encoder())],
    ["reservations", getArrayEncoder(getReservationV1Encoder())]
  ]);
}
function getReservationListV1Decoder() {
  return getStructDecoder([
    ["key", getKeyDecoder()],
    ["masterEdition", getAddressDecoder()],
    ["supplySnapshot", getOptionDecoder(getU64Decoder())],
    ["reservations", getArrayDecoder(getReservationV1Decoder())]
  ]);
}
function getReservationListV1Codec() {
  return combineCodec(
    getReservationListV1Encoder(),
    getReservationListV1Decoder()
  );
}
function decodeReservationListV1(encodedAccount) {
  return decodeAccount(
    encodedAccount,
    getReservationListV1Decoder()
  );
}
async function fetchReservationListV1(rpc, address, config) {
  const maybeAccount = await fetchMaybeReservationListV1(rpc, address, config);
  assertAccountExists(maybeAccount);
  return maybeAccount;
}
async function fetchMaybeReservationListV1(rpc, address, config) {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeReservationListV1(maybeAccount);
}
async function fetchAllReservationListV1(rpc, addresses, config) {
  const maybeAccounts = await fetchAllMaybeReservationListV1(
    rpc,
    addresses,
    config
  );
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}
async function fetchAllMaybeReservationListV1(rpc, addresses, config) {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map(
    (maybeAccount) => decodeReservationListV1(maybeAccount)
  );
}
function getReservationListV2Encoder() {
  return getStructEncoder([
    ["key", getKeyEncoder()],
    ["masterEdition", getAddressEncoder()],
    ["supplySnapshot", getOptionEncoder(getU64Encoder())],
    ["reservations", getArrayEncoder(getReservationEncoder())],
    ["totalReservationSpots", getU64Encoder()],
    ["currentReservationSpots", getU64Encoder()]
  ]);
}
function getReservationListV2Decoder() {
  return getStructDecoder([
    ["key", getKeyDecoder()],
    ["masterEdition", getAddressDecoder()],
    ["supplySnapshot", getOptionDecoder(getU64Decoder())],
    ["reservations", getArrayDecoder(getReservationDecoder())],
    ["totalReservationSpots", getU64Decoder()],
    ["currentReservationSpots", getU64Decoder()]
  ]);
}
function getReservationListV2Codec() {
  return combineCodec(
    getReservationListV2Encoder(),
    getReservationListV2Decoder()
  );
}
function decodeReservationListV2(encodedAccount) {
  return decodeAccount(
    encodedAccount,
    getReservationListV2Decoder()
  );
}
async function fetchReservationListV2(rpc, address, config) {
  const maybeAccount = await fetchMaybeReservationListV2(rpc, address, config);
  assertAccountExists(maybeAccount);
  return maybeAccount;
}
async function fetchMaybeReservationListV2(rpc, address, config) {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeReservationListV2(maybeAccount);
}
async function fetchAllReservationListV2(rpc, addresses, config) {
  const maybeAccounts = await fetchAllMaybeReservationListV2(
    rpc,
    addresses,
    config
  );
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}
async function fetchAllMaybeReservationListV2(rpc, addresses, config) {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map(
    (maybeAccount) => decodeReservationListV2(maybeAccount)
  );
}
function getTokenOwnedEscrowEncoder() {
  return getStructEncoder([
    ["key", getKeyEncoder()],
    ["baseToken", getAddressEncoder()],
    ["authority", getEscrowAuthorityEncoder()],
    ["bump", getU8Encoder()]
  ]);
}
function getTokenOwnedEscrowDecoder() {
  return getStructDecoder([
    ["key", getKeyDecoder()],
    ["baseToken", getAddressDecoder()],
    ["authority", getEscrowAuthorityDecoder()],
    ["bump", getU8Decoder()]
  ]);
}
function getTokenOwnedEscrowCodec() {
  return combineCodec(
    getTokenOwnedEscrowEncoder(),
    getTokenOwnedEscrowDecoder()
  );
}
function decodeTokenOwnedEscrow(encodedAccount) {
  return decodeAccount(
    encodedAccount,
    getTokenOwnedEscrowDecoder()
  );
}
async function fetchTokenOwnedEscrow(rpc, address, config) {
  const maybeAccount = await fetchMaybeTokenOwnedEscrow(rpc, address, config);
  assertAccountExists(maybeAccount);
  return maybeAccount;
}
async function fetchMaybeTokenOwnedEscrow(rpc, address, config) {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeTokenOwnedEscrow(maybeAccount);
}
async function fetchAllTokenOwnedEscrow(rpc, addresses, config) {
  const maybeAccounts = await fetchAllMaybeTokenOwnedEscrow(
    rpc,
    addresses,
    config
  );
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}
async function fetchAllMaybeTokenOwnedEscrow(rpc, addresses, config) {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map(
    (maybeAccount) => decodeTokenOwnedEscrow(maybeAccount)
  );
}
function getTokenRecordEncoder() {
  return getStructEncoder([
    ["key", getKeyEncoder()],
    ["bump", getU8Encoder()],
    ["state", getTokenStateEncoder()],
    ["ruleSetRevision", getOptionEncoder(getU64Encoder())],
    ["delegate", getOptionEncoder(getAddressEncoder())],
    ["delegateRole", getOptionEncoder(getTokenDelegateRoleEncoder())],
    ["lockedTransfer", getOptionEncoder(getAddressEncoder())]
  ]);
}
function getTokenRecordDecoder() {
  return getStructDecoder([
    ["key", getKeyDecoder()],
    ["bump", getU8Decoder()],
    ["state", getTokenStateDecoder()],
    ["ruleSetRevision", getOptionDecoder(getU64Decoder())],
    ["delegate", getOptionDecoder(getAddressDecoder())],
    ["delegateRole", getOptionDecoder(getTokenDelegateRoleDecoder())],
    ["lockedTransfer", getOptionDecoder(getAddressDecoder())]
  ]);
}
function getTokenRecordCodec() {
  return combineCodec(getTokenRecordEncoder(), getTokenRecordDecoder());
}
function decodeTokenRecord(encodedAccount) {
  return decodeAccount(
    encodedAccount,
    getTokenRecordDecoder()
  );
}
async function fetchTokenRecord(rpc, address, config) {
  const maybeAccount = await fetchMaybeTokenRecord(rpc, address, config);
  assertAccountExists(maybeAccount);
  return maybeAccount;
}
async function fetchMaybeTokenRecord(rpc, address, config) {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeTokenRecord(maybeAccount);
}
async function fetchAllTokenRecord(rpc, addresses, config) {
  const maybeAccounts = await fetchAllMaybeTokenRecord(rpc, addresses, config);
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}
async function fetchAllMaybeTokenRecord(rpc, addresses, config) {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map((maybeAccount) => decodeTokenRecord(maybeAccount));
}
async function fetchTokenRecordFromSeeds(rpc, seeds, config = {}) {
  const maybeAccount = await fetchMaybeTokenRecordFromSeeds(rpc, seeds, config);
  assertAccountExists(maybeAccount);
  return maybeAccount;
}
async function fetchMaybeTokenRecordFromSeeds(rpc, seeds, config = {}) {
  const { programAddress, ...fetchConfig } = config;
  const [address] = await findTokenRecordPda(seeds, { programAddress });
  return await fetchMaybeTokenRecord(rpc, address, fetchConfig);
}
function getUseAuthorityRecordEncoder() {
  return getStructEncoder([
    ["key", getKeyEncoder()],
    ["allowedUses", getU64Encoder()],
    ["bump", getU8Encoder()]
  ]);
}
function getUseAuthorityRecordDecoder() {
  return getStructDecoder([
    ["key", getKeyDecoder()],
    ["allowedUses", getU64Decoder()],
    ["bump", getU8Decoder()]
  ]);
}
function getUseAuthorityRecordCodec() {
  return combineCodec(
    getUseAuthorityRecordEncoder(),
    getUseAuthorityRecordDecoder()
  );
}
function decodeUseAuthorityRecord(encodedAccount) {
  return decodeAccount(
    encodedAccount,
    getUseAuthorityRecordDecoder()
  );
}
async function fetchUseAuthorityRecord(rpc, address, config) {
  const maybeAccount = await fetchMaybeUseAuthorityRecord(rpc, address, config);
  assertAccountExists(maybeAccount);
  return maybeAccount;
}
async function fetchMaybeUseAuthorityRecord(rpc, address, config) {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeUseAuthorityRecord(maybeAccount);
}
async function fetchAllUseAuthorityRecord(rpc, addresses, config) {
  const maybeAccounts = await fetchAllMaybeUseAuthorityRecord(
    rpc,
    addresses,
    config
  );
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}
async function fetchAllMaybeUseAuthorityRecord(rpc, addresses, config) {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map(
    (maybeAccount) => decodeUseAuthorityRecord(maybeAccount)
  );
}
function getUseAuthorityRecordSize() {
  return 10;
}
var TOKEN_METADATA_PROGRAM_ADDRESS = "metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s";
var TokenMetadataAccount = /* @__PURE__ */ ((TokenMetadataAccount2) => {
  TokenMetadataAccount2[TokenMetadataAccount2["CollectionAuthorityRecord"] = 0] = "CollectionAuthorityRecord";
  TokenMetadataAccount2[TokenMetadataAccount2["MetadataDelegateRecord"] = 1] = "MetadataDelegateRecord";
  TokenMetadataAccount2[TokenMetadataAccount2["HolderDelegateRecord"] = 2] = "HolderDelegateRecord";
  TokenMetadataAccount2[TokenMetadataAccount2["Edition"] = 3] = "Edition";
  TokenMetadataAccount2[TokenMetadataAccount2["EditionMarker"] = 4] = "EditionMarker";
  TokenMetadataAccount2[TokenMetadataAccount2["EditionMarkerV2"] = 5] = "EditionMarkerV2";
  TokenMetadataAccount2[TokenMetadataAccount2["TokenOwnedEscrow"] = 6] = "TokenOwnedEscrow";
  TokenMetadataAccount2[TokenMetadataAccount2["MasterEdition"] = 7] = "MasterEdition";
  TokenMetadataAccount2[TokenMetadataAccount2["MasterEditionV1"] = 8] = "MasterEditionV1";
  TokenMetadataAccount2[TokenMetadataAccount2["Metadata"] = 9] = "Metadata";
  TokenMetadataAccount2[TokenMetadataAccount2["TokenRecord"] = 10] = "TokenRecord";
  TokenMetadataAccount2[TokenMetadataAccount2["ReservationListV2"] = 11] = "ReservationListV2";
  TokenMetadataAccount2[TokenMetadataAccount2["ReservationListV1"] = 12] = "ReservationListV1";
  TokenMetadataAccount2[TokenMetadataAccount2["UseAuthorityRecord"] = 13] = "UseAuthorityRecord";
  return TokenMetadataAccount2;
})(TokenMetadataAccount || {});
var TokenMetadataInstruction = /* @__PURE__ */ ((TokenMetadataInstruction2) => {
  TokenMetadataInstruction2[TokenMetadataInstruction2["CreateMetadataAccount"] = 0] = "CreateMetadataAccount";
  TokenMetadataInstruction2[TokenMetadataInstruction2["UpdateMetadataAccount"] = 1] = "UpdateMetadataAccount";
  TokenMetadataInstruction2[TokenMetadataInstruction2["DeprecatedCreateMasterEdition"] = 2] = "DeprecatedCreateMasterEdition";
  TokenMetadataInstruction2[TokenMetadataInstruction2["DeprecatedMintNewEditionFromMasterEditionViaPrintingToken"] = 3] = "DeprecatedMintNewEditionFromMasterEditionViaPrintingToken";
  TokenMetadataInstruction2[TokenMetadataInstruction2["UpdatePrimarySaleHappenedViaToken"] = 4] = "UpdatePrimarySaleHappenedViaToken";
  TokenMetadataInstruction2[TokenMetadataInstruction2["DeprecatedSetReservationList"] = 5] = "DeprecatedSetReservationList";
  TokenMetadataInstruction2[TokenMetadataInstruction2["DeprecatedCreateReservationList"] = 6] = "DeprecatedCreateReservationList";
  TokenMetadataInstruction2[TokenMetadataInstruction2["SignMetadata"] = 7] = "SignMetadata";
  TokenMetadataInstruction2[TokenMetadataInstruction2["DeprecatedMintPrintingTokensViaToken"] = 8] = "DeprecatedMintPrintingTokensViaToken";
  TokenMetadataInstruction2[TokenMetadataInstruction2["DeprecatedMintPrintingTokens"] = 9] = "DeprecatedMintPrintingTokens";
  TokenMetadataInstruction2[TokenMetadataInstruction2["CreateMasterEdition"] = 10] = "CreateMasterEdition";
  TokenMetadataInstruction2[TokenMetadataInstruction2["MintNewEditionFromMasterEditionViaToken"] = 11] = "MintNewEditionFromMasterEditionViaToken";
  TokenMetadataInstruction2[TokenMetadataInstruction2["ConvertMasterEditionV1ToV2"] = 12] = "ConvertMasterEditionV1ToV2";
  TokenMetadataInstruction2[TokenMetadataInstruction2["MintNewEditionFromMasterEditionViaVaultProxy"] = 13] = "MintNewEditionFromMasterEditionViaVaultProxy";
  TokenMetadataInstruction2[TokenMetadataInstruction2["PuffMetadata"] = 14] = "PuffMetadata";
  TokenMetadataInstruction2[TokenMetadataInstruction2["UpdateMetadataAccountV2"] = 15] = "UpdateMetadataAccountV2";
  TokenMetadataInstruction2[TokenMetadataInstruction2["CreateMetadataAccountV2"] = 16] = "CreateMetadataAccountV2";
  TokenMetadataInstruction2[TokenMetadataInstruction2["CreateMasterEditionV3"] = 17] = "CreateMasterEditionV3";
  TokenMetadataInstruction2[TokenMetadataInstruction2["VerifyCollection"] = 18] = "VerifyCollection";
  TokenMetadataInstruction2[TokenMetadataInstruction2["Utilize"] = 19] = "Utilize";
  TokenMetadataInstruction2[TokenMetadataInstruction2["ApproveUseAuthority"] = 20] = "ApproveUseAuthority";
  TokenMetadataInstruction2[TokenMetadataInstruction2["RevokeUseAuthority"] = 21] = "RevokeUseAuthority";
  TokenMetadataInstruction2[TokenMetadataInstruction2["UnverifyCollection"] = 22] = "UnverifyCollection";
  TokenMetadataInstruction2[TokenMetadataInstruction2["ApproveCollectionAuthority"] = 23] = "ApproveCollectionAuthority";
  TokenMetadataInstruction2[TokenMetadataInstruction2["RevokeCollectionAuthority"] = 24] = "RevokeCollectionAuthority";
  TokenMetadataInstruction2[TokenMetadataInstruction2["SetAndVerifyCollection"] = 25] = "SetAndVerifyCollection";
  TokenMetadataInstruction2[TokenMetadataInstruction2["FreezeDelegatedAccount"] = 26] = "FreezeDelegatedAccount";
  TokenMetadataInstruction2[TokenMetadataInstruction2["ThawDelegatedAccount"] = 27] = "ThawDelegatedAccount";
  TokenMetadataInstruction2[TokenMetadataInstruction2["RemoveCreatorVerification"] = 28] = "RemoveCreatorVerification";
  TokenMetadataInstruction2[TokenMetadataInstruction2["BurnNft"] = 29] = "BurnNft";
  TokenMetadataInstruction2[TokenMetadataInstruction2["VerifySizedCollectionItem"] = 30] = "VerifySizedCollectionItem";
  TokenMetadataInstruction2[TokenMetadataInstruction2["UnverifySizedCollectionItem"] = 31] = "UnverifySizedCollectionItem";
  TokenMetadataInstruction2[TokenMetadataInstruction2["SetAndVerifySizedCollectionItem"] = 32] = "SetAndVerifySizedCollectionItem";
  TokenMetadataInstruction2[TokenMetadataInstruction2["CreateMetadataAccountV3"] = 33] = "CreateMetadataAccountV3";
  TokenMetadataInstruction2[TokenMetadataInstruction2["SetCollectionSize"] = 34] = "SetCollectionSize";
  TokenMetadataInstruction2[TokenMetadataInstruction2["SetTokenStandard"] = 35] = "SetTokenStandard";
  TokenMetadataInstruction2[TokenMetadataInstruction2["BubblegumSetCollectionSize"] = 36] = "BubblegumSetCollectionSize";
  TokenMetadataInstruction2[TokenMetadataInstruction2["BurnEditionNft"] = 37] = "BurnEditionNft";
  TokenMetadataInstruction2[TokenMetadataInstruction2["CreateEscrowAccount"] = 38] = "CreateEscrowAccount";
  TokenMetadataInstruction2[TokenMetadataInstruction2["CloseEscrowAccount"] = 39] = "CloseEscrowAccount";
  TokenMetadataInstruction2[TokenMetadataInstruction2["TransferOutOfEscrow"] = 40] = "TransferOutOfEscrow";
  TokenMetadataInstruction2[TokenMetadataInstruction2["Burn"] = 41] = "Burn";
  TokenMetadataInstruction2[TokenMetadataInstruction2["CreateV1"] = 42] = "CreateV1";
  TokenMetadataInstruction2[TokenMetadataInstruction2["MintV1"] = 43] = "MintV1";
  TokenMetadataInstruction2[TokenMetadataInstruction2["Delegate"] = 44] = "Delegate";
  TokenMetadataInstruction2[TokenMetadataInstruction2["Revoke"] = 45] = "Revoke";
  TokenMetadataInstruction2[TokenMetadataInstruction2["Lock"] = 46] = "Lock";
  TokenMetadataInstruction2[TokenMetadataInstruction2["Unlock"] = 47] = "Unlock";
  TokenMetadataInstruction2[TokenMetadataInstruction2["Migrate"] = 48] = "Migrate";
  TokenMetadataInstruction2[TokenMetadataInstruction2["Transfer"] = 49] = "Transfer";
  TokenMetadataInstruction2[TokenMetadataInstruction2["Update"] = 50] = "Update";
  TokenMetadataInstruction2[TokenMetadataInstruction2["Use"] = 51] = "Use";
  TokenMetadataInstruction2[TokenMetadataInstruction2["Verify"] = 52] = "Verify";
  TokenMetadataInstruction2[TokenMetadataInstruction2["Unverify"] = 53] = "Unverify";
  TokenMetadataInstruction2[TokenMetadataInstruction2["Collect"] = 54] = "Collect";
  TokenMetadataInstruction2[TokenMetadataInstruction2["Print"] = 55] = "Print";
  return TokenMetadataInstruction2;
})(TokenMetadataInstruction || {});
function identifyTokenMetadataInstruction(instruction) {
  const data = "data" in instruction ? instruction.data : instruction;
  if (containsBytes(data, getU8Encoder().encode(0), 0)) {
    return 0 /* CreateMetadataAccount */;
  }
  if (containsBytes(data, getU8Encoder().encode(1), 0)) {
    return 1 /* UpdateMetadataAccount */;
  }
  if (containsBytes(data, getU8Encoder().encode(2), 0)) {
    return 2 /* DeprecatedCreateMasterEdition */;
  }
  if (containsBytes(data, getU8Encoder().encode(3), 0)) {
    return 3 /* DeprecatedMintNewEditionFromMasterEditionViaPrintingToken */;
  }
  if (containsBytes(data, getU8Encoder().encode(4), 0)) {
    return 4 /* UpdatePrimarySaleHappenedViaToken */;
  }
  if (containsBytes(data, getU8Encoder().encode(5), 0)) {
    return 5 /* DeprecatedSetReservationList */;
  }
  if (containsBytes(data, getU8Encoder().encode(6), 0)) {
    return 6 /* DeprecatedCreateReservationList */;
  }
  if (containsBytes(data, getU8Encoder().encode(7), 0)) {
    return 7 /* SignMetadata */;
  }
  if (containsBytes(data, getU8Encoder().encode(8), 0)) {
    return 8 /* DeprecatedMintPrintingTokensViaToken */;
  }
  if (containsBytes(data, getU8Encoder().encode(9), 0)) {
    return 9 /* DeprecatedMintPrintingTokens */;
  }
  if (containsBytes(data, getU8Encoder().encode(10), 0)) {
    return 10 /* CreateMasterEdition */;
  }
  if (containsBytes(data, getU8Encoder().encode(11), 0)) {
    return 11 /* MintNewEditionFromMasterEditionViaToken */;
  }
  if (containsBytes(data, getU8Encoder().encode(12), 0)) {
    return 12 /* ConvertMasterEditionV1ToV2 */;
  }
  if (containsBytes(data, getU8Encoder().encode(13), 0)) {
    return 13 /* MintNewEditionFromMasterEditionViaVaultProxy */;
  }
  if (containsBytes(data, getU8Encoder().encode(14), 0)) {
    return 14 /* PuffMetadata */;
  }
  if (containsBytes(data, getU8Encoder().encode(15), 0)) {
    return 15 /* UpdateMetadataAccountV2 */;
  }
  if (containsBytes(data, getU8Encoder().encode(16), 0)) {
    return 16 /* CreateMetadataAccountV2 */;
  }
  if (containsBytes(data, getU8Encoder().encode(17), 0)) {
    return 17 /* CreateMasterEditionV3 */;
  }
  if (containsBytes(data, getU8Encoder().encode(18), 0)) {
    return 18 /* VerifyCollection */;
  }
  if (containsBytes(data, getU8Encoder().encode(19), 0)) {
    return 19 /* Utilize */;
  }
  if (containsBytes(data, getU8Encoder().encode(20), 0)) {
    return 20 /* ApproveUseAuthority */;
  }
  if (containsBytes(data, getU8Encoder().encode(21), 0)) {
    return 21 /* RevokeUseAuthority */;
  }
  if (containsBytes(data, getU8Encoder().encode(22), 0)) {
    return 22 /* UnverifyCollection */;
  }
  if (containsBytes(data, getU8Encoder().encode(23), 0)) {
    return 23 /* ApproveCollectionAuthority */;
  }
  if (containsBytes(data, getU8Encoder().encode(24), 0)) {
    return 24 /* RevokeCollectionAuthority */;
  }
  if (containsBytes(data, getU8Encoder().encode(25), 0)) {
    return 25 /* SetAndVerifyCollection */;
  }
  if (containsBytes(data, getU8Encoder().encode(26), 0)) {
    return 26 /* FreezeDelegatedAccount */;
  }
  if (containsBytes(data, getU8Encoder().encode(27), 0)) {
    return 27 /* ThawDelegatedAccount */;
  }
  if (containsBytes(data, getU8Encoder().encode(28), 0)) {
    return 28 /* RemoveCreatorVerification */;
  }
  if (containsBytes(data, getU8Encoder().encode(29), 0)) {
    return 29 /* BurnNft */;
  }
  if (containsBytes(data, getU8Encoder().encode(30), 0)) {
    return 30 /* VerifySizedCollectionItem */;
  }
  if (containsBytes(data, getU8Encoder().encode(31), 0)) {
    return 31 /* UnverifySizedCollectionItem */;
  }
  if (containsBytes(data, getU8Encoder().encode(32), 0)) {
    return 32 /* SetAndVerifySizedCollectionItem */;
  }
  if (containsBytes(data, getU8Encoder().encode(33), 0)) {
    return 33 /* CreateMetadataAccountV3 */;
  }
  if (containsBytes(data, getU8Encoder().encode(34), 0)) {
    return 34 /* SetCollectionSize */;
  }
  if (containsBytes(data, getU8Encoder().encode(35), 0)) {
    return 35 /* SetTokenStandard */;
  }
  if (containsBytes(data, getU8Encoder().encode(36), 0)) {
    return 36 /* BubblegumSetCollectionSize */;
  }
  if (containsBytes(data, getU8Encoder().encode(37), 0)) {
    return 37 /* BurnEditionNft */;
  }
  if (containsBytes(data, getU8Encoder().encode(38), 0)) {
    return 38 /* CreateEscrowAccount */;
  }
  if (containsBytes(data, getU8Encoder().encode(39), 0)) {
    return 39 /* CloseEscrowAccount */;
  }
  if (containsBytes(data, getU8Encoder().encode(40), 0)) {
    return 40 /* TransferOutOfEscrow */;
  }
  if (containsBytes(data, getU8Encoder().encode(41), 0)) {
    return 41 /* Burn */;
  }
  if (containsBytes(data, getU8Encoder().encode(42), 0)) {
    return 42 /* CreateV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(43), 0)) {
    return 43 /* MintV1 */;
  }
  if (containsBytes(data, getU8Encoder().encode(44), 0)) {
    return 44 /* Delegate */;
  }
  if (containsBytes(data, getU8Encoder().encode(45), 0)) {
    return 45 /* Revoke */;
  }
  if (containsBytes(data, getU8Encoder().encode(46), 0)) {
    return 46 /* Lock */;
  }
  if (containsBytes(data, getU8Encoder().encode(47), 0)) {
    return 47 /* Unlock */;
  }
  if (containsBytes(data, getU8Encoder().encode(48), 0)) {
    return 48 /* Migrate */;
  }
  if (containsBytes(data, getU8Encoder().encode(49), 0)) {
    return 49 /* Transfer */;
  }
  if (containsBytes(data, getU8Encoder().encode(50), 0)) {
    return 50 /* Update */;
  }
  if (containsBytes(data, getU8Encoder().encode(51), 0)) {
    return 51 /* Use */;
  }
  if (containsBytes(data, getU8Encoder().encode(52), 0)) {
    return 52 /* Verify */;
  }
  if (containsBytes(data, getU8Encoder().encode(53), 0)) {
    return 53 /* Unverify */;
  }
  if (containsBytes(data, getU8Encoder().encode(54), 0)) {
    return 54 /* Collect */;
  }
  if (containsBytes(data, getU8Encoder().encode(55), 0)) {
    return 55 /* Print */;
  }
  throw new Error(
    "The provided instruction could not be identified as a tokenMetadata instruction."
  );
}

// src/generated/errors/tokenMetadata.ts
var TOKEN_METADATA_ERROR__INSTRUCTION_UNPACK_ERROR = 0;
var TOKEN_METADATA_ERROR__INSTRUCTION_PACK_ERROR = 1;
var TOKEN_METADATA_ERROR__NOT_RENT_EXEMPT = 2;
var TOKEN_METADATA_ERROR__ALREADY_INITIALIZED = 3;
var TOKEN_METADATA_ERROR__UNINITIALIZED = 4;
var TOKEN_METADATA_ERROR__INVALID_METADATA_KEY = 5;
var TOKEN_METADATA_ERROR__INVALID_EDITION_KEY = 6;
var TOKEN_METADATA_ERROR__UPDATE_AUTHORITY_INCORRECT = 7;
var TOKEN_METADATA_ERROR__UPDATE_AUTHORITY_IS_NOT_SIGNER = 8;
var TOKEN_METADATA_ERROR__NOT_MINT_AUTHORITY = 9;
var TOKEN_METADATA_ERROR__INVALID_MINT_AUTHORITY = 10;
var TOKEN_METADATA_ERROR__NAME_TOO_LONG = 11;
var TOKEN_METADATA_ERROR__SYMBOL_TOO_LONG = 12;
var TOKEN_METADATA_ERROR__URI_TOO_LONG = 13;
var TOKEN_METADATA_ERROR__UPDATE_AUTHORITY_MUST_BE_EQUAL_TO_METADATA_AUTHORITY_AND_SIGNER = 14;
var TOKEN_METADATA_ERROR__MINT_MISMATCH = 15;
var TOKEN_METADATA_ERROR__EDITIONS_MUST_HAVE_EXACTLY_ONE_TOKEN = 16;
var TOKEN_METADATA_ERROR__MAX_EDITIONS_MINTED_ALREADY = 17;
var TOKEN_METADATA_ERROR__TOKEN_MINT_TO_FAILED = 18;
var TOKEN_METADATA_ERROR__MASTER_RECORD_MISMATCH = 19;
var TOKEN_METADATA_ERROR__DESTINATION_MINT_MISMATCH = 20;
var TOKEN_METADATA_ERROR__EDITION_ALREADY_MINTED = 21;
var TOKEN_METADATA_ERROR__PRINTING_MINT_DECIMALS_SHOULD_BE_ZERO = 22;
var TOKEN_METADATA_ERROR__ONE_TIME_PRINTING_AUTHORIZATION_MINT_DECIMALS_SHOULD_BE_ZERO = 23;
var TOKEN_METADATA_ERROR__EDITION_MINT_DECIMALS_SHOULD_BE_ZERO = 24;
var TOKEN_METADATA_ERROR__TOKEN_BURN_FAILED = 25;
var TOKEN_METADATA_ERROR__TOKEN_ACCOUNT_ONE_TIME_AUTH_MINT_MISMATCH = 26;
var TOKEN_METADATA_ERROR__DERIVED_KEY_INVALID = 27;
var TOKEN_METADATA_ERROR__PRINTING_MINT_MISMATCH = 28;
var TOKEN_METADATA_ERROR__ONE_TIME_PRINTING_AUTH_MINT_MISMATCH = 29;
var TOKEN_METADATA_ERROR__TOKEN_ACCOUNT_MINT_MISMATCH = 30;
var TOKEN_METADATA_ERROR__TOKEN_ACCOUNT_MINT_MISMATCH_V2 = 31;
var TOKEN_METADATA_ERROR__NOT_ENOUGH_TOKENS = 32;
var TOKEN_METADATA_ERROR__PRINTING_MINT_AUTHORIZATION_ACCOUNT_MISMATCH = 33;
var TOKEN_METADATA_ERROR__AUTHORIZATION_TOKEN_ACCOUNT_OWNER_MISMATCH = 34;
var TOKEN_METADATA_ERROR__DISABLED = 35;
var TOKEN_METADATA_ERROR__CREATORS_TOO_LONG = 36;
var TOKEN_METADATA_ERROR__CREATORS_MUST_BE_ATLEAST_ONE = 37;
var TOKEN_METADATA_ERROR__MUST_BE_ONE_OF_CREATORS = 38;
var TOKEN_METADATA_ERROR__NO_CREATORS_PRESENT_ON_METADATA = 39;
var TOKEN_METADATA_ERROR__CREATOR_NOT_FOUND = 40;
var TOKEN_METADATA_ERROR__INVALID_BASIS_POINTS = 41;
var TOKEN_METADATA_ERROR__PRIMARY_SALE_CAN_ONLY_BE_FLIPPED_TO_TRUE = 42;
var TOKEN_METADATA_ERROR__OWNER_MISMATCH = 43;
var TOKEN_METADATA_ERROR__NO_BALANCE_IN_ACCOUNT_FOR_AUTHORIZATION = 44;
var TOKEN_METADATA_ERROR__SHARE_TOTAL_MUST_BE100 = 45;
var TOKEN_METADATA_ERROR__RESERVATION_EXISTS = 46;
var TOKEN_METADATA_ERROR__RESERVATION_DOES_NOT_EXIST = 47;
var TOKEN_METADATA_ERROR__RESERVATION_NOT_SET = 48;
var TOKEN_METADATA_ERROR__RESERVATION_ALREADY_MADE = 49;
var TOKEN_METADATA_ERROR__BEYOND_MAX_ADDRESS_SIZE = 50;
var TOKEN_METADATA_ERROR__NUMERICAL_OVERFLOW_ERROR = 51;
var TOKEN_METADATA_ERROR__RESERVATION_BREACHES_MAXIMUM_SUPPLY = 52;
var TOKEN_METADATA_ERROR__ADDRESS_NOT_IN_RESERVATION = 53;
var TOKEN_METADATA_ERROR__CANNOT_VERIFY_ANOTHER_CREATOR = 54;
var TOKEN_METADATA_ERROR__CANNOT_UNVERIFY_ANOTHER_CREATOR = 55;
var TOKEN_METADATA_ERROR__SPOT_MISMATCH = 56;
var TOKEN_METADATA_ERROR__INCORRECT_OWNER = 57;
var TOKEN_METADATA_ERROR__PRINTING_WOULD_BREACH_MAXIMUM_SUPPLY = 58;
var TOKEN_METADATA_ERROR__DATA_IS_IMMUTABLE = 59;
var TOKEN_METADATA_ERROR__DUPLICATE_CREATOR_ADDRESS = 60;
var TOKEN_METADATA_ERROR__RESERVATION_SPOTS_REMAINING_SHOULD_MATCH_TOTAL_SPOTS_AT_START = 61;
var TOKEN_METADATA_ERROR__INVALID_TOKEN_PROGRAM = 62;
var TOKEN_METADATA_ERROR__DATA_TYPE_MISMATCH = 63;
var TOKEN_METADATA_ERROR__BEYOND_ALOTTED_ADDRESS_SIZE = 64;
var TOKEN_METADATA_ERROR__RESERVATION_NOT_COMPLETE = 65;
var TOKEN_METADATA_ERROR__TRIED_TO_REPLACE_AN_EXISTING_RESERVATION = 66;
var TOKEN_METADATA_ERROR__INVALID_OPERATION = 67;
var TOKEN_METADATA_ERROR__INVALID_OWNER = 68;
var TOKEN_METADATA_ERROR__PRINTING_MINT_SUPPLY_MUST_BE_ZERO_FOR_CONVERSION = 69;
var TOKEN_METADATA_ERROR__ONE_TIME_AUTH_MINT_SUPPLY_MUST_BE_ZERO_FOR_CONVERSION = 70;
var TOKEN_METADATA_ERROR__INVALID_EDITION_INDEX = 71;
var TOKEN_METADATA_ERROR__RESERVATION_ARRAY_SHOULD_BE_SIZE_ONE = 72;
var TOKEN_METADATA_ERROR__IS_MUTABLE_CAN_ONLY_BE_FLIPPED_TO_FALSE = 73;
var TOKEN_METADATA_ERROR__COLLECTION_CANNOT_BE_VERIFIED_IN_THIS_INSTRUCTION = 74;
var TOKEN_METADATA_ERROR__REMOVED = 75;
var TOKEN_METADATA_ERROR__MUST_BE_BURNED = 76;
var TOKEN_METADATA_ERROR__INVALID_USE_METHOD = 77;
var TOKEN_METADATA_ERROR__CANNOT_CHANGE_USE_METHOD_AFTER_FIRST_USE = 78;
var TOKEN_METADATA_ERROR__CANNOT_CHANGE_USES_AFTER_FIRST_USE = 79;
var TOKEN_METADATA_ERROR__COLLECTION_NOT_FOUND = 80;
var TOKEN_METADATA_ERROR__INVALID_COLLECTION_UPDATE_AUTHORITY = 81;
var TOKEN_METADATA_ERROR__COLLECTION_MUST_BE_A_UNIQUE_MASTER_EDITION = 82;
var TOKEN_METADATA_ERROR__USE_AUTHORITY_RECORD_ALREADY_EXISTS = 83;
var TOKEN_METADATA_ERROR__USE_AUTHORITY_RECORD_ALREADY_REVOKED = 84;
var TOKEN_METADATA_ERROR__UNUSABLE = 85;
var TOKEN_METADATA_ERROR__NOT_ENOUGH_USES = 86;
var TOKEN_METADATA_ERROR__COLLECTION_AUTHORITY_RECORD_ALREADY_EXISTS = 87;
var TOKEN_METADATA_ERROR__COLLECTION_AUTHORITY_DOES_NOT_EXIST = 88;
var TOKEN_METADATA_ERROR__INVALID_USE_AUTHORITY_RECORD = 89;
var TOKEN_METADATA_ERROR__INVALID_COLLECTION_AUTHORITY_RECORD = 90;
var TOKEN_METADATA_ERROR__INVALID_FREEZE_AUTHORITY = 91;
var TOKEN_METADATA_ERROR__INVALID_DELEGATE = 92;
var TOKEN_METADATA_ERROR__CANNOT_ADJUST_VERIFIED_CREATOR = 93;
var TOKEN_METADATA_ERROR__CANNOT_REMOVE_VERIFIED_CREATOR = 94;
var TOKEN_METADATA_ERROR__CANNOT_WIPE_VERIFIED_CREATORS = 95;
var TOKEN_METADATA_ERROR__NOT_ALLOWED_TO_CHANGE_SELLER_FEE_BASIS_POINTS = 96;
var TOKEN_METADATA_ERROR__EDITION_OVERRIDE_CANNOT_BE_ZERO = 97;
var TOKEN_METADATA_ERROR__INVALID_USER = 98;
var TOKEN_METADATA_ERROR__REVOKE_COLLECTION_AUTHORITY_SIGNER_INCORRECT = 99;
var TOKEN_METADATA_ERROR__TOKEN_CLOSE_FAILED = 100;
var TOKEN_METADATA_ERROR__UNSIZED_COLLECTION = 101;
var TOKEN_METADATA_ERROR__SIZED_COLLECTION = 102;
var TOKEN_METADATA_ERROR__MISSING_COLLECTION_METADATA = 103;
var TOKEN_METADATA_ERROR__NOT_A_MEMBER_OF_COLLECTION = 104;
var TOKEN_METADATA_ERROR__NOT_VERIFIED_MEMBER_OF_COLLECTION = 105;
var TOKEN_METADATA_ERROR__NOT_A_COLLECTION_PARENT = 106;
var TOKEN_METADATA_ERROR__COULD_NOT_DETERMINE_TOKEN_STANDARD = 107;
var TOKEN_METADATA_ERROR__MISSING_EDITION_ACCOUNT = 108;
var TOKEN_METADATA_ERROR__NOT_A_MASTER_EDITION = 109;
var TOKEN_METADATA_ERROR__MASTER_EDITION_HAS_PRINTS = 110;
var TOKEN_METADATA_ERROR__BORSH_DESERIALIZATION_ERROR = 111;
var TOKEN_METADATA_ERROR__CANNOT_UPDATE_VERIFIED_COLLECTION = 112;
var TOKEN_METADATA_ERROR__COLLECTION_MASTER_EDITION_ACCOUNT_INVALID = 113;
var TOKEN_METADATA_ERROR__ALREADY_VERIFIED = 114;
var TOKEN_METADATA_ERROR__ALREADY_UNVERIFIED = 115;
var TOKEN_METADATA_ERROR__NOT_A_PRINT_EDITION = 116;
var TOKEN_METADATA_ERROR__INVALID_MASTER_EDITION = 117;
var TOKEN_METADATA_ERROR__INVALID_PRINT_EDITION = 118;
var TOKEN_METADATA_ERROR__INVALID_EDITION_MARKER = 119;
var TOKEN_METADATA_ERROR__RESERVATION_LIST_DEPRECATED = 120;
var TOKEN_METADATA_ERROR__PRINT_EDITION_DOES_NOT_MATCH_MASTER_EDITION = 121;
var TOKEN_METADATA_ERROR__EDITION_NUMBER_GREATER_THAN_MAX_SUPPLY = 122;
var TOKEN_METADATA_ERROR__MUST_UNVERIFY = 123;
var TOKEN_METADATA_ERROR__INVALID_ESCROW_BUMP_SEED = 124;
var TOKEN_METADATA_ERROR__MUST_BE_ESCROW_AUTHORITY = 125;
var TOKEN_METADATA_ERROR__INVALID_SYSTEM_PROGRAM = 126;
var TOKEN_METADATA_ERROR__MUST_BE_NON_FUNGIBLE = 127;
var TOKEN_METADATA_ERROR__INSUFFICIENT_TOKENS = 128;
var TOKEN_METADATA_ERROR__BORSH_SERIALIZATION_ERROR = 129;
var TOKEN_METADATA_ERROR__NO_FREEZE_AUTHORITY_SET = 130;
var TOKEN_METADATA_ERROR__INVALID_COLLECTION_SIZE_CHANGE = 131;
var TOKEN_METADATA_ERROR__INVALID_BUBBLEGUM_SIGNER = 132;
var TOKEN_METADATA_ERROR__ESCROW_PARENT_HAS_DELEGATE = 133;
var TOKEN_METADATA_ERROR__MINT_IS_NOT_SIGNER = 134;
var TOKEN_METADATA_ERROR__INVALID_TOKEN_STANDARD = 135;
var TOKEN_METADATA_ERROR__INVALID_MINT_FOR_TOKEN_STANDARD = 136;
var TOKEN_METADATA_ERROR__INVALID_AUTHORIZATION_RULES = 137;
var TOKEN_METADATA_ERROR__MISSING_AUTHORIZATION_RULES = 138;
var TOKEN_METADATA_ERROR__MISSING_PROGRAMMABLE_CONFIG = 139;
var TOKEN_METADATA_ERROR__INVALID_PROGRAMMABLE_CONFIG = 140;
var TOKEN_METADATA_ERROR__DELEGATE_ALREADY_EXISTS = 141;
var TOKEN_METADATA_ERROR__DELEGATE_NOT_FOUND = 142;
var TOKEN_METADATA_ERROR__MISSING_ACCOUNT_IN_BUILDER = 143;
var TOKEN_METADATA_ERROR__MISSING_ARGUMENT_IN_BUILDER = 144;
var TOKEN_METADATA_ERROR__FEATURE_NOT_SUPPORTED = 145;
var TOKEN_METADATA_ERROR__INVALID_SYSTEM_WALLET = 146;
var TOKEN_METADATA_ERROR__ONLY_SALE_DELEGATE_CAN_TRANSFER = 147;
var TOKEN_METADATA_ERROR__MISSING_TOKEN_ACCOUNT = 148;
var TOKEN_METADATA_ERROR__MISSING_SPL_TOKEN_PROGRAM = 149;
var TOKEN_METADATA_ERROR__MISSING_AUTHORIZATION_RULES_PROGRAM = 150;
var TOKEN_METADATA_ERROR__INVALID_DELEGATE_ROLE_FOR_TRANSFER = 151;
var TOKEN_METADATA_ERROR__INVALID_TRANSFER_AUTHORITY = 152;
var TOKEN_METADATA_ERROR__INSTRUCTION_NOT_SUPPORTED = 153;
var TOKEN_METADATA_ERROR__KEY_MISMATCH = 154;
var TOKEN_METADATA_ERROR__LOCKED_TOKEN = 155;
var TOKEN_METADATA_ERROR__UNLOCKED_TOKEN = 156;
var TOKEN_METADATA_ERROR__MISSING_DELEGATE_ROLE = 157;
var TOKEN_METADATA_ERROR__INVALID_AUTHORITY_TYPE = 158;
var TOKEN_METADATA_ERROR__MISSING_TOKEN_RECORD = 159;
var TOKEN_METADATA_ERROR__MINT_SUPPLY_MUST_BE_ZERO = 160;
var TOKEN_METADATA_ERROR__DATA_IS_EMPTY_OR_ZEROED = 161;
var TOKEN_METADATA_ERROR__MISSING_TOKEN_OWNER_ACCOUNT = 162;
var TOKEN_METADATA_ERROR__INVALID_MASTER_EDITION_ACCOUNT_LENGTH = 163;
var TOKEN_METADATA_ERROR__INCORRECT_TOKEN_STATE = 164;
var TOKEN_METADATA_ERROR__INVALID_DELEGATE_ROLE = 165;
var TOKEN_METADATA_ERROR__MISSING_PRINT_SUPPLY = 166;
var TOKEN_METADATA_ERROR__MISSING_MASTER_EDITION_ACCOUNT = 167;
var TOKEN_METADATA_ERROR__AMOUNT_MUST_BE_GREATER_THAN_ZERO = 168;
var TOKEN_METADATA_ERROR__INVALID_DELEGATE_ARGS = 169;
var TOKEN_METADATA_ERROR__MISSING_LOCKED_TRANSFER_ADDRESS = 170;
var TOKEN_METADATA_ERROR__INVALID_LOCKED_TRANSFER_ADDRESS = 171;
var TOKEN_METADATA_ERROR__DATA_INCREMENT_LIMIT_EXCEEDED = 172;
var TOKEN_METADATA_ERROR__CANNOT_UPDATE_ASSET_WITH_DELEGATE = 173;
var TOKEN_METADATA_ERROR__INVALID_AMOUNT = 174;
var TOKEN_METADATA_ERROR__MISSING_MASTER_EDITION_MINT_ACCOUNT = 175;
var TOKEN_METADATA_ERROR__MISSING_MASTER_EDITION_TOKEN_ACCOUNT = 176;
var TOKEN_METADATA_ERROR__MISSING_EDITION_MARKER_ACCOUNT = 177;
var TOKEN_METADATA_ERROR__CANNOT_BURN_WITH_DELEGATE = 178;
var TOKEN_METADATA_ERROR__MISSING_EDITION = 179;
var TOKEN_METADATA_ERROR__INVALID_ASSOCIATED_TOKEN_ACCOUNT_PROGRAM = 180;
var TOKEN_METADATA_ERROR__INVALID_INSTRUCTIONS_SYSVAR = 181;
var TOKEN_METADATA_ERROR__INVALID_PARENT_ACCOUNTS = 182;
var TOKEN_METADATA_ERROR__INVALID_UPDATE_ARGS = 183;
var TOKEN_METADATA_ERROR__INSUFFICIENT_TOKEN_BALANCE = 184;
var TOKEN_METADATA_ERROR__MISSING_COLLECTION_MINT = 185;
var TOKEN_METADATA_ERROR__MISSING_COLLECTION_MASTER_EDITION = 186;
var TOKEN_METADATA_ERROR__INVALID_TOKEN_RECORD = 187;
var TOKEN_METADATA_ERROR__INVALID_CLOSE_AUTHORITY = 188;
var TOKEN_METADATA_ERROR__INVALID_INSTRUCTION = 189;
var TOKEN_METADATA_ERROR__MISSING_DELEGATE_RECORD = 190;
var TOKEN_METADATA_ERROR__INVALID_FEE_ACCOUNT = 191;
var TOKEN_METADATA_ERROR__INVALID_METADATA_FLAGS = 192;
var TOKEN_METADATA_ERROR__CANNOT_CHANGE_UPDATE_AUTHORITY_WITH_DELEGATE = 193;
var TOKEN_METADATA_ERROR__INVALID_MINT_EXTENSION_TYPE = 194;
var TOKEN_METADATA_ERROR__INVALID_MINT_CLOSE_AUTHORITY = 195;
var TOKEN_METADATA_ERROR__INVALID_METADATA_POINTER = 196;
var TOKEN_METADATA_ERROR__INVALID_TOKEN_EXTENSION_TYPE = 197;
var TOKEN_METADATA_ERROR__MISSING_IMMUTABLE_OWNER_EXTENSION = 198;
var tokenMetadataErrorMessages;
if (process.env.NODE_ENV !== "production") {
  tokenMetadataErrorMessages = {
    [TOKEN_METADATA_ERROR__ADDRESS_NOT_IN_RESERVATION]: ``,
    [TOKEN_METADATA_ERROR__ALREADY_INITIALIZED]: `Already initialized`,
    [TOKEN_METADATA_ERROR__ALREADY_UNVERIFIED]: ``,
    [TOKEN_METADATA_ERROR__ALREADY_VERIFIED]: `Item is already verified.`,
    [TOKEN_METADATA_ERROR__AMOUNT_MUST_BE_GREATER_THAN_ZERO]: `Amount must be greater than zero`,
    [TOKEN_METADATA_ERROR__AUTHORIZATION_TOKEN_ACCOUNT_OWNER_MISMATCH]: ``,
    [TOKEN_METADATA_ERROR__BEYOND_ALOTTED_ADDRESS_SIZE]: ``,
    [TOKEN_METADATA_ERROR__BEYOND_MAX_ADDRESS_SIZE]: ``,
    [TOKEN_METADATA_ERROR__BORSH_DESERIALIZATION_ERROR]: ``,
    [TOKEN_METADATA_ERROR__BORSH_SERIALIZATION_ERROR]: `Borsh Serialization Error`,
    [TOKEN_METADATA_ERROR__CANNOT_ADJUST_VERIFIED_CREATOR]: ``,
    [TOKEN_METADATA_ERROR__CANNOT_BURN_WITH_DELEGATE]: `Cannot burn while persistent delegate is set`,
    [TOKEN_METADATA_ERROR__CANNOT_CHANGE_UPDATE_AUTHORITY_WITH_DELEGATE]: `Cannot change the update authority with a delegate`,
    [TOKEN_METADATA_ERROR__CANNOT_CHANGE_USE_METHOD_AFTER_FIRST_USE]: `Cannot Change Use Method after the first use`,
    [TOKEN_METADATA_ERROR__CANNOT_CHANGE_USES_AFTER_FIRST_USE]: `Cannot Change Remaining or Available uses after the first use`,
    [TOKEN_METADATA_ERROR__CANNOT_REMOVE_VERIFIED_CREATOR]: `Verified creators cannot be removed.`,
    [TOKEN_METADATA_ERROR__CANNOT_UNVERIFY_ANOTHER_CREATOR]: `You cannot unilaterally unverify another creator`,
    [TOKEN_METADATA_ERROR__CANNOT_UPDATE_ASSET_WITH_DELEGATE]: `Cannot update the rule set of a programmable asset that has a delegate`,
    [TOKEN_METADATA_ERROR__CANNOT_UPDATE_VERIFIED_COLLECTION]: `Cannot update a verified collection in this command`,
    [TOKEN_METADATA_ERROR__CANNOT_VERIFY_ANOTHER_CREATOR]: `You cannot unilaterally verify another creator, they must sign`,
    [TOKEN_METADATA_ERROR__CANNOT_WIPE_VERIFIED_CREATORS]: ``,
    [TOKEN_METADATA_ERROR__COLLECTION_AUTHORITY_DOES_NOT_EXIST]: `This Collection Authority Record Does Not Exist.`,
    [TOKEN_METADATA_ERROR__COLLECTION_AUTHORITY_RECORD_ALREADY_EXISTS]: `This Collection Authority Record Already Exists.`,
    [TOKEN_METADATA_ERROR__COLLECTION_CANNOT_BE_VERIFIED_IN_THIS_INSTRUCTION]: `Collection cannot be verified in this instruction`,
    [TOKEN_METADATA_ERROR__COLLECTION_MASTER_EDITION_ACCOUNT_INVALID]: `Edition account doesnt match collection `,
    [TOKEN_METADATA_ERROR__COLLECTION_MUST_BE_A_UNIQUE_MASTER_EDITION]: `Collection Must Be a Unique Master Edition v2`,
    [TOKEN_METADATA_ERROR__COLLECTION_NOT_FOUND]: `Collection Not Found on Metadata`,
    [TOKEN_METADATA_ERROR__COULD_NOT_DETERMINE_TOKEN_STANDARD]: `Could not determine a TokenStandard type.`,
    [TOKEN_METADATA_ERROR__CREATOR_NOT_FOUND]: `This creator address was not found`,
    [TOKEN_METADATA_ERROR__CREATORS_MUST_BE_ATLEAST_ONE]: `Creators must be at least one if set`,
    [TOKEN_METADATA_ERROR__CREATORS_TOO_LONG]: `Creators list too long`,
    [TOKEN_METADATA_ERROR__DATA_INCREMENT_LIMIT_EXCEEDED]: `Exceeded account realloc increase limit`,
    [TOKEN_METADATA_ERROR__DATA_IS_EMPTY_OR_ZEROED]: `Data is empty or zeroed`,
    [TOKEN_METADATA_ERROR__DATA_IS_IMMUTABLE]: `Data is immutable`,
    [TOKEN_METADATA_ERROR__DATA_TYPE_MISMATCH]: `Data type mismatch`,
    [TOKEN_METADATA_ERROR__DELEGATE_ALREADY_EXISTS]: `Delegate already exists`,
    [TOKEN_METADATA_ERROR__DELEGATE_NOT_FOUND]: `Delegate not found`,
    [TOKEN_METADATA_ERROR__DERIVED_KEY_INVALID]: `Derived key invalid`,
    [TOKEN_METADATA_ERROR__DESTINATION_MINT_MISMATCH]: ``,
    [TOKEN_METADATA_ERROR__DISABLED]: ``,
    [TOKEN_METADATA_ERROR__DUPLICATE_CREATOR_ADDRESS]: `No duplicate creator addresses`,
    [TOKEN_METADATA_ERROR__EDITION_ALREADY_MINTED]: ``,
    [TOKEN_METADATA_ERROR__EDITION_MINT_DECIMALS_SHOULD_BE_ZERO]: `EditionMintDecimalsShouldBeZero`,
    [TOKEN_METADATA_ERROR__EDITION_NUMBER_GREATER_THAN_MAX_SUPPLY]: `Edition Number greater than max supply`,
    [TOKEN_METADATA_ERROR__EDITION_OVERRIDE_CANNOT_BE_ZERO]: `Edition override cannot be zero`,
    [TOKEN_METADATA_ERROR__EDITIONS_MUST_HAVE_EXACTLY_ONE_TOKEN]: `Editions must have exactly one token`,
    [TOKEN_METADATA_ERROR__ESCROW_PARENT_HAS_DELEGATE]: `Escrow parent cannot have a delegate`,
    [TOKEN_METADATA_ERROR__FEATURE_NOT_SUPPORTED]: `Feature not supported currently`,
    [TOKEN_METADATA_ERROR__INCORRECT_OWNER]: `Incorrect account owner`,
    [TOKEN_METADATA_ERROR__INCORRECT_TOKEN_STATE]: `Incorrect token state`,
    [TOKEN_METADATA_ERROR__INSTRUCTION_NOT_SUPPORTED]: `Instruction not supported for ProgrammableNonFungible assets`,
    [TOKEN_METADATA_ERROR__INSTRUCTION_PACK_ERROR]: ``,
    [TOKEN_METADATA_ERROR__INSTRUCTION_UNPACK_ERROR]: ``,
    [TOKEN_METADATA_ERROR__INSUFFICIENT_TOKEN_BALANCE]: `Token account does not have enough tokens`,
    [TOKEN_METADATA_ERROR__INSUFFICIENT_TOKENS]: `Insufficient tokens for transfer`,
    [TOKEN_METADATA_ERROR__INVALID_AMOUNT]: `Invalid token amount for this operation or token standard`,
    [TOKEN_METADATA_ERROR__INVALID_ASSOCIATED_TOKEN_ACCOUNT_PROGRAM]: `Invalid Associated Token Account Program`,
    [TOKEN_METADATA_ERROR__INVALID_AUTHORITY_TYPE]: `Invalid authority type`,
    [TOKEN_METADATA_ERROR__INVALID_AUTHORIZATION_RULES]: `Invalid authorization rules account`,
    [TOKEN_METADATA_ERROR__INVALID_BASIS_POINTS]: `Basis points cannot be more than 10000`,
    [TOKEN_METADATA_ERROR__INVALID_BUBBLEGUM_SIGNER]: `Invalid bubblegum signer`,
    [TOKEN_METADATA_ERROR__INVALID_CLOSE_AUTHORITY]: `The close authority needs to be revoked by the Utility Delegate`,
    [TOKEN_METADATA_ERROR__INVALID_COLLECTION_AUTHORITY_RECORD]: ``,
    [TOKEN_METADATA_ERROR__INVALID_COLLECTION_SIZE_CHANGE]: `Invalid collection size change`,
    [TOKEN_METADATA_ERROR__INVALID_COLLECTION_UPDATE_AUTHORITY]: `Collection Update Authority is invalid`,
    [TOKEN_METADATA_ERROR__INVALID_DELEGATE]: `All tokens in this account have not been delegated to this user.`,
    [TOKEN_METADATA_ERROR__INVALID_DELEGATE_ARGS]: `Invalid delegate args`,
    [TOKEN_METADATA_ERROR__INVALID_DELEGATE_ROLE]: `Invalid delegate role`,
    [TOKEN_METADATA_ERROR__INVALID_DELEGATE_ROLE_FOR_TRANSFER]: `Invalid delegate role for transfer`,
    [TOKEN_METADATA_ERROR__INVALID_EDITION_INDEX]: `You tried to insert one edition too many into an edition mark pda`,
    [TOKEN_METADATA_ERROR__INVALID_EDITION_KEY]: `Edition's key must match seed of ['metadata', program id, name, 'edition'] provided`,
    [TOKEN_METADATA_ERROR__INVALID_EDITION_MARKER]: `Invalid Edition Marker`,
    [TOKEN_METADATA_ERROR__INVALID_ESCROW_BUMP_SEED]: `Invalid Escrow Account Bump Seed`,
    [TOKEN_METADATA_ERROR__INVALID_FEE_ACCOUNT]: ``,
    [TOKEN_METADATA_ERROR__INVALID_FREEZE_AUTHORITY]: `Metadata does not match the freeze authority on the mint`,
    [TOKEN_METADATA_ERROR__INVALID_INSTRUCTION]: `Invalid or removed instruction`,
    [TOKEN_METADATA_ERROR__INVALID_INSTRUCTIONS_SYSVAR]: `Invalid InstructionsSysvar`,
    [TOKEN_METADATA_ERROR__INVALID_LOCKED_TRANSFER_ADDRESS]: `Invalid destination address for locked transfer`,
    [TOKEN_METADATA_ERROR__INVALID_MASTER_EDITION]: `Invalid Master Edition`,
    [TOKEN_METADATA_ERROR__INVALID_MASTER_EDITION_ACCOUNT_LENGTH]: `Master edition account has an invalid length`,
    [TOKEN_METADATA_ERROR__INVALID_METADATA_FLAGS]: ``,
    [TOKEN_METADATA_ERROR__INVALID_METADATA_KEY]: ` Metadata's key must match seed of ['metadata', program id, mint] provided`,
    [TOKEN_METADATA_ERROR__INVALID_METADATA_POINTER]: `Invalid metadata pointer`,
    [TOKEN_METADATA_ERROR__INVALID_MINT_AUTHORITY]: `Mint authority provided does not match the authority on the mint`,
    [TOKEN_METADATA_ERROR__INVALID_MINT_CLOSE_AUTHORITY]: `Invalid mint close authority`,
    [TOKEN_METADATA_ERROR__INVALID_MINT_EXTENSION_TYPE]: `Invalid mint extension type`,
    [TOKEN_METADATA_ERROR__INVALID_MINT_FOR_TOKEN_STANDARD]: `Invalid mint account for specified token standard`,
    [TOKEN_METADATA_ERROR__INVALID_OPERATION]: `Invalid operation`,
    [TOKEN_METADATA_ERROR__INVALID_OWNER]: `Invalid Owner`,
    [TOKEN_METADATA_ERROR__INVALID_PARENT_ACCOUNTS]: `Invalid or Unneeded parent accounts`,
    [TOKEN_METADATA_ERROR__INVALID_PRINT_EDITION]: `Invalid Print Edition`,
    [TOKEN_METADATA_ERROR__INVALID_PROGRAMMABLE_CONFIG]: `Invalid programmable configuration`,
    [TOKEN_METADATA_ERROR__INVALID_SYSTEM_PROGRAM]: `Invalid System Program`,
    [TOKEN_METADATA_ERROR__INVALID_SYSTEM_WALLET]: `Invalid system wallet`,
    [TOKEN_METADATA_ERROR__INVALID_TOKEN_EXTENSION_TYPE]: `Invalid token extension type`,
    [TOKEN_METADATA_ERROR__INVALID_TOKEN_PROGRAM]: `Invalid token program`,
    [TOKEN_METADATA_ERROR__INVALID_TOKEN_RECORD]: `Invalid token record account`,
    [TOKEN_METADATA_ERROR__INVALID_TOKEN_STANDARD]: `Invalid token standard`,
    [TOKEN_METADATA_ERROR__INVALID_TRANSFER_AUTHORITY]: `Invalid transfer authority`,
    [TOKEN_METADATA_ERROR__INVALID_UPDATE_ARGS]: `Authority cannot apply all update args`,
    [TOKEN_METADATA_ERROR__INVALID_USE_AUTHORITY_RECORD]: `This Use Authority Record is invalid.`,
    [TOKEN_METADATA_ERROR__INVALID_USE_METHOD]: `This use method is invalid`,
    [TOKEN_METADATA_ERROR__INVALID_USER]: `Invalid User`,
    [TOKEN_METADATA_ERROR__IS_MUTABLE_CAN_ONLY_BE_FLIPPED_TO_FALSE]: `Is Mutable can only be flipped to false`,
    [TOKEN_METADATA_ERROR__KEY_MISMATCH]: `Public key does not match expected value`,
    [TOKEN_METADATA_ERROR__LOCKED_TOKEN]: `Token is locked`,
    [TOKEN_METADATA_ERROR__MASTER_EDITION_HAS_PRINTS]: `This Master Edition has existing prints`,
    [TOKEN_METADATA_ERROR__MASTER_RECORD_MISMATCH]: ``,
    [TOKEN_METADATA_ERROR__MAX_EDITIONS_MINTED_ALREADY]: ``,
    [TOKEN_METADATA_ERROR__MINT_IS_NOT_SIGNER]: `Mint needs to be signer to initialize the account`,
    [TOKEN_METADATA_ERROR__MINT_MISMATCH]: `Mint given does not match mint on Metadata`,
    [TOKEN_METADATA_ERROR__MINT_SUPPLY_MUST_BE_ZERO]: `Mint supply must be zero for programmable assets`,
    [TOKEN_METADATA_ERROR__MISSING_ACCOUNT_IN_BUILDER]: `Required account not set in instruction builder`,
    [TOKEN_METADATA_ERROR__MISSING_ARGUMENT_IN_BUILDER]: `Required argument not set in instruction builder`,
    [TOKEN_METADATA_ERROR__MISSING_AUTHORIZATION_RULES]: `Missing authorization rules account`,
    [TOKEN_METADATA_ERROR__MISSING_AUTHORIZATION_RULES_PROGRAM]: `Missing authorization rules program`,
    [TOKEN_METADATA_ERROR__MISSING_COLLECTION_MASTER_EDITION]: `Missing collection master edition account`,
    [TOKEN_METADATA_ERROR__MISSING_COLLECTION_METADATA]: `Missing collection metadata account`,
    [TOKEN_METADATA_ERROR__MISSING_COLLECTION_MINT]: `Missing collection account`,
    [TOKEN_METADATA_ERROR__MISSING_DELEGATE_RECORD]: `Missing delegate record`,
    [TOKEN_METADATA_ERROR__MISSING_DELEGATE_ROLE]: `Missing delegate role`,
    [TOKEN_METADATA_ERROR__MISSING_EDITION]: `Missing edition account`,
    [TOKEN_METADATA_ERROR__MISSING_EDITION_ACCOUNT]: `This mint account has an edition but none was provided.`,
    [TOKEN_METADATA_ERROR__MISSING_EDITION_MARKER_ACCOUNT]: `Missing edition marker account`,
    [TOKEN_METADATA_ERROR__MISSING_IMMUTABLE_OWNER_EXTENSION]: `Missing immutable owner extension`,
    [TOKEN_METADATA_ERROR__MISSING_LOCKED_TRANSFER_ADDRESS]: `Missing address for locked transfer`,
    [TOKEN_METADATA_ERROR__MISSING_MASTER_EDITION_ACCOUNT]: `Missing master edition account`,
    [TOKEN_METADATA_ERROR__MISSING_MASTER_EDITION_MINT_ACCOUNT]: `Missing master edition mint account`,
    [TOKEN_METADATA_ERROR__MISSING_MASTER_EDITION_TOKEN_ACCOUNT]: `Missing master edition token account`,
    [TOKEN_METADATA_ERROR__MISSING_PRINT_SUPPLY]: `Print supply is required for non-fungibles`,
    [TOKEN_METADATA_ERROR__MISSING_PROGRAMMABLE_CONFIG]: `Missing programmable configuration`,
    [TOKEN_METADATA_ERROR__MISSING_SPL_TOKEN_PROGRAM]: `Missing SPL token program`,
    [TOKEN_METADATA_ERROR__MISSING_TOKEN_ACCOUNT]: `Missing token account`,
    [TOKEN_METADATA_ERROR__MISSING_TOKEN_OWNER_ACCOUNT]: `Missing token owner`,
    [TOKEN_METADATA_ERROR__MISSING_TOKEN_RECORD]: `Missing token record account`,
    [TOKEN_METADATA_ERROR__MUST_BE_BURNED]: ``,
    [TOKEN_METADATA_ERROR__MUST_BE_ESCROW_AUTHORITY]: `Must Escrow Authority`,
    [TOKEN_METADATA_ERROR__MUST_BE_NON_FUNGIBLE]: `Must be a Non Fungible Token`,
    [TOKEN_METADATA_ERROR__MUST_BE_ONE_OF_CREATORS]: ``,
    [TOKEN_METADATA_ERROR__MUST_UNVERIFY]: `Must unverify before migrating collections.`,
    [TOKEN_METADATA_ERROR__NAME_TOO_LONG]: `Name too long`,
    [TOKEN_METADATA_ERROR__NO_BALANCE_IN_ACCOUNT_FOR_AUTHORIZATION]: `This account has no tokens to be used for authorization`,
    [TOKEN_METADATA_ERROR__NO_CREATORS_PRESENT_ON_METADATA]: `This metadata does not have creators`,
    [TOKEN_METADATA_ERROR__NO_FREEZE_AUTHORITY_SET]: `Cannot create NFT with no Freeze Authority.`,
    [TOKEN_METADATA_ERROR__NOT_A_COLLECTION_PARENT]: `This NFT is not a collection parent NFT.`,
    [TOKEN_METADATA_ERROR__NOT_ALLOWED_TO_CHANGE_SELLER_FEE_BASIS_POINTS]: ``,
    [TOKEN_METADATA_ERROR__NOT_A_MASTER_EDITION]: `This edition is not a Master Edition`,
    [TOKEN_METADATA_ERROR__NOT_A_MEMBER_OF_COLLECTION]: `This NFT is not a member of the specified collection.`,
    [TOKEN_METADATA_ERROR__NOT_A_PRINT_EDITION]: `This edition is not a Print Edition`,
    [TOKEN_METADATA_ERROR__NOT_ENOUGH_TOKENS]: `Not enough tokens to mint a limited edition`,
    [TOKEN_METADATA_ERROR__NOT_ENOUGH_USES]: `There are not enough Uses left on this token.`,
    [TOKEN_METADATA_ERROR__NOT_MINT_AUTHORITY]: `You must be the mint authority and signer on this transaction`,
    [TOKEN_METADATA_ERROR__NOT_RENT_EXEMPT]: `Lamport balance below rent-exempt threshold`,
    [TOKEN_METADATA_ERROR__NOT_VERIFIED_MEMBER_OF_COLLECTION]: `This NFT is not a verified member of the specified collection.`,
    [TOKEN_METADATA_ERROR__NUMERICAL_OVERFLOW_ERROR]: `NumericalOverflowError`,
    [TOKEN_METADATA_ERROR__ONE_TIME_AUTH_MINT_SUPPLY_MUST_BE_ZERO_FOR_CONVERSION]: `One Time Auth mint supply must be zero for conversion`,
    [TOKEN_METADATA_ERROR__ONE_TIME_PRINTING_AUTH_MINT_MISMATCH]: `The One Time Printing Auth mint does not match that on the master edition!`,
    [TOKEN_METADATA_ERROR__ONE_TIME_PRINTING_AUTHORIZATION_MINT_DECIMALS_SHOULD_BE_ZERO]: ``,
    [TOKEN_METADATA_ERROR__ONLY_SALE_DELEGATE_CAN_TRANSFER]: `Only the sale delegate can transfer while its set`,
    [TOKEN_METADATA_ERROR__OWNER_MISMATCH]: `Owner does not match that on the account given`,
    [TOKEN_METADATA_ERROR__PRIMARY_SALE_CAN_ONLY_BE_FLIPPED_TO_TRUE]: `Primary sale can only be flipped to true and is immutable`,
    [TOKEN_METADATA_ERROR__PRINT_EDITION_DOES_NOT_MATCH_MASTER_EDITION]: `Print Edition does not match Master Edition`,
    [TOKEN_METADATA_ERROR__PRINTING_MINT_AUTHORIZATION_ACCOUNT_MISMATCH]: ``,
    [TOKEN_METADATA_ERROR__PRINTING_MINT_DECIMALS_SHOULD_BE_ZERO]: ``,
    [TOKEN_METADATA_ERROR__PRINTING_MINT_MISMATCH]: `The Printing mint does not match that on the master edition!`,
    [TOKEN_METADATA_ERROR__PRINTING_MINT_SUPPLY_MUST_BE_ZERO_FOR_CONVERSION]: `Printing mint supply must be zero for conversion`,
    [TOKEN_METADATA_ERROR__PRINTING_WOULD_BREACH_MAXIMUM_SUPPLY]: ``,
    [TOKEN_METADATA_ERROR__REMOVED]: `This instruction was deprecated in a previous release and is now removed`,
    [TOKEN_METADATA_ERROR__RESERVATION_ALREADY_MADE]: ``,
    [TOKEN_METADATA_ERROR__RESERVATION_ARRAY_SHOULD_BE_SIZE_ONE]: ``,
    [TOKEN_METADATA_ERROR__RESERVATION_BREACHES_MAXIMUM_SUPPLY]: ``,
    [TOKEN_METADATA_ERROR__RESERVATION_DOES_NOT_EXIST]: ``,
    [TOKEN_METADATA_ERROR__RESERVATION_EXISTS]: ``,
    [TOKEN_METADATA_ERROR__RESERVATION_LIST_DEPRECATED]: `Reservation List is Deprecated`,
    [TOKEN_METADATA_ERROR__RESERVATION_NOT_COMPLETE]: ``,
    [TOKEN_METADATA_ERROR__RESERVATION_NOT_SET]: ``,
    [TOKEN_METADATA_ERROR__RESERVATION_SPOTS_REMAINING_SHOULD_MATCH_TOTAL_SPOTS_AT_START]: ``,
    [TOKEN_METADATA_ERROR__REVOKE_COLLECTION_AUTHORITY_SIGNER_INCORRECT]: `Revoke Collection Authority signer is incorrect`,
    [TOKEN_METADATA_ERROR__SHARE_TOTAL_MUST_BE100]: `Share total must equal 100 for creator array`,
    [TOKEN_METADATA_ERROR__SIZED_COLLECTION]: `Can't use this function on a sized collection`,
    [TOKEN_METADATA_ERROR__SPOT_MISMATCH]: ``,
    [TOKEN_METADATA_ERROR__SYMBOL_TOO_LONG]: `Symbol too long`,
    [TOKEN_METADATA_ERROR__TOKEN_ACCOUNT_MINT_MISMATCH]: `The mint of the token account does not match the Printing mint!`,
    [TOKEN_METADATA_ERROR__TOKEN_ACCOUNT_MINT_MISMATCH_V2]: `The mint of the token account does not match the master metadata mint!`,
    [TOKEN_METADATA_ERROR__TOKEN_ACCOUNT_ONE_TIME_AUTH_MINT_MISMATCH]: ``,
    [TOKEN_METADATA_ERROR__TOKEN_BURN_FAILED]: ``,
    [TOKEN_METADATA_ERROR__TOKEN_CLOSE_FAILED]: ``,
    [TOKEN_METADATA_ERROR__TOKEN_MINT_TO_FAILED]: ``,
    [TOKEN_METADATA_ERROR__TRIED_TO_REPLACE_AN_EXISTING_RESERVATION]: ``,
    [TOKEN_METADATA_ERROR__UNINITIALIZED]: `Uninitialized`,
    [TOKEN_METADATA_ERROR__UNLOCKED_TOKEN]: `Token is unlocked`,
    [TOKEN_METADATA_ERROR__UNSIZED_COLLECTION]: `Can't use this function on unsized collection`,
    [TOKEN_METADATA_ERROR__UNUSABLE]: `This token has no uses`,
    [TOKEN_METADATA_ERROR__UPDATE_AUTHORITY_INCORRECT]: `Update Authority given does not match`,
    [TOKEN_METADATA_ERROR__UPDATE_AUTHORITY_IS_NOT_SIGNER]: `Update Authority needs to be signer to update metadata`,
    [TOKEN_METADATA_ERROR__UPDATE_AUTHORITY_MUST_BE_EQUAL_TO_METADATA_AUTHORITY_AND_SIGNER]: ``,
    [TOKEN_METADATA_ERROR__URI_TOO_LONG]: `URI too long`,
    [TOKEN_METADATA_ERROR__USE_AUTHORITY_RECORD_ALREADY_EXISTS]: `The Use Authority Record Already Exists, to modify it Revoke, then Approve`,
    [TOKEN_METADATA_ERROR__USE_AUTHORITY_RECORD_ALREADY_REVOKED]: `The Use Authority Record is empty or already revoked`
  };
}
function getTokenMetadataErrorMessage(code) {
  if (process.env.NODE_ENV !== "production") {
    return tokenMetadataErrorMessages[code];
  }
  return "Error message not available in production bundles.";
}
function isTokenMetadataError(error, transactionMessage, code) {
  return isProgramError(
    error,
    transactionMessage,
    TOKEN_METADATA_PROGRAM_ADDRESS,
    code
  );
}
function expectAddress(value) {
  if (!value) {
    throw new Error("Expected a Address.");
  }
  if (typeof value === "object" && "address" in value) {
    return value.address;
  }
  if (Array.isArray(value)) {
    return value[0];
  }
  return value;
}
function getAccountMetaFactory(programAddress, optionalAccountStrategy) {
  return (account) => {
    if (!account.value) {
      if (optionalAccountStrategy === "omitted") return;
      return Object.freeze({
        address: programAddress,
        role: AccountRole.READONLY
      });
    }
    const writableRole = account.isWritable ? AccountRole.WRITABLE : AccountRole.READONLY;
    return Object.freeze({
      address: expectAddress(account.value),
      role: isTransactionSigner(account.value) ? upgradeRoleToSigner(writableRole) : writableRole,
      ...isTransactionSigner(account.value) ? { signer: account.value } : {}
    });
  };
}
function isTransactionSigner(value) {
  return !!value && typeof value === "object" && "address" in value && isTransactionSigner$1(value);
}

// src/generated/instructions/approveCollectionAuthority.ts
function getApproveCollectionAuthorityInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 23 })
  );
}
function getApproveCollectionAuthorityInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getApproveCollectionAuthorityInstructionDataCodec() {
  return combineCodec(
    getApproveCollectionAuthorityInstructionDataEncoder(),
    getApproveCollectionAuthorityInstructionDataDecoder()
  );
}
function getApproveCollectionAuthorityInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    collectionAuthorityRecord: {
      value: input.collectionAuthorityRecord ?? null,
      isWritable: true
    },
    newCollectionAuthority: {
      value: input.newCollectionAuthority ?? null,
      isWritable: false
    },
    updateAuthority: { value: input.updateAuthority ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    metadata: { value: input.metadata ?? null, isWritable: false },
    mint: { value: input.mint ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    rent: { value: input.rent ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "omitted");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.collectionAuthorityRecord),
      getAccountMeta(accounts.newCollectionAuthority),
      getAccountMeta(accounts.updateAuthority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.rent)
    ].filter((x) => x !== void 0),
    programAddress,
    data: getApproveCollectionAuthorityInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseApproveCollectionAuthorityInstruction(instruction) {
  if (instruction.accounts.length < 7) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  let optionalAccountsRemaining = instruction.accounts.length - 7;
  const getNextOptionalAccount = () => {
    if (optionalAccountsRemaining === 0) return void 0;
    optionalAccountsRemaining -= 1;
    return getNextAccount();
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      collectionAuthorityRecord: getNextAccount(),
      newCollectionAuthority: getNextAccount(),
      updateAuthority: getNextAccount(),
      payer: getNextAccount(),
      metadata: getNextAccount(),
      mint: getNextAccount(),
      systemProgram: getNextAccount(),
      rent: getNextOptionalAccount()
    },
    data: getApproveCollectionAuthorityInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getApproveUseAuthorityInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["numberOfUses", getU64Encoder()]
    ]),
    (value) => ({ ...value, discriminator: 20 })
  );
}
function getApproveUseAuthorityInstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["numberOfUses", getU64Decoder()]
  ]);
}
function getApproveUseAuthorityInstructionDataCodec() {
  return combineCodec(
    getApproveUseAuthorityInstructionDataEncoder(),
    getApproveUseAuthorityInstructionDataDecoder()
  );
}
function getApproveUseAuthorityInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    useAuthorityRecord: {
      value: input.useAuthorityRecord ?? null,
      isWritable: true
    },
    owner: { value: input.owner ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    user: { value: input.user ?? null, isWritable: false },
    ownerTokenAccount: {
      value: input.ownerTokenAccount ?? null,
      isWritable: true
    },
    metadata: { value: input.metadata ?? null, isWritable: false },
    mint: { value: input.mint ?? null, isWritable: false },
    burner: { value: input.burner ?? null, isWritable: false },
    tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    rent: { value: input.rent ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.tokenProgram.value) {
    accounts.tokenProgram.value = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
  }
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "omitted");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.useAuthorityRecord),
      getAccountMeta(accounts.owner),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.user),
      getAccountMeta(accounts.ownerTokenAccount),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.burner),
      getAccountMeta(accounts.tokenProgram),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.rent)
    ].filter((x) => x !== void 0),
    programAddress,
    data: getApproveUseAuthorityInstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseApproveUseAuthorityInstruction(instruction) {
  if (instruction.accounts.length < 10) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  let optionalAccountsRemaining = instruction.accounts.length - 10;
  const getNextOptionalAccount = () => {
    if (optionalAccountsRemaining === 0) return void 0;
    optionalAccountsRemaining -= 1;
    return getNextAccount();
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      useAuthorityRecord: getNextAccount(),
      owner: getNextAccount(),
      payer: getNextAccount(),
      user: getNextAccount(),
      ownerTokenAccount: getNextAccount(),
      metadata: getNextAccount(),
      mint: getNextAccount(),
      burner: getNextAccount(),
      tokenProgram: getNextAccount(),
      systemProgram: getNextAccount(),
      rent: getNextOptionalAccount()
    },
    data: getApproveUseAuthorityInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getBubblegumSetCollectionSizeInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["setCollectionSizeArgs", getSetCollectionSizeArgsEncoder()]
    ]),
    (value) => ({ ...value, discriminator: 36 })
  );
}
function getBubblegumSetCollectionSizeInstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["setCollectionSizeArgs", getSetCollectionSizeArgsDecoder()]
  ]);
}
function getBubblegumSetCollectionSizeInstructionDataCodec() {
  return combineCodec(
    getBubblegumSetCollectionSizeInstructionDataEncoder(),
    getBubblegumSetCollectionSizeInstructionDataDecoder()
  );
}
function getBubblegumSetCollectionSizeInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    collectionMetadata: {
      value: input.collectionMetadata ?? null,
      isWritable: true
    },
    collectionAuthority: {
      value: input.collectionAuthority ?? null,
      isWritable: false
    },
    collectionMint: { value: input.collectionMint ?? null, isWritable: false },
    bubblegumSigner: {
      value: input.bubblegumSigner ?? null,
      isWritable: false
    },
    collectionAuthorityRecord: {
      value: input.collectionAuthorityRecord ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  const getAccountMeta = getAccountMetaFactory(programAddress, "omitted");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.collectionMetadata),
      getAccountMeta(accounts.collectionAuthority),
      getAccountMeta(accounts.collectionMint),
      getAccountMeta(accounts.bubblegumSigner),
      getAccountMeta(accounts.collectionAuthorityRecord)
    ].filter((x) => x !== void 0),
    programAddress,
    data: getBubblegumSetCollectionSizeInstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseBubblegumSetCollectionSizeInstruction(instruction) {
  if (instruction.accounts.length < 4) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  let optionalAccountsRemaining = instruction.accounts.length - 4;
  const getNextOptionalAccount = () => {
    if (optionalAccountsRemaining === 0) return void 0;
    optionalAccountsRemaining -= 1;
    return getNextAccount();
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      collectionMetadata: getNextAccount(),
      collectionAuthority: getNextAccount(),
      collectionMint: getNextAccount(),
      bubblegumSigner: getNextAccount(),
      collectionAuthorityRecord: getNextOptionalAccount()
    },
    data: getBubblegumSetCollectionSizeInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getBurnInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["burnArgs", getBurnArgsEncoder()]
    ]),
    (value) => ({ ...value, discriminator: 41 })
  );
}
function getBurnInstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["burnArgs", getBurnArgsDecoder()]
  ]);
}
function getBurnInstructionDataCodec() {
  return combineCodec(
    getBurnInstructionDataEncoder(),
    getBurnInstructionDataDecoder()
  );
}
function getBurnInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    authority: { value: input.authority ?? null, isWritable: true },
    collectionMetadata: {
      value: input.collectionMetadata ?? null,
      isWritable: true
    },
    metadata: { value: input.metadata ?? null, isWritable: true },
    edition: { value: input.edition ?? null, isWritable: true },
    mint: { value: input.mint ?? null, isWritable: true },
    token: { value: input.token ?? null, isWritable: true },
    masterEdition: { value: input.masterEdition ?? null, isWritable: true },
    masterEditionMint: {
      value: input.masterEditionMint ?? null,
      isWritable: false
    },
    masterEditionToken: {
      value: input.masterEditionToken ?? null,
      isWritable: false
    },
    editionMarker: { value: input.editionMarker ?? null, isWritable: true },
    tokenRecord: { value: input.tokenRecord ?? null, isWritable: true },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    sysvarInstructions: {
      value: input.sysvarInstructions ?? null,
      isWritable: false
    },
    splTokenProgram: {
      value: input.splTokenProgram ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.sysvarInstructions.value) {
    accounts.sysvarInstructions.value = "Sysvar1nstructions1111111111111111111111111";
  }
  if (!accounts.splTokenProgram.value) {
    accounts.splTokenProgram.value = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.collectionMetadata),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.edition),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.token),
      getAccountMeta(accounts.masterEdition),
      getAccountMeta(accounts.masterEditionMint),
      getAccountMeta(accounts.masterEditionToken),
      getAccountMeta(accounts.editionMarker),
      getAccountMeta(accounts.tokenRecord),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.sysvarInstructions),
      getAccountMeta(accounts.splTokenProgram)
    ],
    programAddress,
    data: getBurnInstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseBurnInstruction(instruction) {
  if (instruction.accounts.length < 14) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === TOKEN_METADATA_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      authority: getNextAccount(),
      collectionMetadata: getNextOptionalAccount(),
      metadata: getNextAccount(),
      edition: getNextOptionalAccount(),
      mint: getNextAccount(),
      token: getNextAccount(),
      masterEdition: getNextOptionalAccount(),
      masterEditionMint: getNextOptionalAccount(),
      masterEditionToken: getNextOptionalAccount(),
      editionMarker: getNextOptionalAccount(),
      tokenRecord: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      sysvarInstructions: getNextAccount(),
      splTokenProgram: getNextAccount()
    },
    data: getBurnInstructionDataDecoder().decode(instruction.data)
  };
}
function getBurnEditionNftInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 37 })
  );
}
function getBurnEditionNftInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getBurnEditionNftInstructionDataCodec() {
  return combineCodec(
    getBurnEditionNftInstructionDataEncoder(),
    getBurnEditionNftInstructionDataDecoder()
  );
}
function getBurnEditionNftInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true },
    owner: { value: input.owner ?? null, isWritable: true },
    printEditionMint: {
      value: input.printEditionMint ?? null,
      isWritable: true
    },
    masterEditionMint: {
      value: input.masterEditionMint ?? null,
      isWritable: false
    },
    printEditionTokenAccount: {
      value: input.printEditionTokenAccount ?? null,
      isWritable: true
    },
    masterEditionTokenAccount: {
      value: input.masterEditionTokenAccount ?? null,
      isWritable: false
    },
    masterEditionAccount: {
      value: input.masterEditionAccount ?? null,
      isWritable: true
    },
    printEditionAccount: {
      value: input.printEditionAccount ?? null,
      isWritable: true
    },
    editionMarkerAccount: {
      value: input.editionMarkerAccount ?? null,
      isWritable: true
    },
    splTokenProgram: {
      value: input.splTokenProgram ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  if (!accounts.splTokenProgram.value) {
    accounts.splTokenProgram.value = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.owner),
      getAccountMeta(accounts.printEditionMint),
      getAccountMeta(accounts.masterEditionMint),
      getAccountMeta(accounts.printEditionTokenAccount),
      getAccountMeta(accounts.masterEditionTokenAccount),
      getAccountMeta(accounts.masterEditionAccount),
      getAccountMeta(accounts.printEditionAccount),
      getAccountMeta(accounts.editionMarkerAccount),
      getAccountMeta(accounts.splTokenProgram)
    ],
    programAddress,
    data: getBurnEditionNftInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseBurnEditionNftInstruction(instruction) {
  if (instruction.accounts.length < 10) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      metadata: getNextAccount(),
      owner: getNextAccount(),
      printEditionMint: getNextAccount(),
      masterEditionMint: getNextAccount(),
      printEditionTokenAccount: getNextAccount(),
      masterEditionTokenAccount: getNextAccount(),
      masterEditionAccount: getNextAccount(),
      printEditionAccount: getNextAccount(),
      editionMarkerAccount: getNextAccount(),
      splTokenProgram: getNextAccount()
    },
    data: getBurnEditionNftInstructionDataDecoder().decode(instruction.data)
  };
}
function getBurnNftInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 29 })
  );
}
function getBurnNftInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getBurnNftInstructionDataCodec() {
  return combineCodec(
    getBurnNftInstructionDataEncoder(),
    getBurnNftInstructionDataDecoder()
  );
}
function getBurnNftInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true },
    owner: { value: input.owner ?? null, isWritable: true },
    mint: { value: input.mint ?? null, isWritable: true },
    tokenAccount: { value: input.tokenAccount ?? null, isWritable: true },
    masterEditionAccount: {
      value: input.masterEditionAccount ?? null,
      isWritable: true
    },
    splTokenProgram: {
      value: input.splTokenProgram ?? null,
      isWritable: false
    },
    collectionMetadata: {
      value: input.collectionMetadata ?? null,
      isWritable: true
    }
  };
  const accounts = originalAccounts;
  if (!accounts.splTokenProgram.value) {
    accounts.splTokenProgram.value = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "omitted");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.owner),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.tokenAccount),
      getAccountMeta(accounts.masterEditionAccount),
      getAccountMeta(accounts.splTokenProgram),
      getAccountMeta(accounts.collectionMetadata)
    ].filter((x) => x !== void 0),
    programAddress,
    data: getBurnNftInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseBurnNftInstruction(instruction) {
  if (instruction.accounts.length < 6) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  let optionalAccountsRemaining = instruction.accounts.length - 6;
  const getNextOptionalAccount = () => {
    if (optionalAccountsRemaining === 0) return void 0;
    optionalAccountsRemaining -= 1;
    return getNextAccount();
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      metadata: getNextAccount(),
      owner: getNextAccount(),
      mint: getNextAccount(),
      tokenAccount: getNextAccount(),
      masterEditionAccount: getNextAccount(),
      splTokenProgram: getNextAccount(),
      collectionMetadata: getNextOptionalAccount()
    },
    data: getBurnNftInstructionDataDecoder().decode(instruction.data)
  };
}
function getCloseEscrowAccountInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 39 })
  );
}
function getCloseEscrowAccountInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getCloseEscrowAccountInstructionDataCodec() {
  return combineCodec(
    getCloseEscrowAccountInstructionDataEncoder(),
    getCloseEscrowAccountInstructionDataDecoder()
  );
}
function getCloseEscrowAccountInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    escrow: { value: input.escrow ?? null, isWritable: true },
    metadata: { value: input.metadata ?? null, isWritable: true },
    mint: { value: input.mint ?? null, isWritable: false },
    tokenAccount: { value: input.tokenAccount ?? null, isWritable: false },
    edition: { value: input.edition ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: true },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    sysvarInstructions: {
      value: input.sysvarInstructions ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.sysvarInstructions.value) {
    accounts.sysvarInstructions.value = "Sysvar1nstructions1111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.escrow),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.tokenAccount),
      getAccountMeta(accounts.edition),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.sysvarInstructions)
    ],
    programAddress,
    data: getCloseEscrowAccountInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseCloseEscrowAccountInstruction(instruction) {
  if (instruction.accounts.length < 8) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      escrow: getNextAccount(),
      metadata: getNextAccount(),
      mint: getNextAccount(),
      tokenAccount: getNextAccount(),
      edition: getNextAccount(),
      payer: getNextAccount(),
      systemProgram: getNextAccount(),
      sysvarInstructions: getNextAccount()
    },
    data: getCloseEscrowAccountInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getCollectInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 54 })
  );
}
function getCollectInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getCollectInstructionDataCodec() {
  return combineCodec(
    getCollectInstructionDataEncoder(),
    getCollectInstructionDataDecoder()
  );
}
function getCollectInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    authority: { value: input.authority ?? null, isWritable: false },
    recipient: { value: input.recipient ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.recipient)
    ],
    programAddress,
    data: getCollectInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseCollectInstruction(instruction) {
  if (instruction.accounts.length < 2) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      authority: getNextAccount(),
      recipient: getNextAccount()
    },
    data: getCollectInstructionDataDecoder().decode(instruction.data)
  };
}
function getConvertMasterEditionV1ToV2InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 12 })
  );
}
function getConvertMasterEditionV1ToV2InstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getConvertMasterEditionV1ToV2InstructionDataCodec() {
  return combineCodec(
    getConvertMasterEditionV1ToV2InstructionDataEncoder(),
    getConvertMasterEditionV1ToV2InstructionDataDecoder()
  );
}
function getConvertMasterEditionV1ToV2Instruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    masterEdition: { value: input.masterEdition ?? null, isWritable: true },
    oneTimeAuth: { value: input.oneTimeAuth ?? null, isWritable: true },
    printingMint: { value: input.printingMint ?? null, isWritable: true }
  };
  const accounts = originalAccounts;
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.masterEdition),
      getAccountMeta(accounts.oneTimeAuth),
      getAccountMeta(accounts.printingMint)
    ],
    programAddress,
    data: getConvertMasterEditionV1ToV2InstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseConvertMasterEditionV1ToV2Instruction(instruction) {
  if (instruction.accounts.length < 3) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      masterEdition: getNextAccount(),
      oneTimeAuth: getNextAccount(),
      printingMint: getNextAccount()
    },
    data: getConvertMasterEditionV1ToV2InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getCreateEscrowAccountInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 38 })
  );
}
function getCreateEscrowAccountInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getCreateEscrowAccountInstructionDataCodec() {
  return combineCodec(
    getCreateEscrowAccountInstructionDataEncoder(),
    getCreateEscrowAccountInstructionDataDecoder()
  );
}
function getCreateEscrowAccountInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    escrow: { value: input.escrow ?? null, isWritable: true },
    metadata: { value: input.metadata ?? null, isWritable: true },
    mint: { value: input.mint ?? null, isWritable: false },
    tokenAccount: { value: input.tokenAccount ?? null, isWritable: false },
    edition: { value: input.edition ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: true },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    sysvarInstructions: {
      value: input.sysvarInstructions ?? null,
      isWritable: false
    },
    authority: { value: input.authority ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.sysvarInstructions.value) {
    accounts.sysvarInstructions.value = "Sysvar1nstructions1111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "omitted");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.escrow),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.tokenAccount),
      getAccountMeta(accounts.edition),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.sysvarInstructions),
      getAccountMeta(accounts.authority)
    ].filter((x) => x !== void 0),
    programAddress,
    data: getCreateEscrowAccountInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseCreateEscrowAccountInstruction(instruction) {
  if (instruction.accounts.length < 8) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  let optionalAccountsRemaining = instruction.accounts.length - 8;
  const getNextOptionalAccount = () => {
    if (optionalAccountsRemaining === 0) return void 0;
    optionalAccountsRemaining -= 1;
    return getNextAccount();
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      escrow: getNextAccount(),
      metadata: getNextAccount(),
      mint: getNextAccount(),
      tokenAccount: getNextAccount(),
      edition: getNextAccount(),
      payer: getNextAccount(),
      systemProgram: getNextAccount(),
      sysvarInstructions: getNextAccount(),
      authority: getNextOptionalAccount()
    },
    data: getCreateEscrowAccountInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getCreateMasterEditionInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 10 })
  );
}
function getCreateMasterEditionInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getCreateMasterEditionInstructionDataCodec() {
  return combineCodec(
    getCreateMasterEditionInstructionDataEncoder(),
    getCreateMasterEditionInstructionDataDecoder()
  );
}
function getCreateMasterEditionInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    edition: { value: input.edition ?? null, isWritable: true },
    mint: { value: input.mint ?? null, isWritable: true },
    updateAuthority: {
      value: input.updateAuthority ?? null,
      isWritable: false
    },
    mintAuthority: { value: input.mintAuthority ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: true },
    metadata: { value: input.metadata ?? null, isWritable: false },
    tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    rent: { value: input.rent ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  if (!accounts.tokenProgram.value) {
    accounts.tokenProgram.value = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
  }
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.rent.value) {
    accounts.rent.value = "SysvarRent111111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.edition),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.updateAuthority),
      getAccountMeta(accounts.mintAuthority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.tokenProgram),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.rent)
    ],
    programAddress,
    data: getCreateMasterEditionInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseCreateMasterEditionInstruction(instruction) {
  if (instruction.accounts.length < 9) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      edition: getNextAccount(),
      mint: getNextAccount(),
      updateAuthority: getNextAccount(),
      mintAuthority: getNextAccount(),
      payer: getNextAccount(),
      metadata: getNextAccount(),
      tokenProgram: getNextAccount(),
      systemProgram: getNextAccount(),
      rent: getNextAccount()
    },
    data: getCreateMasterEditionInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getCreateMasterEditionV3InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["maxSupply", getOptionEncoder(getU64Encoder())]
    ]),
    (value) => ({ ...value, discriminator: 17 })
  );
}
function getCreateMasterEditionV3InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["maxSupply", getOptionDecoder(getU64Decoder())]
  ]);
}
function getCreateMasterEditionV3InstructionDataCodec() {
  return combineCodec(
    getCreateMasterEditionV3InstructionDataEncoder(),
    getCreateMasterEditionV3InstructionDataDecoder()
  );
}
function getCreateMasterEditionV3Instruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    edition: { value: input.edition ?? null, isWritable: true },
    mint: { value: input.mint ?? null, isWritable: true },
    updateAuthority: {
      value: input.updateAuthority ?? null,
      isWritable: false
    },
    mintAuthority: { value: input.mintAuthority ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: true },
    metadata: { value: input.metadata ?? null, isWritable: true },
    tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    rent: { value: input.rent ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.tokenProgram.value) {
    accounts.tokenProgram.value = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
  }
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "omitted");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.edition),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.updateAuthority),
      getAccountMeta(accounts.mintAuthority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.tokenProgram),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.rent)
    ].filter((x) => x !== void 0),
    programAddress,
    data: getCreateMasterEditionV3InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseCreateMasterEditionV3Instruction(instruction) {
  if (instruction.accounts.length < 8) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  let optionalAccountsRemaining = instruction.accounts.length - 8;
  const getNextOptionalAccount = () => {
    if (optionalAccountsRemaining === 0) return void 0;
    optionalAccountsRemaining -= 1;
    return getNextAccount();
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      edition: getNextAccount(),
      mint: getNextAccount(),
      updateAuthority: getNextAccount(),
      mintAuthority: getNextAccount(),
      payer: getNextAccount(),
      metadata: getNextAccount(),
      tokenProgram: getNextAccount(),
      systemProgram: getNextAccount(),
      rent: getNextOptionalAccount()
    },
    data: getCreateMasterEditionV3InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getCreateMetadataAccountInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 0 })
  );
}
function getCreateMetadataAccountInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getCreateMetadataAccountInstructionDataCodec() {
  return combineCodec(
    getCreateMetadataAccountInstructionDataEncoder(),
    getCreateMetadataAccountInstructionDataDecoder()
  );
}
function getCreateMetadataAccountInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true },
    mint: { value: input.mint ?? null, isWritable: false },
    mintAuthority: { value: input.mintAuthority ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: true },
    updateAuthority: {
      value: input.updateAuthority ?? null,
      isWritable: false
    },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    rent: { value: input.rent ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.rent.value) {
    accounts.rent.value = "SysvarRent111111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.mintAuthority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.updateAuthority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.rent)
    ],
    programAddress,
    data: getCreateMetadataAccountInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseCreateMetadataAccountInstruction(instruction) {
  if (instruction.accounts.length < 7) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      metadata: getNextAccount(),
      mint: getNextAccount(),
      mintAuthority: getNextAccount(),
      payer: getNextAccount(),
      updateAuthority: getNextAccount(),
      systemProgram: getNextAccount(),
      rent: getNextAccount()
    },
    data: getCreateMetadataAccountInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getCreateMetadataAccountV2InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 16 })
  );
}
function getCreateMetadataAccountV2InstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getCreateMetadataAccountV2InstructionDataCodec() {
  return combineCodec(
    getCreateMetadataAccountV2InstructionDataEncoder(),
    getCreateMetadataAccountV2InstructionDataDecoder()
  );
}
function getCreateMetadataAccountV2Instruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true },
    mint: { value: input.mint ?? null, isWritable: false },
    mintAuthority: { value: input.mintAuthority ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: true },
    updateAuthority: {
      value: input.updateAuthority ?? null,
      isWritable: false
    },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    rent: { value: input.rent ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "omitted");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.mintAuthority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.updateAuthority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.rent)
    ].filter((x) => x !== void 0),
    programAddress,
    data: getCreateMetadataAccountV2InstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseCreateMetadataAccountV2Instruction(instruction) {
  if (instruction.accounts.length < 6) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  let optionalAccountsRemaining = instruction.accounts.length - 6;
  const getNextOptionalAccount = () => {
    if (optionalAccountsRemaining === 0) return void 0;
    optionalAccountsRemaining -= 1;
    return getNextAccount();
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      metadata: getNextAccount(),
      mint: getNextAccount(),
      mintAuthority: getNextAccount(),
      payer: getNextAccount(),
      updateAuthority: getNextAccount(),
      systemProgram: getNextAccount(),
      rent: getNextOptionalAccount()
    },
    data: getCreateMetadataAccountV2InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getCreateMetadataAccountV3InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["data", getDataV2Encoder()],
      ["isMutable", getBooleanEncoder()],
      ["collectionDetails", getOptionEncoder(getCollectionDetailsEncoder())]
    ]),
    (value) => ({ ...value, discriminator: 33 })
  );
}
function getCreateMetadataAccountV3InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["data", getDataV2Decoder()],
    ["isMutable", getBooleanDecoder()],
    ["collectionDetails", getOptionDecoder(getCollectionDetailsDecoder())]
  ]);
}
function getCreateMetadataAccountV3InstructionDataCodec() {
  return combineCodec(
    getCreateMetadataAccountV3InstructionDataEncoder(),
    getCreateMetadataAccountV3InstructionDataDecoder()
  );
}
function getCreateMetadataAccountV3Instruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true },
    mint: { value: input.mint ?? null, isWritable: false },
    mintAuthority: { value: input.mintAuthority ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: true },
    updateAuthority: {
      value: input.updateAuthority ?? null,
      isWritable: false
    },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    rent: { value: input.rent ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "omitted");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.mintAuthority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.updateAuthority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.rent)
    ].filter((x) => x !== void 0),
    programAddress,
    data: getCreateMetadataAccountV3InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseCreateMetadataAccountV3Instruction(instruction) {
  if (instruction.accounts.length < 6) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  let optionalAccountsRemaining = instruction.accounts.length - 6;
  const getNextOptionalAccount = () => {
    if (optionalAccountsRemaining === 0) return void 0;
    optionalAccountsRemaining -= 1;
    return getNextAccount();
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      metadata: getNextAccount(),
      mint: getNextAccount(),
      mintAuthority: getNextAccount(),
      payer: getNextAccount(),
      updateAuthority: getNextAccount(),
      systemProgram: getNextAccount(),
      rent: getNextOptionalAccount()
    },
    data: getCreateMetadataAccountV3InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getCreateV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["createV1Discriminator", getU8Encoder()],
      ["name", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
      ["symbol", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
      ["uri", addEncoderSizePrefix(getUtf8Encoder(), getU32Encoder())],
      ["sellerFeeBasisPoints", getU16Encoder()],
      ["creators", getOptionEncoder(getArrayEncoder(getCreatorEncoder()))],
      ["primarySaleHappened", getBooleanEncoder()],
      ["isMutable", getBooleanEncoder()],
      ["tokenStandard", getTokenStandardEncoder()],
      ["collection", getOptionEncoder(getCollectionEncoder())],
      ["uses", getOptionEncoder(getUsesEncoder())],
      ["collectionDetails", getOptionEncoder(getCollectionDetailsEncoder())],
      ["ruleSet", getOptionEncoder(getAddressEncoder())],
      ["decimals", getOptionEncoder(getU8Encoder())],
      ["printSupply", getOptionEncoder(getPrintSupplyEncoder())]
    ]),
    (value) => ({ ...value, discriminator: 42, createV1Discriminator: 0 })
  );
}
function getCreateV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["createV1Discriminator", getU8Decoder()],
    ["name", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["symbol", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["uri", addDecoderSizePrefix(getUtf8Decoder(), getU32Decoder())],
    ["sellerFeeBasisPoints", getU16Decoder()],
    ["creators", getOptionDecoder(getArrayDecoder(getCreatorDecoder()))],
    ["primarySaleHappened", getBooleanDecoder()],
    ["isMutable", getBooleanDecoder()],
    ["tokenStandard", getTokenStandardDecoder()],
    ["collection", getOptionDecoder(getCollectionDecoder())],
    ["uses", getOptionDecoder(getUsesDecoder())],
    ["collectionDetails", getOptionDecoder(getCollectionDetailsDecoder())],
    ["ruleSet", getOptionDecoder(getAddressDecoder())],
    ["decimals", getOptionDecoder(getU8Decoder())],
    ["printSupply", getOptionDecoder(getPrintSupplyDecoder())]
  ]);
}
function getCreateV1InstructionDataCodec() {
  return combineCodec(
    getCreateV1InstructionDataEncoder(),
    getCreateV1InstructionDataDecoder()
  );
}
async function getCreateV1InstructionAsync(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true },
    masterEdition: { value: input.masterEdition ?? null, isWritable: true },
    mint: { value: input.mint ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: true },
    updateAuthority: {
      value: input.updateAuthority ?? null,
      isWritable: false
    },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    sysvarInstructions: {
      value: input.sysvarInstructions ?? null,
      isWritable: false
    },
    splTokenProgram: {
      value: input.splTokenProgram ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.masterEdition.value) {
    accounts.masterEdition.value = await findMasterEditionPda({
      mint: expectAddress(accounts.mint.value)
    });
  }
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.sysvarInstructions.value) {
    accounts.sysvarInstructions.value = "Sysvar1nstructions1111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.masterEdition),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.updateAuthority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.sysvarInstructions),
      getAccountMeta(accounts.splTokenProgram)
    ],
    programAddress,
    data: getCreateV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function getCreateV1Instruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true },
    masterEdition: { value: input.masterEdition ?? null, isWritable: true },
    mint: { value: input.mint ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: true },
    updateAuthority: {
      value: input.updateAuthority ?? null,
      isWritable: false
    },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    sysvarInstructions: {
      value: input.sysvarInstructions ?? null,
      isWritable: false
    },
    splTokenProgram: {
      value: input.splTokenProgram ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.sysvarInstructions.value) {
    accounts.sysvarInstructions.value = "Sysvar1nstructions1111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.masterEdition),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.updateAuthority),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.sysvarInstructions),
      getAccountMeta(accounts.splTokenProgram)
    ],
    programAddress,
    data: getCreateV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseCreateV1Instruction(instruction) {
  if (instruction.accounts.length < 9) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === TOKEN_METADATA_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      metadata: getNextAccount(),
      masterEdition: getNextOptionalAccount(),
      mint: getNextAccount(),
      authority: getNextAccount(),
      payer: getNextAccount(),
      updateAuthority: getNextAccount(),
      systemProgram: getNextAccount(),
      sysvarInstructions: getNextAccount(),
      splTokenProgram: getNextOptionalAccount()
    },
    data: getCreateV1InstructionDataDecoder().decode(instruction.data)
  };
}
function getDelegateInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["delegateArgs", getDelegateArgsEncoder()]
    ]),
    (value) => ({ ...value, discriminator: 44 })
  );
}
function getDelegateInstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["delegateArgs", getDelegateArgsDecoder()]
  ]);
}
function getDelegateInstructionDataCodec() {
  return combineCodec(
    getDelegateInstructionDataEncoder(),
    getDelegateInstructionDataDecoder()
  );
}
function getDelegateInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    delegateRecord: { value: input.delegateRecord ?? null, isWritable: true },
    delegate: { value: input.delegate ?? null, isWritable: false },
    metadata: { value: input.metadata ?? null, isWritable: true },
    masterEdition: { value: input.masterEdition ?? null, isWritable: false },
    tokenRecord: { value: input.tokenRecord ?? null, isWritable: true },
    mint: { value: input.mint ?? null, isWritable: false },
    token: { value: input.token ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: true },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    sysvarInstructions: {
      value: input.sysvarInstructions ?? null,
      isWritable: false
    },
    splTokenProgram: {
      value: input.splTokenProgram ?? null,
      isWritable: false
    },
    authorizationRulesProgram: {
      value: input.authorizationRulesProgram ?? null,
      isWritable: false
    },
    authorizationRules: {
      value: input.authorizationRules ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.sysvarInstructions.value) {
    accounts.sysvarInstructions.value = "Sysvar1nstructions1111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.delegateRecord),
      getAccountMeta(accounts.delegate),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.masterEdition),
      getAccountMeta(accounts.tokenRecord),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.token),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.sysvarInstructions),
      getAccountMeta(accounts.splTokenProgram),
      getAccountMeta(accounts.authorizationRulesProgram),
      getAccountMeta(accounts.authorizationRules)
    ],
    programAddress,
    data: getDelegateInstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseDelegateInstruction(instruction) {
  if (instruction.accounts.length < 14) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === TOKEN_METADATA_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      delegateRecord: getNextOptionalAccount(),
      delegate: getNextAccount(),
      metadata: getNextAccount(),
      masterEdition: getNextOptionalAccount(),
      tokenRecord: getNextOptionalAccount(),
      mint: getNextAccount(),
      token: getNextOptionalAccount(),
      authority: getNextAccount(),
      payer: getNextAccount(),
      systemProgram: getNextAccount(),
      sysvarInstructions: getNextAccount(),
      splTokenProgram: getNextOptionalAccount(),
      authorizationRulesProgram: getNextOptionalAccount(),
      authorizationRules: getNextOptionalAccount()
    },
    data: getDelegateInstructionDataDecoder().decode(instruction.data)
  };
}
function getDeprecatedCreateMasterEditionInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 2 })
  );
}
function getDeprecatedCreateMasterEditionInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getDeprecatedCreateMasterEditionInstructionDataCodec() {
  return combineCodec(
    getDeprecatedCreateMasterEditionInstructionDataEncoder(),
    getDeprecatedCreateMasterEditionInstructionDataDecoder()
  );
}
function getDeprecatedCreateMasterEditionInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    edition: { value: input.edition ?? null, isWritable: true },
    mint: { value: input.mint ?? null, isWritable: true },
    printingMint: { value: input.printingMint ?? null, isWritable: true },
    oneTimePrintingAuthorizationMint: {
      value: input.oneTimePrintingAuthorizationMint ?? null,
      isWritable: true
    },
    updateAuthority: {
      value: input.updateAuthority ?? null,
      isWritable: false
    },
    printingMintAuthority: {
      value: input.printingMintAuthority ?? null,
      isWritable: false
    },
    mintAuthority: { value: input.mintAuthority ?? null, isWritable: false },
    metadata: { value: input.metadata ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: false },
    tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    rent: { value: input.rent ?? null, isWritable: false },
    oneTimePrintingAuthorizationMintAuthority: {
      value: input.oneTimePrintingAuthorizationMintAuthority ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  if (!accounts.tokenProgram.value) {
    accounts.tokenProgram.value = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
  }
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.rent.value) {
    accounts.rent.value = "SysvarRent111111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.edition),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.printingMint),
      getAccountMeta(accounts.oneTimePrintingAuthorizationMint),
      getAccountMeta(accounts.updateAuthority),
      getAccountMeta(accounts.printingMintAuthority),
      getAccountMeta(accounts.mintAuthority),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.tokenProgram),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.rent),
      getAccountMeta(accounts.oneTimePrintingAuthorizationMintAuthority)
    ],
    programAddress,
    data: getDeprecatedCreateMasterEditionInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseDeprecatedCreateMasterEditionInstruction(instruction) {
  if (instruction.accounts.length < 13) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      edition: getNextAccount(),
      mint: getNextAccount(),
      printingMint: getNextAccount(),
      oneTimePrintingAuthorizationMint: getNextAccount(),
      updateAuthority: getNextAccount(),
      printingMintAuthority: getNextAccount(),
      mintAuthority: getNextAccount(),
      metadata: getNextAccount(),
      payer: getNextAccount(),
      tokenProgram: getNextAccount(),
      systemProgram: getNextAccount(),
      rent: getNextAccount(),
      oneTimePrintingAuthorizationMintAuthority: getNextAccount()
    },
    data: getDeprecatedCreateMasterEditionInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getDeprecatedCreateReservationListInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 6 })
  );
}
function getDeprecatedCreateReservationListInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getDeprecatedCreateReservationListInstructionDataCodec() {
  return combineCodec(
    getDeprecatedCreateReservationListInstructionDataEncoder(),
    getDeprecatedCreateReservationListInstructionDataDecoder()
  );
}
function getDeprecatedCreateReservationListInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    reservationList: { value: input.reservationList ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: false },
    updateAuthority: {
      value: input.updateAuthority ?? null,
      isWritable: false
    },
    masterEdition: { value: input.masterEdition ?? null, isWritable: false },
    resource: { value: input.resource ?? null, isWritable: false },
    metadata: { value: input.metadata ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    rent: { value: input.rent ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.rent.value) {
    accounts.rent.value = "SysvarRent111111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.reservationList),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.updateAuthority),
      getAccountMeta(accounts.masterEdition),
      getAccountMeta(accounts.resource),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.rent)
    ],
    programAddress,
    data: getDeprecatedCreateReservationListInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseDeprecatedCreateReservationListInstruction(instruction) {
  if (instruction.accounts.length < 8) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      reservationList: getNextAccount(),
      payer: getNextAccount(),
      updateAuthority: getNextAccount(),
      masterEdition: getNextAccount(),
      resource: getNextAccount(),
      metadata: getNextAccount(),
      systemProgram: getNextAccount(),
      rent: getNextAccount()
    },
    data: getDeprecatedCreateReservationListInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getDeprecatedMintNewEditionFromMasterEditionViaPrintingTokenInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 3 })
  );
}
function getDeprecatedMintNewEditionFromMasterEditionViaPrintingTokenInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getDeprecatedMintNewEditionFromMasterEditionViaPrintingTokenInstructionDataCodec() {
  return combineCodec(
    getDeprecatedMintNewEditionFromMasterEditionViaPrintingTokenInstructionDataEncoder(),
    getDeprecatedMintNewEditionFromMasterEditionViaPrintingTokenInstructionDataDecoder()
  );
}
function getDeprecatedMintNewEditionFromMasterEditionViaPrintingTokenInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true },
    edition: { value: input.edition ?? null, isWritable: true },
    masterEdition: { value: input.masterEdition ?? null, isWritable: true },
    mint: { value: input.mint ?? null, isWritable: true },
    mintAuthority: { value: input.mintAuthority ?? null, isWritable: false },
    printingMint: { value: input.printingMint ?? null, isWritable: true },
    masterTokenAccount: {
      value: input.masterTokenAccount ?? null,
      isWritable: true
    },
    editionMarker: { value: input.editionMarker ?? null, isWritable: true },
    burnAuthority: { value: input.burnAuthority ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: false },
    masterUpdateAuthority: {
      value: input.masterUpdateAuthority ?? null,
      isWritable: false
    },
    masterMetadata: { value: input.masterMetadata ?? null, isWritable: false },
    tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    rent: { value: input.rent ?? null, isWritable: false },
    reservationList: { value: input.reservationList ?? null, isWritable: true }
  };
  const accounts = originalAccounts;
  if (!accounts.tokenProgram.value) {
    accounts.tokenProgram.value = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
  }
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.rent.value) {
    accounts.rent.value = "SysvarRent111111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "omitted");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.edition),
      getAccountMeta(accounts.masterEdition),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.mintAuthority),
      getAccountMeta(accounts.printingMint),
      getAccountMeta(accounts.masterTokenAccount),
      getAccountMeta(accounts.editionMarker),
      getAccountMeta(accounts.burnAuthority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.masterUpdateAuthority),
      getAccountMeta(accounts.masterMetadata),
      getAccountMeta(accounts.tokenProgram),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.rent),
      getAccountMeta(accounts.reservationList)
    ].filter((x) => x !== void 0),
    programAddress,
    data: getDeprecatedMintNewEditionFromMasterEditionViaPrintingTokenInstructionDataEncoder().encode(
      {}
    )
  };
  return instruction;
}
function parseDeprecatedMintNewEditionFromMasterEditionViaPrintingTokenInstruction(instruction) {
  if (instruction.accounts.length < 15) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  let optionalAccountsRemaining = instruction.accounts.length - 15;
  const getNextOptionalAccount = () => {
    if (optionalAccountsRemaining === 0) return void 0;
    optionalAccountsRemaining -= 1;
    return getNextAccount();
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      metadata: getNextAccount(),
      edition: getNextAccount(),
      masterEdition: getNextAccount(),
      mint: getNextAccount(),
      mintAuthority: getNextAccount(),
      printingMint: getNextAccount(),
      masterTokenAccount: getNextAccount(),
      editionMarker: getNextAccount(),
      burnAuthority: getNextAccount(),
      payer: getNextAccount(),
      masterUpdateAuthority: getNextAccount(),
      masterMetadata: getNextAccount(),
      tokenProgram: getNextAccount(),
      systemProgram: getNextAccount(),
      rent: getNextAccount(),
      reservationList: getNextOptionalAccount()
    },
    data: getDeprecatedMintNewEditionFromMasterEditionViaPrintingTokenInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getDeprecatedMintPrintingTokensInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 9 })
  );
}
function getDeprecatedMintPrintingTokensInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getDeprecatedMintPrintingTokensInstructionDataCodec() {
  return combineCodec(
    getDeprecatedMintPrintingTokensInstructionDataEncoder(),
    getDeprecatedMintPrintingTokensInstructionDataDecoder()
  );
}
function getDeprecatedMintPrintingTokensInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    destination: { value: input.destination ?? null, isWritable: true },
    printingMint: { value: input.printingMint ?? null, isWritable: true },
    updateAuthority: {
      value: input.updateAuthority ?? null,
      isWritable: false
    },
    metadata: { value: input.metadata ?? null, isWritable: false },
    masterEdition: { value: input.masterEdition ?? null, isWritable: false },
    tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
    rent: { value: input.rent ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  if (!accounts.tokenProgram.value) {
    accounts.tokenProgram.value = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
  }
  if (!accounts.rent.value) {
    accounts.rent.value = "SysvarRent111111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.destination),
      getAccountMeta(accounts.printingMint),
      getAccountMeta(accounts.updateAuthority),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.masterEdition),
      getAccountMeta(accounts.tokenProgram),
      getAccountMeta(accounts.rent)
    ],
    programAddress,
    data: getDeprecatedMintPrintingTokensInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseDeprecatedMintPrintingTokensInstruction(instruction) {
  if (instruction.accounts.length < 7) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      destination: getNextAccount(),
      printingMint: getNextAccount(),
      updateAuthority: getNextAccount(),
      metadata: getNextAccount(),
      masterEdition: getNextAccount(),
      tokenProgram: getNextAccount(),
      rent: getNextAccount()
    },
    data: getDeprecatedMintPrintingTokensInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getDeprecatedMintPrintingTokensViaTokenInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 8 })
  );
}
function getDeprecatedMintPrintingTokensViaTokenInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getDeprecatedMintPrintingTokensViaTokenInstructionDataCodec() {
  return combineCodec(
    getDeprecatedMintPrintingTokensViaTokenInstructionDataEncoder(),
    getDeprecatedMintPrintingTokensViaTokenInstructionDataDecoder()
  );
}
function getDeprecatedMintPrintingTokensViaTokenInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    destination: { value: input.destination ?? null, isWritable: true },
    token: { value: input.token ?? null, isWritable: true },
    oneTimePrintingAuthorizationMint: {
      value: input.oneTimePrintingAuthorizationMint ?? null,
      isWritable: true
    },
    printingMint: { value: input.printingMint ?? null, isWritable: true },
    burnAuthority: { value: input.burnAuthority ?? null, isWritable: false },
    metadata: { value: input.metadata ?? null, isWritable: false },
    masterEdition: { value: input.masterEdition ?? null, isWritable: false },
    tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
    rent: { value: input.rent ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  if (!accounts.tokenProgram.value) {
    accounts.tokenProgram.value = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
  }
  if (!accounts.rent.value) {
    accounts.rent.value = "SysvarRent111111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.destination),
      getAccountMeta(accounts.token),
      getAccountMeta(accounts.oneTimePrintingAuthorizationMint),
      getAccountMeta(accounts.printingMint),
      getAccountMeta(accounts.burnAuthority),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.masterEdition),
      getAccountMeta(accounts.tokenProgram),
      getAccountMeta(accounts.rent)
    ],
    programAddress,
    data: getDeprecatedMintPrintingTokensViaTokenInstructionDataEncoder().encode(
      {}
    )
  };
  return instruction;
}
function parseDeprecatedMintPrintingTokensViaTokenInstruction(instruction) {
  if (instruction.accounts.length < 9) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      destination: getNextAccount(),
      token: getNextAccount(),
      oneTimePrintingAuthorizationMint: getNextAccount(),
      printingMint: getNextAccount(),
      burnAuthority: getNextAccount(),
      metadata: getNextAccount(),
      masterEdition: getNextAccount(),
      tokenProgram: getNextAccount(),
      rent: getNextAccount()
    },
    data: getDeprecatedMintPrintingTokensViaTokenInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getDeprecatedSetReservationListInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 5 })
  );
}
function getDeprecatedSetReservationListInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getDeprecatedSetReservationListInstructionDataCodec() {
  return combineCodec(
    getDeprecatedSetReservationListInstructionDataEncoder(),
    getDeprecatedSetReservationListInstructionDataDecoder()
  );
}
function getDeprecatedSetReservationListInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    masterEdition: { value: input.masterEdition ?? null, isWritable: true },
    reservationList: { value: input.reservationList ?? null, isWritable: true },
    resource: { value: input.resource ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.masterEdition),
      getAccountMeta(accounts.reservationList),
      getAccountMeta(accounts.resource)
    ],
    programAddress,
    data: getDeprecatedSetReservationListInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseDeprecatedSetReservationListInstruction(instruction) {
  if (instruction.accounts.length < 3) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      masterEdition: getNextAccount(),
      reservationList: getNextAccount(),
      resource: getNextAccount()
    },
    data: getDeprecatedSetReservationListInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getFreezeDelegatedAccountInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 26 })
  );
}
function getFreezeDelegatedAccountInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getFreezeDelegatedAccountInstructionDataCodec() {
  return combineCodec(
    getFreezeDelegatedAccountInstructionDataEncoder(),
    getFreezeDelegatedAccountInstructionDataDecoder()
  );
}
function getFreezeDelegatedAccountInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    delegate: { value: input.delegate ?? null, isWritable: true },
    tokenAccount: { value: input.tokenAccount ?? null, isWritable: true },
    edition: { value: input.edition ?? null, isWritable: false },
    mint: { value: input.mint ?? null, isWritable: false },
    tokenProgram: { value: input.tokenProgram ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  if (!accounts.tokenProgram.value) {
    accounts.tokenProgram.value = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.delegate),
      getAccountMeta(accounts.tokenAccount),
      getAccountMeta(accounts.edition),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.tokenProgram)
    ],
    programAddress,
    data: getFreezeDelegatedAccountInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseFreezeDelegatedAccountInstruction(instruction) {
  if (instruction.accounts.length < 5) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      delegate: getNextAccount(),
      tokenAccount: getNextAccount(),
      edition: getNextAccount(),
      mint: getNextAccount(),
      tokenProgram: getNextAccount()
    },
    data: getFreezeDelegatedAccountInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getLockInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["lockArgs", getLockArgsEncoder()]
    ]),
    (value) => ({ ...value, discriminator: 46 })
  );
}
function getLockInstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["lockArgs", getLockArgsDecoder()]
  ]);
}
function getLockInstructionDataCodec() {
  return combineCodec(
    getLockInstructionDataEncoder(),
    getLockInstructionDataDecoder()
  );
}
function getLockInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    authority: { value: input.authority ?? null, isWritable: false },
    tokenOwner: { value: input.tokenOwner ?? null, isWritable: false },
    token: { value: input.token ?? null, isWritable: true },
    mint: { value: input.mint ?? null, isWritable: false },
    metadata: { value: input.metadata ?? null, isWritable: true },
    edition: { value: input.edition ?? null, isWritable: false },
    tokenRecord: { value: input.tokenRecord ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    sysvarInstructions: {
      value: input.sysvarInstructions ?? null,
      isWritable: false
    },
    splTokenProgram: {
      value: input.splTokenProgram ?? null,
      isWritable: false
    },
    authorizationRulesProgram: {
      value: input.authorizationRulesProgram ?? null,
      isWritable: false
    },
    authorizationRules: {
      value: input.authorizationRules ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.sysvarInstructions.value) {
    accounts.sysvarInstructions.value = "Sysvar1nstructions1111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.tokenOwner),
      getAccountMeta(accounts.token),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.edition),
      getAccountMeta(accounts.tokenRecord),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.sysvarInstructions),
      getAccountMeta(accounts.splTokenProgram),
      getAccountMeta(accounts.authorizationRulesProgram),
      getAccountMeta(accounts.authorizationRules)
    ],
    programAddress,
    data: getLockInstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseLockInstruction(instruction) {
  if (instruction.accounts.length < 13) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === TOKEN_METADATA_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      authority: getNextAccount(),
      tokenOwner: getNextOptionalAccount(),
      token: getNextAccount(),
      mint: getNextAccount(),
      metadata: getNextAccount(),
      edition: getNextOptionalAccount(),
      tokenRecord: getNextOptionalAccount(),
      payer: getNextAccount(),
      systemProgram: getNextAccount(),
      sysvarInstructions: getNextAccount(),
      splTokenProgram: getNextOptionalAccount(),
      authorizationRulesProgram: getNextOptionalAccount(),
      authorizationRules: getNextOptionalAccount()
    },
    data: getLockInstructionDataDecoder().decode(instruction.data)
  };
}
function getMigrateInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 48 })
  );
}
function getMigrateInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getMigrateInstructionDataCodec() {
  return combineCodec(
    getMigrateInstructionDataEncoder(),
    getMigrateInstructionDataDecoder()
  );
}
function getMigrateInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true },
    edition: { value: input.edition ?? null, isWritable: true },
    token: { value: input.token ?? null, isWritable: true },
    tokenOwner: { value: input.tokenOwner ?? null, isWritable: false },
    mint: { value: input.mint ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    collectionMetadata: {
      value: input.collectionMetadata ?? null,
      isWritable: false
    },
    delegateRecord: { value: input.delegateRecord ?? null, isWritable: false },
    tokenRecord: { value: input.tokenRecord ?? null, isWritable: true },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    sysvarInstructions: {
      value: input.sysvarInstructions ?? null,
      isWritable: false
    },
    splTokenProgram: {
      value: input.splTokenProgram ?? null,
      isWritable: false
    },
    authorizationRulesProgram: {
      value: input.authorizationRulesProgram ?? null,
      isWritable: false
    },
    authorizationRules: {
      value: input.authorizationRules ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.sysvarInstructions.value) {
    accounts.sysvarInstructions.value = "Sysvar1nstructions1111111111111111111111111";
  }
  if (!accounts.splTokenProgram.value) {
    accounts.splTokenProgram.value = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.edition),
      getAccountMeta(accounts.token),
      getAccountMeta(accounts.tokenOwner),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.collectionMetadata),
      getAccountMeta(accounts.delegateRecord),
      getAccountMeta(accounts.tokenRecord),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.sysvarInstructions),
      getAccountMeta(accounts.splTokenProgram),
      getAccountMeta(accounts.authorizationRulesProgram),
      getAccountMeta(accounts.authorizationRules)
    ],
    programAddress,
    data: getMigrateInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseMigrateInstruction(instruction) {
  if (instruction.accounts.length < 15) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === TOKEN_METADATA_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      metadata: getNextAccount(),
      edition: getNextAccount(),
      token: getNextAccount(),
      tokenOwner: getNextAccount(),
      mint: getNextAccount(),
      payer: getNextAccount(),
      authority: getNextAccount(),
      collectionMetadata: getNextAccount(),
      delegateRecord: getNextAccount(),
      tokenRecord: getNextAccount(),
      systemProgram: getNextAccount(),
      sysvarInstructions: getNextAccount(),
      splTokenProgram: getNextAccount(),
      authorizationRulesProgram: getNextOptionalAccount(),
      authorizationRules: getNextOptionalAccount()
    },
    data: getMigrateInstructionDataDecoder().decode(instruction.data)
  };
}
function getMintNewEditionFromMasterEditionViaTokenInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      [
        "mintNewEditionFromMasterEditionViaTokenArgs",
        getMintNewEditionFromMasterEditionViaTokenArgsEncoder()
      ]
    ]),
    (value) => ({ ...value, discriminator: 11 })
  );
}
function getMintNewEditionFromMasterEditionViaTokenInstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    [
      "mintNewEditionFromMasterEditionViaTokenArgs",
      getMintNewEditionFromMasterEditionViaTokenArgsDecoder()
    ]
  ]);
}
function getMintNewEditionFromMasterEditionViaTokenInstructionDataCodec() {
  return combineCodec(
    getMintNewEditionFromMasterEditionViaTokenInstructionDataEncoder(),
    getMintNewEditionFromMasterEditionViaTokenInstructionDataDecoder()
  );
}
function getMintNewEditionFromMasterEditionViaTokenInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    newMetadata: { value: input.newMetadata ?? null, isWritable: true },
    newEdition: { value: input.newEdition ?? null, isWritable: true },
    masterEdition: { value: input.masterEdition ?? null, isWritable: true },
    newMint: { value: input.newMint ?? null, isWritable: true },
    editionMarkPda: { value: input.editionMarkPda ?? null, isWritable: true },
    newMintAuthority: {
      value: input.newMintAuthority ?? null,
      isWritable: false
    },
    payer: { value: input.payer ?? null, isWritable: true },
    tokenAccountOwner: {
      value: input.tokenAccountOwner ?? null,
      isWritable: false
    },
    tokenAccount: { value: input.tokenAccount ?? null, isWritable: false },
    newMetadataUpdateAuthority: {
      value: input.newMetadataUpdateAuthority ?? null,
      isWritable: false
    },
    metadata: { value: input.metadata ?? null, isWritable: false },
    tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    rent: { value: input.rent ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.tokenProgram.value) {
    accounts.tokenProgram.value = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
  }
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "omitted");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.newMetadata),
      getAccountMeta(accounts.newEdition),
      getAccountMeta(accounts.masterEdition),
      getAccountMeta(accounts.newMint),
      getAccountMeta(accounts.editionMarkPda),
      getAccountMeta(accounts.newMintAuthority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.tokenAccountOwner),
      getAccountMeta(accounts.tokenAccount),
      getAccountMeta(accounts.newMetadataUpdateAuthority),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.tokenProgram),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.rent)
    ].filter((x) => x !== void 0),
    programAddress,
    data: getMintNewEditionFromMasterEditionViaTokenInstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseMintNewEditionFromMasterEditionViaTokenInstruction(instruction) {
  if (instruction.accounts.length < 13) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  let optionalAccountsRemaining = instruction.accounts.length - 13;
  const getNextOptionalAccount = () => {
    if (optionalAccountsRemaining === 0) return void 0;
    optionalAccountsRemaining -= 1;
    return getNextAccount();
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      newMetadata: getNextAccount(),
      newEdition: getNextAccount(),
      masterEdition: getNextAccount(),
      newMint: getNextAccount(),
      editionMarkPda: getNextAccount(),
      newMintAuthority: getNextAccount(),
      payer: getNextAccount(),
      tokenAccountOwner: getNextAccount(),
      tokenAccount: getNextAccount(),
      newMetadataUpdateAuthority: getNextAccount(),
      metadata: getNextAccount(),
      tokenProgram: getNextAccount(),
      systemProgram: getNextAccount(),
      rent: getNextOptionalAccount()
    },
    data: getMintNewEditionFromMasterEditionViaTokenInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getMintNewEditionFromMasterEditionViaVaultProxyInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      [
        "mintNewEditionFromMasterEditionViaTokenArgs",
        getMintNewEditionFromMasterEditionViaTokenArgsEncoder()
      ]
    ]),
    (value) => ({ ...value, discriminator: 13 })
  );
}
function getMintNewEditionFromMasterEditionViaVaultProxyInstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    [
      "mintNewEditionFromMasterEditionViaTokenArgs",
      getMintNewEditionFromMasterEditionViaTokenArgsDecoder()
    ]
  ]);
}
function getMintNewEditionFromMasterEditionViaVaultProxyInstructionDataCodec() {
  return combineCodec(
    getMintNewEditionFromMasterEditionViaVaultProxyInstructionDataEncoder(),
    getMintNewEditionFromMasterEditionViaVaultProxyInstructionDataDecoder()
  );
}
function getMintNewEditionFromMasterEditionViaVaultProxyInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    newMetadata: { value: input.newMetadata ?? null, isWritable: true },
    newEdition: { value: input.newEdition ?? null, isWritable: true },
    masterEdition: { value: input.masterEdition ?? null, isWritable: true },
    newMint: { value: input.newMint ?? null, isWritable: true },
    editionMarkPda: { value: input.editionMarkPda ?? null, isWritable: true },
    newMintAuthority: {
      value: input.newMintAuthority ?? null,
      isWritable: false
    },
    payer: { value: input.payer ?? null, isWritable: true },
    vaultAuthority: { value: input.vaultAuthority ?? null, isWritable: false },
    safetyDepositStore: {
      value: input.safetyDepositStore ?? null,
      isWritable: false
    },
    safetyDepositBox: {
      value: input.safetyDepositBox ?? null,
      isWritable: false
    },
    vault: { value: input.vault ?? null, isWritable: false },
    newMetadataUpdateAuthority: {
      value: input.newMetadataUpdateAuthority ?? null,
      isWritable: false
    },
    metadata: { value: input.metadata ?? null, isWritable: false },
    tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
    tokenVaultProgram: {
      value: input.tokenVaultProgram ?? null,
      isWritable: false
    },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    rent: { value: input.rent ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.tokenProgram.value) {
    accounts.tokenProgram.value = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
  }
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "omitted");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.newMetadata),
      getAccountMeta(accounts.newEdition),
      getAccountMeta(accounts.masterEdition),
      getAccountMeta(accounts.newMint),
      getAccountMeta(accounts.editionMarkPda),
      getAccountMeta(accounts.newMintAuthority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.vaultAuthority),
      getAccountMeta(accounts.safetyDepositStore),
      getAccountMeta(accounts.safetyDepositBox),
      getAccountMeta(accounts.vault),
      getAccountMeta(accounts.newMetadataUpdateAuthority),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.tokenProgram),
      getAccountMeta(accounts.tokenVaultProgram),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.rent)
    ].filter((x) => x !== void 0),
    programAddress,
    data: getMintNewEditionFromMasterEditionViaVaultProxyInstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseMintNewEditionFromMasterEditionViaVaultProxyInstruction(instruction) {
  if (instruction.accounts.length < 16) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  let optionalAccountsRemaining = instruction.accounts.length - 16;
  const getNextOptionalAccount = () => {
    if (optionalAccountsRemaining === 0) return void 0;
    optionalAccountsRemaining -= 1;
    return getNextAccount();
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      newMetadata: getNextAccount(),
      newEdition: getNextAccount(),
      masterEdition: getNextAccount(),
      newMint: getNextAccount(),
      editionMarkPda: getNextAccount(),
      newMintAuthority: getNextAccount(),
      payer: getNextAccount(),
      vaultAuthority: getNextAccount(),
      safetyDepositStore: getNextAccount(),
      safetyDepositBox: getNextAccount(),
      vault: getNextAccount(),
      newMetadataUpdateAuthority: getNextAccount(),
      metadata: getNextAccount(),
      tokenProgram: getNextAccount(),
      tokenVaultProgram: getNextAccount(),
      systemProgram: getNextAccount(),
      rent: getNextOptionalAccount()
    },
    data: getMintNewEditionFromMasterEditionViaVaultProxyInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getMintV1InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["mintV1Discriminator", getU8Encoder()],
      ["amount", getU64Encoder()],
      ["authorizationData", getOptionEncoder(getAuthorizationDataEncoder())]
    ]),
    (value) => ({ ...value, discriminator: 43, mintV1Discriminator: 0 })
  );
}
function getMintV1InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["mintV1Discriminator", getU8Decoder()],
    ["amount", getU64Decoder()],
    ["authorizationData", getOptionDecoder(getAuthorizationDataDecoder())]
  ]);
}
function getMintV1InstructionDataCodec() {
  return combineCodec(
    getMintV1InstructionDataEncoder(),
    getMintV1InstructionDataDecoder()
  );
}
function getMintV1Instruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    token: { value: input.token ?? null, isWritable: true },
    tokenOwner: { value: input.tokenOwner ?? null, isWritable: false },
    metadata: { value: input.metadata ?? null, isWritable: false },
    masterEdition: { value: input.masterEdition ?? null, isWritable: true },
    tokenRecord: { value: input.tokenRecord ?? null, isWritable: true },
    mint: { value: input.mint ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    delegateRecord: { value: input.delegateRecord ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: true },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    sysvarInstructions: {
      value: input.sysvarInstructions ?? null,
      isWritable: false
    },
    splTokenProgram: {
      value: input.splTokenProgram ?? null,
      isWritable: false
    },
    splAtaProgram: { value: input.splAtaProgram ?? null, isWritable: false },
    authorizationRulesProgram: {
      value: input.authorizationRulesProgram ?? null,
      isWritable: false
    },
    authorizationRules: {
      value: input.authorizationRules ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.sysvarInstructions.value) {
    accounts.sysvarInstructions.value = "Sysvar1nstructions1111111111111111111111111";
  }
  if (!accounts.splTokenProgram.value) {
    accounts.splTokenProgram.value = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
  }
  if (!accounts.splAtaProgram.value) {
    accounts.splAtaProgram.value = "ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.token),
      getAccountMeta(accounts.tokenOwner),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.masterEdition),
      getAccountMeta(accounts.tokenRecord),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.delegateRecord),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.sysvarInstructions),
      getAccountMeta(accounts.splTokenProgram),
      getAccountMeta(accounts.splAtaProgram),
      getAccountMeta(accounts.authorizationRulesProgram),
      getAccountMeta(accounts.authorizationRules)
    ],
    programAddress,
    data: getMintV1InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseMintV1Instruction(instruction) {
  if (instruction.accounts.length < 15) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === TOKEN_METADATA_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      token: getNextAccount(),
      tokenOwner: getNextOptionalAccount(),
      metadata: getNextAccount(),
      masterEdition: getNextOptionalAccount(),
      tokenRecord: getNextOptionalAccount(),
      mint: getNextAccount(),
      authority: getNextAccount(),
      delegateRecord: getNextOptionalAccount(),
      payer: getNextAccount(),
      systemProgram: getNextAccount(),
      sysvarInstructions: getNextAccount(),
      splTokenProgram: getNextAccount(),
      splAtaProgram: getNextAccount(),
      authorizationRulesProgram: getNextOptionalAccount(),
      authorizationRules: getNextOptionalAccount()
    },
    data: getMintV1InstructionDataDecoder().decode(instruction.data)
  };
}
function getPrintInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["printArgs", getPrintArgsEncoder()]
    ]),
    (value) => ({ ...value, discriminator: 55 })
  );
}
function getPrintInstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["printArgs", getPrintArgsDecoder()]
  ]);
}
function getPrintInstructionDataCodec() {
  return combineCodec(
    getPrintInstructionDataEncoder(),
    getPrintInstructionDataDecoder()
  );
}
function getPrintInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    editionMetadata: { value: input.editionMetadata ?? null, isWritable: true },
    edition: { value: input.edition ?? null, isWritable: true },
    editionMint: { value: input.editionMint ?? null, isWritable: true },
    editionTokenAccountOwner: {
      value: input.editionTokenAccountOwner ?? null,
      isWritable: false
    },
    editionTokenAccount: {
      value: input.editionTokenAccount ?? null,
      isWritable: true
    },
    editionMintAuthority: {
      value: input.editionMintAuthority ?? null,
      isWritable: false
    },
    editionTokenRecord: {
      value: input.editionTokenRecord ?? null,
      isWritable: true
    },
    masterEdition: { value: input.masterEdition ?? null, isWritable: true },
    editionMarkerPda: {
      value: input.editionMarkerPda ?? null,
      isWritable: true
    },
    payer: { value: input.payer ?? null, isWritable: true },
    masterTokenAccountOwner: {
      value: input.masterTokenAccountOwner ?? null,
      isWritable: false
    },
    masterTokenAccount: {
      value: input.masterTokenAccount ?? null,
      isWritable: false
    },
    masterMetadata: { value: input.masterMetadata ?? null, isWritable: false },
    updateAuthority: {
      value: input.updateAuthority ?? null,
      isWritable: false
    },
    splTokenProgram: {
      value: input.splTokenProgram ?? null,
      isWritable: false
    },
    splAtaProgram: { value: input.splAtaProgram ?? null, isWritable: false },
    sysvarInstructions: {
      value: input.sysvarInstructions ?? null,
      isWritable: false
    },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.splTokenProgram.value) {
    accounts.splTokenProgram.value = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
  }
  if (!accounts.splAtaProgram.value) {
    accounts.splAtaProgram.value = "ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL";
  }
  if (!accounts.sysvarInstructions.value) {
    accounts.sysvarInstructions.value = "Sysvar1nstructions1111111111111111111111111";
  }
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.editionMetadata),
      getAccountMeta(accounts.edition),
      getAccountMeta(accounts.editionMint),
      getAccountMeta(accounts.editionTokenAccountOwner),
      getAccountMeta(accounts.editionTokenAccount),
      getAccountMeta(accounts.editionMintAuthority),
      getAccountMeta(accounts.editionTokenRecord),
      getAccountMeta(accounts.masterEdition),
      getAccountMeta(accounts.editionMarkerPda),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.masterTokenAccountOwner),
      getAccountMeta(accounts.masterTokenAccount),
      getAccountMeta(accounts.masterMetadata),
      getAccountMeta(accounts.updateAuthority),
      getAccountMeta(accounts.splTokenProgram),
      getAccountMeta(accounts.splAtaProgram),
      getAccountMeta(accounts.sysvarInstructions),
      getAccountMeta(accounts.systemProgram)
    ],
    programAddress,
    data: getPrintInstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parsePrintInstruction(instruction) {
  if (instruction.accounts.length < 18) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === TOKEN_METADATA_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      editionMetadata: getNextAccount(),
      edition: getNextAccount(),
      editionMint: getNextAccount(),
      editionTokenAccountOwner: getNextAccount(),
      editionTokenAccount: getNextAccount(),
      editionMintAuthority: getNextAccount(),
      editionTokenRecord: getNextOptionalAccount(),
      masterEdition: getNextAccount(),
      editionMarkerPda: getNextAccount(),
      payer: getNextAccount(),
      masterTokenAccountOwner: getNextAccount(),
      masterTokenAccount: getNextAccount(),
      masterMetadata: getNextAccount(),
      updateAuthority: getNextAccount(),
      splTokenProgram: getNextAccount(),
      splAtaProgram: getNextAccount(),
      sysvarInstructions: getNextAccount(),
      systemProgram: getNextAccount()
    },
    data: getPrintInstructionDataDecoder().decode(instruction.data)
  };
}
function getPuffMetadataInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 14 })
  );
}
function getPuffMetadataInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getPuffMetadataInstructionDataCodec() {
  return combineCodec(
    getPuffMetadataInstructionDataEncoder(),
    getPuffMetadataInstructionDataDecoder()
  );
}
function getPuffMetadataInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true }
  };
  const accounts = originalAccounts;
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [getAccountMeta(accounts.metadata)],
    programAddress,
    data: getPuffMetadataInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parsePuffMetadataInstruction(instruction) {
  if (instruction.accounts.length < 1) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      metadata: getNextAccount()
    },
    data: getPuffMetadataInstructionDataDecoder().decode(instruction.data)
  };
}
function getRemoveCreatorVerificationInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 28 })
  );
}
function getRemoveCreatorVerificationInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getRemoveCreatorVerificationInstructionDataCodec() {
  return combineCodec(
    getRemoveCreatorVerificationInstructionDataEncoder(),
    getRemoveCreatorVerificationInstructionDataDecoder()
  );
}
function getRemoveCreatorVerificationInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true },
    creator: { value: input.creator ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.creator)
    ],
    programAddress,
    data: getRemoveCreatorVerificationInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseRemoveCreatorVerificationInstruction(instruction) {
  if (instruction.accounts.length < 2) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      metadata: getNextAccount(),
      creator: getNextAccount()
    },
    data: getRemoveCreatorVerificationInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getRevokeInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["revokeArgs", getRevokeArgsEncoder()]
    ]),
    (value) => ({ ...value, discriminator: 45 })
  );
}
function getRevokeInstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["revokeArgs", getRevokeArgsDecoder()]
  ]);
}
function getRevokeInstructionDataCodec() {
  return combineCodec(
    getRevokeInstructionDataEncoder(),
    getRevokeInstructionDataDecoder()
  );
}
function getRevokeInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    delegateRecord: { value: input.delegateRecord ?? null, isWritable: true },
    delegate: { value: input.delegate ?? null, isWritable: false },
    metadata: { value: input.metadata ?? null, isWritable: true },
    masterEdition: { value: input.masterEdition ?? null, isWritable: false },
    tokenRecord: { value: input.tokenRecord ?? null, isWritable: true },
    mint: { value: input.mint ?? null, isWritable: false },
    token: { value: input.token ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: true },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    sysvarInstructions: {
      value: input.sysvarInstructions ?? null,
      isWritable: false
    },
    splTokenProgram: {
      value: input.splTokenProgram ?? null,
      isWritable: false
    },
    authorizationRulesProgram: {
      value: input.authorizationRulesProgram ?? null,
      isWritable: false
    },
    authorizationRules: {
      value: input.authorizationRules ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.sysvarInstructions.value) {
    accounts.sysvarInstructions.value = "Sysvar1nstructions1111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.delegateRecord),
      getAccountMeta(accounts.delegate),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.masterEdition),
      getAccountMeta(accounts.tokenRecord),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.token),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.sysvarInstructions),
      getAccountMeta(accounts.splTokenProgram),
      getAccountMeta(accounts.authorizationRulesProgram),
      getAccountMeta(accounts.authorizationRules)
    ],
    programAddress,
    data: getRevokeInstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseRevokeInstruction(instruction) {
  if (instruction.accounts.length < 14) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === TOKEN_METADATA_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      delegateRecord: getNextOptionalAccount(),
      delegate: getNextAccount(),
      metadata: getNextAccount(),
      masterEdition: getNextOptionalAccount(),
      tokenRecord: getNextOptionalAccount(),
      mint: getNextAccount(),
      token: getNextOptionalAccount(),
      authority: getNextAccount(),
      payer: getNextAccount(),
      systemProgram: getNextAccount(),
      sysvarInstructions: getNextAccount(),
      splTokenProgram: getNextOptionalAccount(),
      authorizationRulesProgram: getNextOptionalAccount(),
      authorizationRules: getNextOptionalAccount()
    },
    data: getRevokeInstructionDataDecoder().decode(instruction.data)
  };
}
function getRevokeCollectionAuthorityInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 24 })
  );
}
function getRevokeCollectionAuthorityInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getRevokeCollectionAuthorityInstructionDataCodec() {
  return combineCodec(
    getRevokeCollectionAuthorityInstructionDataEncoder(),
    getRevokeCollectionAuthorityInstructionDataDecoder()
  );
}
function getRevokeCollectionAuthorityInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    collectionAuthorityRecord: {
      value: input.collectionAuthorityRecord ?? null,
      isWritable: true
    },
    delegateAuthority: {
      value: input.delegateAuthority ?? null,
      isWritable: true
    },
    revokeAuthority: { value: input.revokeAuthority ?? null, isWritable: true },
    metadata: { value: input.metadata ?? null, isWritable: false },
    mint: { value: input.mint ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.collectionAuthorityRecord),
      getAccountMeta(accounts.delegateAuthority),
      getAccountMeta(accounts.revokeAuthority),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.mint)
    ],
    programAddress,
    data: getRevokeCollectionAuthorityInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseRevokeCollectionAuthorityInstruction(instruction) {
  if (instruction.accounts.length < 5) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      collectionAuthorityRecord: getNextAccount(),
      delegateAuthority: getNextAccount(),
      revokeAuthority: getNextAccount(),
      metadata: getNextAccount(),
      mint: getNextAccount()
    },
    data: getRevokeCollectionAuthorityInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getRevokeUseAuthorityInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 21 })
  );
}
function getRevokeUseAuthorityInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getRevokeUseAuthorityInstructionDataCodec() {
  return combineCodec(
    getRevokeUseAuthorityInstructionDataEncoder(),
    getRevokeUseAuthorityInstructionDataDecoder()
  );
}
function getRevokeUseAuthorityInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    useAuthorityRecord: {
      value: input.useAuthorityRecord ?? null,
      isWritable: true
    },
    owner: { value: input.owner ?? null, isWritable: true },
    user: { value: input.user ?? null, isWritable: false },
    ownerTokenAccount: {
      value: input.ownerTokenAccount ?? null,
      isWritable: true
    },
    mint: { value: input.mint ?? null, isWritable: false },
    metadata: { value: input.metadata ?? null, isWritable: false },
    tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    rent: { value: input.rent ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  if (!accounts.tokenProgram.value) {
    accounts.tokenProgram.value = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
  }
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "omitted");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.useAuthorityRecord),
      getAccountMeta(accounts.owner),
      getAccountMeta(accounts.user),
      getAccountMeta(accounts.ownerTokenAccount),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.tokenProgram),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.rent)
    ].filter((x) => x !== void 0),
    programAddress,
    data: getRevokeUseAuthorityInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseRevokeUseAuthorityInstruction(instruction) {
  if (instruction.accounts.length < 8) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  let optionalAccountsRemaining = instruction.accounts.length - 8;
  const getNextOptionalAccount = () => {
    if (optionalAccountsRemaining === 0) return void 0;
    optionalAccountsRemaining -= 1;
    return getNextAccount();
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      useAuthorityRecord: getNextAccount(),
      owner: getNextAccount(),
      user: getNextAccount(),
      ownerTokenAccount: getNextAccount(),
      mint: getNextAccount(),
      metadata: getNextAccount(),
      tokenProgram: getNextAccount(),
      systemProgram: getNextAccount(),
      rent: getNextOptionalAccount()
    },
    data: getRevokeUseAuthorityInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getSetAndVerifyCollectionInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 25 })
  );
}
function getSetAndVerifyCollectionInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getSetAndVerifyCollectionInstructionDataCodec() {
  return combineCodec(
    getSetAndVerifyCollectionInstructionDataEncoder(),
    getSetAndVerifyCollectionInstructionDataDecoder()
  );
}
function getSetAndVerifyCollectionInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true },
    collectionAuthority: {
      value: input.collectionAuthority ?? null,
      isWritable: true
    },
    payer: { value: input.payer ?? null, isWritable: true },
    updateAuthority: {
      value: input.updateAuthority ?? null,
      isWritable: false
    },
    collectionMint: { value: input.collectionMint ?? null, isWritable: false },
    collection: { value: input.collection ?? null, isWritable: false },
    collectionMasterEditionAccount: {
      value: input.collectionMasterEditionAccount ?? null,
      isWritable: false
    },
    collectionAuthorityRecord: {
      value: input.collectionAuthorityRecord ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const getAccountMeta = getAccountMetaFactory(programAddress, "omitted");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.collectionAuthority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.updateAuthority),
      getAccountMeta(accounts.collectionMint),
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.collectionMasterEditionAccount),
      getAccountMeta(accounts.collectionAuthorityRecord)
    ].filter((x) => x !== void 0),
    programAddress,
    data: getSetAndVerifyCollectionInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseSetAndVerifyCollectionInstruction(instruction) {
  if (instruction.accounts.length < 7) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  let optionalAccountsRemaining = instruction.accounts.length - 7;
  const getNextOptionalAccount = () => {
    if (optionalAccountsRemaining === 0) return void 0;
    optionalAccountsRemaining -= 1;
    return getNextAccount();
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      metadata: getNextAccount(),
      collectionAuthority: getNextAccount(),
      payer: getNextAccount(),
      updateAuthority: getNextAccount(),
      collectionMint: getNextAccount(),
      collection: getNextAccount(),
      collectionMasterEditionAccount: getNextAccount(),
      collectionAuthorityRecord: getNextOptionalAccount()
    },
    data: getSetAndVerifyCollectionInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getSetAndVerifySizedCollectionItemInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 32 })
  );
}
function getSetAndVerifySizedCollectionItemInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getSetAndVerifySizedCollectionItemInstructionDataCodec() {
  return combineCodec(
    getSetAndVerifySizedCollectionItemInstructionDataEncoder(),
    getSetAndVerifySizedCollectionItemInstructionDataDecoder()
  );
}
function getSetAndVerifySizedCollectionItemInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true },
    collectionAuthority: {
      value: input.collectionAuthority ?? null,
      isWritable: false
    },
    payer: { value: input.payer ?? null, isWritable: true },
    updateAuthority: {
      value: input.updateAuthority ?? null,
      isWritable: false
    },
    collectionMint: { value: input.collectionMint ?? null, isWritable: false },
    collection: { value: input.collection ?? null, isWritable: true },
    collectionMasterEditionAccount: {
      value: input.collectionMasterEditionAccount ?? null,
      isWritable: false
    },
    collectionAuthorityRecord: {
      value: input.collectionAuthorityRecord ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const getAccountMeta = getAccountMetaFactory(programAddress, "omitted");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.collectionAuthority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.updateAuthority),
      getAccountMeta(accounts.collectionMint),
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.collectionMasterEditionAccount),
      getAccountMeta(accounts.collectionAuthorityRecord)
    ].filter((x) => x !== void 0),
    programAddress,
    data: getSetAndVerifySizedCollectionItemInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseSetAndVerifySizedCollectionItemInstruction(instruction) {
  if (instruction.accounts.length < 7) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  let optionalAccountsRemaining = instruction.accounts.length - 7;
  const getNextOptionalAccount = () => {
    if (optionalAccountsRemaining === 0) return void 0;
    optionalAccountsRemaining -= 1;
    return getNextAccount();
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      metadata: getNextAccount(),
      collectionAuthority: getNextAccount(),
      payer: getNextAccount(),
      updateAuthority: getNextAccount(),
      collectionMint: getNextAccount(),
      collection: getNextAccount(),
      collectionMasterEditionAccount: getNextAccount(),
      collectionAuthorityRecord: getNextOptionalAccount()
    },
    data: getSetAndVerifySizedCollectionItemInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getSetCollectionSizeInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["setCollectionSizeArgs", getSetCollectionSizeArgsEncoder()]
    ]),
    (value) => ({ ...value, discriminator: 34 })
  );
}
function getSetCollectionSizeInstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["setCollectionSizeArgs", getSetCollectionSizeArgsDecoder()]
  ]);
}
function getSetCollectionSizeInstructionDataCodec() {
  return combineCodec(
    getSetCollectionSizeInstructionDataEncoder(),
    getSetCollectionSizeInstructionDataDecoder()
  );
}
function getSetCollectionSizeInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    collectionMetadata: {
      value: input.collectionMetadata ?? null,
      isWritable: true
    },
    collectionAuthority: {
      value: input.collectionAuthority ?? null,
      isWritable: true
    },
    collectionMint: { value: input.collectionMint ?? null, isWritable: false },
    collectionAuthorityRecord: {
      value: input.collectionAuthorityRecord ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  const getAccountMeta = getAccountMetaFactory(programAddress, "omitted");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.collectionMetadata),
      getAccountMeta(accounts.collectionAuthority),
      getAccountMeta(accounts.collectionMint),
      getAccountMeta(accounts.collectionAuthorityRecord)
    ].filter((x) => x !== void 0),
    programAddress,
    data: getSetCollectionSizeInstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseSetCollectionSizeInstruction(instruction) {
  if (instruction.accounts.length < 3) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  let optionalAccountsRemaining = instruction.accounts.length - 3;
  const getNextOptionalAccount = () => {
    if (optionalAccountsRemaining === 0) return void 0;
    optionalAccountsRemaining -= 1;
    return getNextAccount();
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      collectionMetadata: getNextAccount(),
      collectionAuthority: getNextAccount(),
      collectionMint: getNextAccount(),
      collectionAuthorityRecord: getNextOptionalAccount()
    },
    data: getSetCollectionSizeInstructionDataDecoder().decode(instruction.data)
  };
}
function getSetTokenStandardInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 35 })
  );
}
function getSetTokenStandardInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getSetTokenStandardInstructionDataCodec() {
  return combineCodec(
    getSetTokenStandardInstructionDataEncoder(),
    getSetTokenStandardInstructionDataDecoder()
  );
}
function getSetTokenStandardInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true },
    updateAuthority: {
      value: input.updateAuthority ?? null,
      isWritable: false
    },
    mint: { value: input.mint ?? null, isWritable: false },
    edition: { value: input.edition ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const getAccountMeta = getAccountMetaFactory(programAddress, "omitted");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.updateAuthority),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.edition)
    ].filter((x) => x !== void 0),
    programAddress,
    data: getSetTokenStandardInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseSetTokenStandardInstruction(instruction) {
  if (instruction.accounts.length < 3) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  let optionalAccountsRemaining = instruction.accounts.length - 3;
  const getNextOptionalAccount = () => {
    if (optionalAccountsRemaining === 0) return void 0;
    optionalAccountsRemaining -= 1;
    return getNextAccount();
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      metadata: getNextAccount(),
      updateAuthority: getNextAccount(),
      mint: getNextAccount(),
      edition: getNextOptionalAccount()
    },
    data: getSetTokenStandardInstructionDataDecoder().decode(instruction.data)
  };
}
function getSignMetadataInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 7 })
  );
}
function getSignMetadataInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getSignMetadataInstructionDataCodec() {
  return combineCodec(
    getSignMetadataInstructionDataEncoder(),
    getSignMetadataInstructionDataDecoder()
  );
}
function getSignMetadataInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true },
    creator: { value: input.creator ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.creator)
    ],
    programAddress,
    data: getSignMetadataInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseSignMetadataInstruction(instruction) {
  if (instruction.accounts.length < 2) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      metadata: getNextAccount(),
      creator: getNextAccount()
    },
    data: getSignMetadataInstructionDataDecoder().decode(instruction.data)
  };
}
function getThawDelegatedAccountInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 27 })
  );
}
function getThawDelegatedAccountInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getThawDelegatedAccountInstructionDataCodec() {
  return combineCodec(
    getThawDelegatedAccountInstructionDataEncoder(),
    getThawDelegatedAccountInstructionDataDecoder()
  );
}
function getThawDelegatedAccountInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    delegate: { value: input.delegate ?? null, isWritable: true },
    tokenAccount: { value: input.tokenAccount ?? null, isWritable: true },
    edition: { value: input.edition ?? null, isWritable: false },
    mint: { value: input.mint ?? null, isWritable: false },
    tokenProgram: { value: input.tokenProgram ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  if (!accounts.tokenProgram.value) {
    accounts.tokenProgram.value = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.delegate),
      getAccountMeta(accounts.tokenAccount),
      getAccountMeta(accounts.edition),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.tokenProgram)
    ],
    programAddress,
    data: getThawDelegatedAccountInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseThawDelegatedAccountInstruction(instruction) {
  if (instruction.accounts.length < 5) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      delegate: getNextAccount(),
      tokenAccount: getNextAccount(),
      edition: getNextAccount(),
      mint: getNextAccount(),
      tokenProgram: getNextAccount()
    },
    data: getThawDelegatedAccountInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getTransferInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["transferArgs", getTransferArgsEncoder()]
    ]),
    (value) => ({ ...value, discriminator: 49 })
  );
}
function getTransferInstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["transferArgs", getTransferArgsDecoder()]
  ]);
}
function getTransferInstructionDataCodec() {
  return combineCodec(
    getTransferInstructionDataEncoder(),
    getTransferInstructionDataDecoder()
  );
}
function getTransferInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    token: { value: input.token ?? null, isWritable: true },
    tokenOwner: { value: input.tokenOwner ?? null, isWritable: false },
    destination: { value: input.destination ?? null, isWritable: true },
    destinationOwner: {
      value: input.destinationOwner ?? null,
      isWritable: false
    },
    mint: { value: input.mint ?? null, isWritable: false },
    metadata: { value: input.metadata ?? null, isWritable: true },
    edition: { value: input.edition ?? null, isWritable: false },
    ownerTokenRecord: {
      value: input.ownerTokenRecord ?? null,
      isWritable: true
    },
    destinationTokenRecord: {
      value: input.destinationTokenRecord ?? null,
      isWritable: true
    },
    authority: { value: input.authority ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: true },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    sysvarInstructions: {
      value: input.sysvarInstructions ?? null,
      isWritable: false
    },
    splTokenProgram: {
      value: input.splTokenProgram ?? null,
      isWritable: false
    },
    splAtaProgram: { value: input.splAtaProgram ?? null, isWritable: false },
    authorizationRulesProgram: {
      value: input.authorizationRulesProgram ?? null,
      isWritable: false
    },
    authorizationRules: {
      value: input.authorizationRules ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.sysvarInstructions.value) {
    accounts.sysvarInstructions.value = "Sysvar1nstructions1111111111111111111111111";
  }
  if (!accounts.splTokenProgram.value) {
    accounts.splTokenProgram.value = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
  }
  if (!accounts.splAtaProgram.value) {
    accounts.splAtaProgram.value = "ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.token),
      getAccountMeta(accounts.tokenOwner),
      getAccountMeta(accounts.destination),
      getAccountMeta(accounts.destinationOwner),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.edition),
      getAccountMeta(accounts.ownerTokenRecord),
      getAccountMeta(accounts.destinationTokenRecord),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.sysvarInstructions),
      getAccountMeta(accounts.splTokenProgram),
      getAccountMeta(accounts.splAtaProgram),
      getAccountMeta(accounts.authorizationRulesProgram),
      getAccountMeta(accounts.authorizationRules)
    ],
    programAddress,
    data: getTransferInstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseTransferInstruction(instruction) {
  if (instruction.accounts.length < 17) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === TOKEN_METADATA_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      token: getNextAccount(),
      tokenOwner: getNextAccount(),
      destination: getNextAccount(),
      destinationOwner: getNextAccount(),
      mint: getNextAccount(),
      metadata: getNextAccount(),
      edition: getNextOptionalAccount(),
      ownerTokenRecord: getNextOptionalAccount(),
      destinationTokenRecord: getNextOptionalAccount(),
      authority: getNextAccount(),
      payer: getNextAccount(),
      systemProgram: getNextAccount(),
      sysvarInstructions: getNextAccount(),
      splTokenProgram: getNextAccount(),
      splAtaProgram: getNextAccount(),
      authorizationRulesProgram: getNextOptionalAccount(),
      authorizationRules: getNextOptionalAccount()
    },
    data: getTransferInstructionDataDecoder().decode(instruction.data)
  };
}
function getTransferOutOfEscrowInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["amount", getU64Encoder()]
    ]),
    (value) => ({ ...value, discriminator: 40 })
  );
}
function getTransferOutOfEscrowInstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["amount", getU64Decoder()]
  ]);
}
function getTransferOutOfEscrowInstructionDataCodec() {
  return combineCodec(
    getTransferOutOfEscrowInstructionDataEncoder(),
    getTransferOutOfEscrowInstructionDataDecoder()
  );
}
function getTransferOutOfEscrowInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    escrow: { value: input.escrow ?? null, isWritable: false },
    metadata: { value: input.metadata ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    attributeMint: { value: input.attributeMint ?? null, isWritable: false },
    attributeSrc: { value: input.attributeSrc ?? null, isWritable: true },
    attributeDst: { value: input.attributeDst ?? null, isWritable: true },
    escrowMint: { value: input.escrowMint ?? null, isWritable: false },
    escrowAccount: { value: input.escrowAccount ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    ataProgram: { value: input.ataProgram ?? null, isWritable: false },
    tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
    sysvarInstructions: {
      value: input.sysvarInstructions ?? null,
      isWritable: false
    },
    authority: { value: input.authority ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.ataProgram.value) {
    accounts.ataProgram.value = "ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL";
  }
  if (!accounts.tokenProgram.value) {
    accounts.tokenProgram.value = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
  }
  if (!accounts.sysvarInstructions.value) {
    accounts.sysvarInstructions.value = "Sysvar1nstructions1111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "omitted");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.escrow),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.attributeMint),
      getAccountMeta(accounts.attributeSrc),
      getAccountMeta(accounts.attributeDst),
      getAccountMeta(accounts.escrowMint),
      getAccountMeta(accounts.escrowAccount),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.ataProgram),
      getAccountMeta(accounts.tokenProgram),
      getAccountMeta(accounts.sysvarInstructions),
      getAccountMeta(accounts.authority)
    ].filter((x) => x !== void 0),
    programAddress,
    data: getTransferOutOfEscrowInstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseTransferOutOfEscrowInstruction(instruction) {
  if (instruction.accounts.length < 12) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  let optionalAccountsRemaining = instruction.accounts.length - 12;
  const getNextOptionalAccount = () => {
    if (optionalAccountsRemaining === 0) return void 0;
    optionalAccountsRemaining -= 1;
    return getNextAccount();
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      escrow: getNextAccount(),
      metadata: getNextAccount(),
      payer: getNextAccount(),
      attributeMint: getNextAccount(),
      attributeSrc: getNextAccount(),
      attributeDst: getNextAccount(),
      escrowMint: getNextAccount(),
      escrowAccount: getNextAccount(),
      systemProgram: getNextAccount(),
      ataProgram: getNextAccount(),
      tokenProgram: getNextAccount(),
      sysvarInstructions: getNextAccount(),
      authority: getNextOptionalAccount()
    },
    data: getTransferOutOfEscrowInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getUnlockInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["unlockArgs", getUnlockArgsEncoder()]
    ]),
    (value) => ({ ...value, discriminator: 47 })
  );
}
function getUnlockInstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["unlockArgs", getUnlockArgsDecoder()]
  ]);
}
function getUnlockInstructionDataCodec() {
  return combineCodec(
    getUnlockInstructionDataEncoder(),
    getUnlockInstructionDataDecoder()
  );
}
function getUnlockInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    authority: { value: input.authority ?? null, isWritable: false },
    tokenOwner: { value: input.tokenOwner ?? null, isWritable: false },
    token: { value: input.token ?? null, isWritable: true },
    mint: { value: input.mint ?? null, isWritable: false },
    metadata: { value: input.metadata ?? null, isWritable: true },
    edition: { value: input.edition ?? null, isWritable: false },
    tokenRecord: { value: input.tokenRecord ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: true },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    sysvarInstructions: {
      value: input.sysvarInstructions ?? null,
      isWritable: false
    },
    splTokenProgram: {
      value: input.splTokenProgram ?? null,
      isWritable: false
    },
    authorizationRulesProgram: {
      value: input.authorizationRulesProgram ?? null,
      isWritable: false
    },
    authorizationRules: {
      value: input.authorizationRules ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.sysvarInstructions.value) {
    accounts.sysvarInstructions.value = "Sysvar1nstructions1111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.tokenOwner),
      getAccountMeta(accounts.token),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.edition),
      getAccountMeta(accounts.tokenRecord),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.sysvarInstructions),
      getAccountMeta(accounts.splTokenProgram),
      getAccountMeta(accounts.authorizationRulesProgram),
      getAccountMeta(accounts.authorizationRules)
    ],
    programAddress,
    data: getUnlockInstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseUnlockInstruction(instruction) {
  if (instruction.accounts.length < 13) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === TOKEN_METADATA_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      authority: getNextAccount(),
      tokenOwner: getNextOptionalAccount(),
      token: getNextAccount(),
      mint: getNextAccount(),
      metadata: getNextAccount(),
      edition: getNextOptionalAccount(),
      tokenRecord: getNextOptionalAccount(),
      payer: getNextAccount(),
      systemProgram: getNextAccount(),
      sysvarInstructions: getNextAccount(),
      splTokenProgram: getNextOptionalAccount(),
      authorizationRulesProgram: getNextOptionalAccount(),
      authorizationRules: getNextOptionalAccount()
    },
    data: getUnlockInstructionDataDecoder().decode(instruction.data)
  };
}
function getUnverifyInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["verificationArgs", getVerificationArgsEncoder()]
    ]),
    (value) => ({ ...value, discriminator: 53 })
  );
}
function getUnverifyInstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["verificationArgs", getVerificationArgsDecoder()]
  ]);
}
function getUnverifyInstructionDataCodec() {
  return combineCodec(
    getUnverifyInstructionDataEncoder(),
    getUnverifyInstructionDataDecoder()
  );
}
function getUnverifyInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    authority: { value: input.authority ?? null, isWritable: false },
    delegateRecord: { value: input.delegateRecord ?? null, isWritable: false },
    metadata: { value: input.metadata ?? null, isWritable: true },
    collectionMint: { value: input.collectionMint ?? null, isWritable: false },
    collectionMetadata: {
      value: input.collectionMetadata ?? null,
      isWritable: true
    },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    sysvarInstructions: {
      value: input.sysvarInstructions ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.sysvarInstructions.value) {
    accounts.sysvarInstructions.value = "Sysvar1nstructions1111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.delegateRecord),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.collectionMint),
      getAccountMeta(accounts.collectionMetadata),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.sysvarInstructions)
    ],
    programAddress,
    data: getUnverifyInstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseUnverifyInstruction(instruction) {
  if (instruction.accounts.length < 7) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === TOKEN_METADATA_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      authority: getNextAccount(),
      delegateRecord: getNextOptionalAccount(),
      metadata: getNextAccount(),
      collectionMint: getNextOptionalAccount(),
      collectionMetadata: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      sysvarInstructions: getNextAccount()
    },
    data: getUnverifyInstructionDataDecoder().decode(instruction.data)
  };
}
function getUnverifyCollectionInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 22 })
  );
}
function getUnverifyCollectionInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getUnverifyCollectionInstructionDataCodec() {
  return combineCodec(
    getUnverifyCollectionInstructionDataEncoder(),
    getUnverifyCollectionInstructionDataDecoder()
  );
}
function getUnverifyCollectionInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true },
    collectionAuthority: {
      value: input.collectionAuthority ?? null,
      isWritable: true
    },
    collectionMint: { value: input.collectionMint ?? null, isWritable: false },
    collection: { value: input.collection ?? null, isWritable: false },
    collectionMasterEditionAccount: {
      value: input.collectionMasterEditionAccount ?? null,
      isWritable: false
    },
    collectionAuthorityRecord: {
      value: input.collectionAuthorityRecord ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const getAccountMeta = getAccountMetaFactory(programAddress, "omitted");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.collectionAuthority),
      getAccountMeta(accounts.collectionMint),
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.collectionMasterEditionAccount),
      getAccountMeta(accounts.collectionAuthorityRecord)
    ].filter((x) => x !== void 0),
    programAddress,
    data: getUnverifyCollectionInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseUnverifyCollectionInstruction(instruction) {
  if (instruction.accounts.length < 5) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  let optionalAccountsRemaining = instruction.accounts.length - 5;
  const getNextOptionalAccount = () => {
    if (optionalAccountsRemaining === 0) return void 0;
    optionalAccountsRemaining -= 1;
    return getNextAccount();
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      metadata: getNextAccount(),
      collectionAuthority: getNextAccount(),
      collectionMint: getNextAccount(),
      collection: getNextAccount(),
      collectionMasterEditionAccount: getNextAccount(),
      collectionAuthorityRecord: getNextOptionalAccount()
    },
    data: getUnverifyCollectionInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getUnverifySizedCollectionItemInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 31 })
  );
}
function getUnverifySizedCollectionItemInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getUnverifySizedCollectionItemInstructionDataCodec() {
  return combineCodec(
    getUnverifySizedCollectionItemInstructionDataEncoder(),
    getUnverifySizedCollectionItemInstructionDataDecoder()
  );
}
function getUnverifySizedCollectionItemInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true },
    collectionAuthority: {
      value: input.collectionAuthority ?? null,
      isWritable: false
    },
    payer: { value: input.payer ?? null, isWritable: true },
    collectionMint: { value: input.collectionMint ?? null, isWritable: false },
    collection: { value: input.collection ?? null, isWritable: true },
    collectionMasterEditionAccount: {
      value: input.collectionMasterEditionAccount ?? null,
      isWritable: false
    },
    collectionAuthorityRecord: {
      value: input.collectionAuthorityRecord ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const getAccountMeta = getAccountMetaFactory(programAddress, "omitted");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.collectionAuthority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.collectionMint),
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.collectionMasterEditionAccount),
      getAccountMeta(accounts.collectionAuthorityRecord)
    ].filter((x) => x !== void 0),
    programAddress,
    data: getUnverifySizedCollectionItemInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseUnverifySizedCollectionItemInstruction(instruction) {
  if (instruction.accounts.length < 6) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  let optionalAccountsRemaining = instruction.accounts.length - 6;
  const getNextOptionalAccount = () => {
    if (optionalAccountsRemaining === 0) return void 0;
    optionalAccountsRemaining -= 1;
    return getNextAccount();
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      metadata: getNextAccount(),
      collectionAuthority: getNextAccount(),
      payer: getNextAccount(),
      collectionMint: getNextAccount(),
      collection: getNextAccount(),
      collectionMasterEditionAccount: getNextAccount(),
      collectionAuthorityRecord: getNextOptionalAccount()
    },
    data: getUnverifySizedCollectionItemInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getUpdateInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["updateArgs", getUpdateArgsEncoder()]
    ]),
    (value) => ({ ...value, discriminator: 50 })
  );
}
function getUpdateInstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["updateArgs", getUpdateArgsDecoder()]
  ]);
}
function getUpdateInstructionDataCodec() {
  return combineCodec(
    getUpdateInstructionDataEncoder(),
    getUpdateInstructionDataDecoder()
  );
}
function getUpdateInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    authority: { value: input.authority ?? null, isWritable: false },
    delegateRecord: { value: input.delegateRecord ?? null, isWritable: false },
    token: { value: input.token ?? null, isWritable: false },
    mint: { value: input.mint ?? null, isWritable: false },
    metadata: { value: input.metadata ?? null, isWritable: true },
    edition: { value: input.edition ?? null, isWritable: false },
    payer: { value: input.payer ?? null, isWritable: true },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    sysvarInstructions: {
      value: input.sysvarInstructions ?? null,
      isWritable: false
    },
    authorizationRulesProgram: {
      value: input.authorizationRulesProgram ?? null,
      isWritable: false
    },
    authorizationRules: {
      value: input.authorizationRules ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.sysvarInstructions.value) {
    accounts.sysvarInstructions.value = "Sysvar1nstructions1111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.delegateRecord),
      getAccountMeta(accounts.token),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.edition),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.sysvarInstructions),
      getAccountMeta(accounts.authorizationRulesProgram),
      getAccountMeta(accounts.authorizationRules)
    ],
    programAddress,
    data: getUpdateInstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseUpdateInstruction(instruction) {
  if (instruction.accounts.length < 11) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === TOKEN_METADATA_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      authority: getNextAccount(),
      delegateRecord: getNextOptionalAccount(),
      token: getNextOptionalAccount(),
      mint: getNextAccount(),
      metadata: getNextAccount(),
      edition: getNextOptionalAccount(),
      payer: getNextAccount(),
      systemProgram: getNextAccount(),
      sysvarInstructions: getNextAccount(),
      authorizationRulesProgram: getNextOptionalAccount(),
      authorizationRules: getNextOptionalAccount()
    },
    data: getUpdateInstructionDataDecoder().decode(instruction.data)
  };
}
function getUpdateMetadataAccountInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 1 })
  );
}
function getUpdateMetadataAccountInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getUpdateMetadataAccountInstructionDataCodec() {
  return combineCodec(
    getUpdateMetadataAccountInstructionDataEncoder(),
    getUpdateMetadataAccountInstructionDataDecoder()
  );
}
function getUpdateMetadataAccountInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true },
    updateAuthority: {
      value: input.updateAuthority ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.updateAuthority)
    ],
    programAddress,
    data: getUpdateMetadataAccountInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseUpdateMetadataAccountInstruction(instruction) {
  if (instruction.accounts.length < 2) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      metadata: getNextAccount(),
      updateAuthority: getNextAccount()
    },
    data: getUpdateMetadataAccountInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getUpdateMetadataAccountV2InstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["data", getOptionEncoder(getDataV2Encoder())],
      ["updateAuthority", getOptionEncoder(getAddressEncoder())],
      ["primarySaleHappened", getOptionEncoder(getBooleanEncoder())],
      ["isMutable", getOptionEncoder(getBooleanEncoder())]
    ]),
    (value) => ({ ...value, discriminator: 15 })
  );
}
function getUpdateMetadataAccountV2InstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["data", getOptionDecoder(getDataV2Decoder())],
    ["updateAuthority", getOptionDecoder(getAddressDecoder())],
    ["primarySaleHappened", getOptionDecoder(getBooleanDecoder())],
    ["isMutable", getOptionDecoder(getBooleanDecoder())]
  ]);
}
function getUpdateMetadataAccountV2InstructionDataCodec() {
  return combineCodec(
    getUpdateMetadataAccountV2InstructionDataEncoder(),
    getUpdateMetadataAccountV2InstructionDataDecoder()
  );
}
function getUpdateMetadataAccountV2Instruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true },
    updateAuthority: {
      value: input.updateAuthority ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const args = { ...input, updateAuthority: input.updateAuthorityArg };
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.updateAuthority)
    ],
    programAddress,
    data: getUpdateMetadataAccountV2InstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseUpdateMetadataAccountV2Instruction(instruction) {
  if (instruction.accounts.length < 2) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      metadata: getNextAccount(),
      updateAuthority: getNextAccount()
    },
    data: getUpdateMetadataAccountV2InstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getUpdatePrimarySaleHappenedViaTokenInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 4 })
  );
}
function getUpdatePrimarySaleHappenedViaTokenInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getUpdatePrimarySaleHappenedViaTokenInstructionDataCodec() {
  return combineCodec(
    getUpdatePrimarySaleHappenedViaTokenInstructionDataEncoder(),
    getUpdatePrimarySaleHappenedViaTokenInstructionDataDecoder()
  );
}
function getUpdatePrimarySaleHappenedViaTokenInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true },
    owner: { value: input.owner ?? null, isWritable: false },
    token: { value: input.token ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.owner),
      getAccountMeta(accounts.token)
    ],
    programAddress,
    data: getUpdatePrimarySaleHappenedViaTokenInstructionDataEncoder().encode(
      {}
    )
  };
  return instruction;
}
function parseUpdatePrimarySaleHappenedViaTokenInstruction(instruction) {
  if (instruction.accounts.length < 3) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      metadata: getNextAccount(),
      owner: getNextAccount(),
      token: getNextAccount()
    },
    data: getUpdatePrimarySaleHappenedViaTokenInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
function getUseInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["useArgs", getUseArgsEncoder()]
    ]),
    (value) => ({ ...value, discriminator: 51 })
  );
}
function getUseInstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["useArgs", getUseArgsDecoder()]
  ]);
}
function getUseInstructionDataCodec() {
  return combineCodec(
    getUseInstructionDataEncoder(),
    getUseInstructionDataDecoder()
  );
}
function getUseInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    authority: { value: input.authority ?? null, isWritable: false },
    delegateRecord: { value: input.delegateRecord ?? null, isWritable: true },
    token: { value: input.token ?? null, isWritable: true },
    mint: { value: input.mint ?? null, isWritable: false },
    metadata: { value: input.metadata ?? null, isWritable: true },
    edition: { value: input.edition ?? null, isWritable: true },
    payer: { value: input.payer ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    sysvarInstructions: {
      value: input.sysvarInstructions ?? null,
      isWritable: false
    },
    splTokenProgram: {
      value: input.splTokenProgram ?? null,
      isWritable: false
    },
    authorizationRulesProgram: {
      value: input.authorizationRulesProgram ?? null,
      isWritable: false
    },
    authorizationRules: {
      value: input.authorizationRules ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.sysvarInstructions.value) {
    accounts.sysvarInstructions.value = "Sysvar1nstructions1111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.delegateRecord),
      getAccountMeta(accounts.token),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.edition),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.sysvarInstructions),
      getAccountMeta(accounts.splTokenProgram),
      getAccountMeta(accounts.authorizationRulesProgram),
      getAccountMeta(accounts.authorizationRules)
    ],
    programAddress,
    data: getUseInstructionDataEncoder().encode(args)
  };
  return instruction;
}
function parseUseInstruction(instruction) {
  if (instruction.accounts.length < 12) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === TOKEN_METADATA_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      authority: getNextAccount(),
      delegateRecord: getNextOptionalAccount(),
      token: getNextOptionalAccount(),
      mint: getNextAccount(),
      metadata: getNextAccount(),
      edition: getNextOptionalAccount(),
      payer: getNextAccount(),
      systemProgram: getNextAccount(),
      sysvarInstructions: getNextAccount(),
      splTokenProgram: getNextOptionalAccount(),
      authorizationRulesProgram: getNextOptionalAccount(),
      authorizationRules: getNextOptionalAccount()
    },
    data: getUseInstructionDataDecoder().decode(instruction.data)
  };
}
function getUtilizeInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["numberOfUses", getU64Encoder()]
    ]),
    (value) => ({ ...value, discriminator: 19 })
  );
}
function getUtilizeInstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["numberOfUses", getU64Decoder()]
  ]);
}
function getUtilizeInstructionDataCodec() {
  return combineCodec(
    getUtilizeInstructionDataEncoder(),
    getUtilizeInstructionDataDecoder()
  );
}
function getUtilizeInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true },
    tokenAccount: { value: input.tokenAccount ?? null, isWritable: true },
    mint: { value: input.mint ?? null, isWritable: true },
    useAuthority: { value: input.useAuthority ?? null, isWritable: true },
    owner: { value: input.owner ?? null, isWritable: false },
    tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
    ataProgram: { value: input.ataProgram ?? null, isWritable: false },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    rent: { value: input.rent ?? null, isWritable: false },
    useAuthorityRecord: {
      value: input.useAuthorityRecord ?? null,
      isWritable: true
    },
    burner: { value: input.burner ?? null, isWritable: false }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.tokenProgram.value) {
    accounts.tokenProgram.value = "TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA";
  }
  if (!accounts.ataProgram.value) {
    accounts.ataProgram.value = "ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL";
  }
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.rent.value) {
    accounts.rent.value = "SysvarRent111111111111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "omitted");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.tokenAccount),
      getAccountMeta(accounts.mint),
      getAccountMeta(accounts.useAuthority),
      getAccountMeta(accounts.owner),
      getAccountMeta(accounts.tokenProgram),
      getAccountMeta(accounts.ataProgram),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.rent),
      getAccountMeta(accounts.useAuthorityRecord),
      getAccountMeta(accounts.burner)
    ].filter((x) => x !== void 0),
    programAddress,
    data: getUtilizeInstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseUtilizeInstruction(instruction) {
  if (instruction.accounts.length < 9) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  let optionalAccountsRemaining = instruction.accounts.length - 9;
  const getNextOptionalAccount = () => {
    if (optionalAccountsRemaining === 0) return void 0;
    optionalAccountsRemaining -= 1;
    return getNextAccount();
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      metadata: getNextAccount(),
      tokenAccount: getNextAccount(),
      mint: getNextAccount(),
      useAuthority: getNextAccount(),
      owner: getNextAccount(),
      tokenProgram: getNextAccount(),
      ataProgram: getNextAccount(),
      systemProgram: getNextAccount(),
      rent: getNextAccount(),
      useAuthorityRecord: getNextOptionalAccount(),
      burner: getNextOptionalAccount()
    },
    data: getUtilizeInstructionDataDecoder().decode(instruction.data)
  };
}
function getVerifyInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([
      ["discriminator", getU8Encoder()],
      ["verificationArgs", getVerificationArgsEncoder()]
    ]),
    (value) => ({ ...value, discriminator: 52 })
  );
}
function getVerifyInstructionDataDecoder() {
  return getStructDecoder([
    ["discriminator", getU8Decoder()],
    ["verificationArgs", getVerificationArgsDecoder()]
  ]);
}
function getVerifyInstructionDataCodec() {
  return combineCodec(
    getVerifyInstructionDataEncoder(),
    getVerifyInstructionDataDecoder()
  );
}
function getVerifyInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    authority: { value: input.authority ?? null, isWritable: false },
    delegateRecord: { value: input.delegateRecord ?? null, isWritable: false },
    metadata: { value: input.metadata ?? null, isWritable: true },
    collectionMint: { value: input.collectionMint ?? null, isWritable: false },
    collectionMetadata: {
      value: input.collectionMetadata ?? null,
      isWritable: true
    },
    collectionMasterEdition: {
      value: input.collectionMasterEdition ?? null,
      isWritable: false
    },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    sysvarInstructions: {
      value: input.sysvarInstructions ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const args = { ...input };
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value = "11111111111111111111111111111111";
  }
  if (!accounts.sysvarInstructions.value) {
    accounts.sysvarInstructions.value = "Sysvar1nstructions1111111111111111111111111";
  }
  const getAccountMeta = getAccountMetaFactory(programAddress, "programId");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.delegateRecord),
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.collectionMint),
      getAccountMeta(accounts.collectionMetadata),
      getAccountMeta(accounts.collectionMasterEdition),
      getAccountMeta(accounts.systemProgram),
      getAccountMeta(accounts.sysvarInstructions)
    ],
    programAddress,
    data: getVerifyInstructionDataEncoder().encode(
      args
    )
  };
  return instruction;
}
function parseVerifyInstruction(instruction) {
  if (instruction.accounts.length < 8) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  const getNextOptionalAccount = () => {
    const accountMeta = getNextAccount();
    return accountMeta.address === TOKEN_METADATA_PROGRAM_ADDRESS ? void 0 : accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      authority: getNextAccount(),
      delegateRecord: getNextOptionalAccount(),
      metadata: getNextAccount(),
      collectionMint: getNextOptionalAccount(),
      collectionMetadata: getNextOptionalAccount(),
      collectionMasterEdition: getNextOptionalAccount(),
      systemProgram: getNextAccount(),
      sysvarInstructions: getNextAccount()
    },
    data: getVerifyInstructionDataDecoder().decode(instruction.data)
  };
}
function getVerifyCollectionInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 18 })
  );
}
function getVerifyCollectionInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getVerifyCollectionInstructionDataCodec() {
  return combineCodec(
    getVerifyCollectionInstructionDataEncoder(),
    getVerifyCollectionInstructionDataDecoder()
  );
}
function getVerifyCollectionInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true },
    collectionAuthority: {
      value: input.collectionAuthority ?? null,
      isWritable: true
    },
    payer: { value: input.payer ?? null, isWritable: true },
    collectionMint: { value: input.collectionMint ?? null, isWritable: false },
    collection: { value: input.collection ?? null, isWritable: false },
    collectionMasterEditionAccount: {
      value: input.collectionMasterEditionAccount ?? null,
      isWritable: false
    },
    collectionAuthorityRecord: {
      value: input.collectionAuthorityRecord ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const getAccountMeta = getAccountMetaFactory(programAddress, "omitted");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.collectionAuthority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.collectionMint),
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.collectionMasterEditionAccount),
      getAccountMeta(accounts.collectionAuthorityRecord)
    ].filter((x) => x !== void 0),
    programAddress,
    data: getVerifyCollectionInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseVerifyCollectionInstruction(instruction) {
  if (instruction.accounts.length < 6) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  let optionalAccountsRemaining = instruction.accounts.length - 6;
  const getNextOptionalAccount = () => {
    if (optionalAccountsRemaining === 0) return void 0;
    optionalAccountsRemaining -= 1;
    return getNextAccount();
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      metadata: getNextAccount(),
      collectionAuthority: getNextAccount(),
      payer: getNextAccount(),
      collectionMint: getNextAccount(),
      collection: getNextAccount(),
      collectionMasterEditionAccount: getNextAccount(),
      collectionAuthorityRecord: getNextOptionalAccount()
    },
    data: getVerifyCollectionInstructionDataDecoder().decode(instruction.data)
  };
}
function getVerifySizedCollectionItemInstructionDataEncoder() {
  return transformEncoder(
    getStructEncoder([["discriminator", getU8Encoder()]]),
    (value) => ({ ...value, discriminator: 30 })
  );
}
function getVerifySizedCollectionItemInstructionDataDecoder() {
  return getStructDecoder([["discriminator", getU8Decoder()]]);
}
function getVerifySizedCollectionItemInstructionDataCodec() {
  return combineCodec(
    getVerifySizedCollectionItemInstructionDataEncoder(),
    getVerifySizedCollectionItemInstructionDataDecoder()
  );
}
function getVerifySizedCollectionItemInstruction(input) {
  const programAddress = TOKEN_METADATA_PROGRAM_ADDRESS;
  const originalAccounts = {
    metadata: { value: input.metadata ?? null, isWritable: true },
    collectionAuthority: {
      value: input.collectionAuthority ?? null,
      isWritable: false
    },
    payer: { value: input.payer ?? null, isWritable: true },
    collectionMint: { value: input.collectionMint ?? null, isWritable: false },
    collection: { value: input.collection ?? null, isWritable: true },
    collectionMasterEditionAccount: {
      value: input.collectionMasterEditionAccount ?? null,
      isWritable: false
    },
    collectionAuthorityRecord: {
      value: input.collectionAuthorityRecord ?? null,
      isWritable: false
    }
  };
  const accounts = originalAccounts;
  const getAccountMeta = getAccountMetaFactory(programAddress, "omitted");
  const instruction = {
    accounts: [
      getAccountMeta(accounts.metadata),
      getAccountMeta(accounts.collectionAuthority),
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.collectionMint),
      getAccountMeta(accounts.collection),
      getAccountMeta(accounts.collectionMasterEditionAccount),
      getAccountMeta(accounts.collectionAuthorityRecord)
    ].filter((x) => x !== void 0),
    programAddress,
    data: getVerifySizedCollectionItemInstructionDataEncoder().encode({})
  };
  return instruction;
}
function parseVerifySizedCollectionItemInstruction(instruction) {
  if (instruction.accounts.length < 6) {
    throw new Error("Not enough accounts");
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts[accountIndex];
    accountIndex += 1;
    return accountMeta;
  };
  let optionalAccountsRemaining = instruction.accounts.length - 6;
  const getNextOptionalAccount = () => {
    if (optionalAccountsRemaining === 0) return void 0;
    optionalAccountsRemaining -= 1;
    return getNextAccount();
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      metadata: getNextAccount(),
      collectionAuthority: getNextAccount(),
      payer: getNextAccount(),
      collectionMint: getNextAccount(),
      collection: getNextAccount(),
      collectionMasterEditionAccount: getNextAccount(),
      collectionAuthorityRecord: getNextOptionalAccount()
    },
    data: getVerifySizedCollectionItemInstructionDataDecoder().decode(
      instruction.data
    )
  };
}
var createDefaultNft = async (args) => {
  const {
    client,
    payer,
    authority,
    owner,
    creators,
    collectionMint,
    standard = 0 /* NonFungible */,
    tokenProgram = TOKEN_PROGRAM_ID,
    ruleSet
  } = args;
  let { data } = args;
  if (!data) {
    data = {
      name: "Example NFT",
      symbol: "EXNFT",
      uri: "https://example.com/nft",
      sellerFeeBasisPoints: 500,
      creators: creators ? creators : [
        {
          address: authority.address,
          verified: true,
          share: 100
        }
      ],
      printSupply: printSupply("Zero"),
      tokenStandard: standard,
      collection: collectionMint ? { verified: false, key: collectionMint } : void 0,
      ruleSet
    };
  }
  if (data.tokenStandard != standard) {
    throw new Error("Token standard mismatch");
  }
  const accounts = {
    authority,
    owner,
    payer,
    tokenProgram
  };
  return await mintNft(client, accounts, data);
};
var createDefaultNftInCollection = async (args) => {
  const { client, payer, authority } = args;
  const collectionNft = await createDefaultNft(args);
  const { mint: collectionMint, metadata: collectionMetadata } = collectionNft;
  const nft = await createDefaultNft({ ...args, collectionMint });
  const { metadata } = nft;
  const verifyCollectionIx = getVerifyInstruction({
    authority,
    metadata,
    collectionMint,
    collectionMetadata,
    collectionMasterEdition: (await findMasterEditionPda({
      mint: collectionMint
    }))[0],
    verificationArgs: 1 /* CollectionV1 */
  });
  await pipe(
    await createDefaultTransaction(client, payer),
    (tx) => appendTransactionMessageInstruction(verifyCollectionIx, tx),
    (tx) => signAndSendTransaction(client, tx)
  );
  return { collection: collectionNft, item: nft };
};
var mintNft = async (client, accounts, data) => {
  const {
    name,
    symbol,
    uri,
    sellerFeeBasisPoints,
    creators,
    primarySaleHappened = false,
    isMutable = true,
    tokenStandard = 0 /* NonFungible */,
    collection,
    uses = null,
    collectionDetails: collectionDetails2 = null,
    ruleSet,
    decimals = null,
    printSupply: printSupply2
  } = data;
  const { authority, owner, tokenProgram = TOKEN_PROGRAM_ID } = accounts;
  let { payer, mint } = accounts;
  if (payer === null) {
    payer = authority;
  }
  if (mint === void 0) {
    mint = await generateKeyPairSigner();
  }
  const [metadata] = await findMetadataPda({ mint: mint.address });
  const [masterEdition] = await findMasterEditionPda({ mint: mint.address });
  const [token] = await findAssociatedTokenPda({
    owner,
    mint: mint.address,
    tokenProgram
  });
  let tokenRecord = void 0;
  if (tokenStandard === 4 /* ProgrammableNonFungible */) {
    [tokenRecord] = await findTokenRecordPda({ mint: mint.address, token });
  }
  const createIx = getCreateV1Instruction({
    metadata,
    masterEdition,
    mint,
    payer,
    authority,
    updateAuthority: authority,
    name,
    symbol,
    uri,
    sellerFeeBasisPoints,
    creators,
    primarySaleHappened,
    isMutable,
    tokenStandard,
    collection: collection ? some(collection) : none(),
    uses,
    collectionDetails: collectionDetails2,
    ruleSet: ruleSet ?? none(),
    decimals,
    printSupply: printSupply2 ?? none(),
    splTokenProgram: tokenProgram
  });
  const mintIx = getMintV1Instruction({
    token,
    tokenOwner: owner,
    metadata,
    masterEdition,
    mint: mint.address,
    authority,
    payer,
    tokenRecord,
    splTokenProgram: tokenProgram,
    amount: 1,
    authorizationData: null
  });
  await pipe(
    await createDefaultTransaction(client, payer),
    (tx) => appendTransactionMessageInstruction(createIx, tx),
    (tx) => appendTransactionMessageInstruction(mintIx, tx),
    (tx) => signAndSendTransaction(client, tx)
  );
  return {
    mint: mint.address,
    metadata,
    masterEdition,
    token,
    tokenRecord
  };
};
var initializeCollection = async ({
  client,
  payer,
  mintAuthority,
  owner,
  creators
}) => {
  const collectionMint = await createMint({
    client,
    payer,
    mintAuthority: mintAuthority.address,
    freezeAuthority: mintAuthority.address
  });
  const collectionTokenAccount = await createAta({
    client,
    payer,
    mint: collectionMint,
    owner
  });
  const mintToIx = getMintToInstruction({
    mint: collectionMint,
    token: collectionTokenAccount,
    mintAuthority,
    amount: 1
  });
  await pipe(
    await createDefaultTransaction(client, payer),
    (tx) => appendTransactionMessageInstruction(mintToIx, tx),
    (tx) => signAndSendTransaction(client, tx)
  );
  const meta = {
    name: "Compressed NFT",
    symbol: "COMP",
    uri: "https://v6nul6vaqrzhjm7qkcpbtbqcxmhwuzvcw2coxx2wali6sbxu634a.arweave.net/r5tF-qCEcnSz8FCeGYYCuw9qZqK2hOvfVgLR6Qb09vg",
    creators,
    editionNonce: some(0),
    tokenStandard: some(0 /* NonFungible */),
    uses: null,
    // Will be set to true during mint by bubblegum
    collection: null,
    primarySaleHappened: true,
    sellerFeeBasisPoints: 500,
    isMutable: false,
    collectionDetails: null,
    key: 2 /* MasterEditionV1 */,
    updateAuthority: mintAuthority.address,
    mint: collectionMint,
    programmableConfig: none()
  };
  const [collectionMetadataAccount] = await getProgramDerivedAddress({
    seeds: [
      Buffer.from("metadata", "utf8"),
      new Uint8Array(getAddressEncoder().encode(MPL_TOKEN_METADATA_PROGRAM_ID)),
      new Uint8Array(getAddressEncoder().encode(collectionMint))
    ],
    programAddress: MPL_TOKEN_METADATA_PROGRAM_ID
  });
  const data = {
    name: meta.name,
    symbol: meta.symbol,
    uri: meta.uri,
    sellerFeeBasisPoints: meta.sellerFeeBasisPoints,
    creators: meta.creators,
    collection: meta.collection,
    uses: meta.uses
  };
  const collectionMetadataIx = getCreateMetadataAccountV3Instruction({
    metadata: collectionMetadataAccount,
    mint: collectionMint,
    mintAuthority,
    payer,
    updateAuthority: mintAuthority,
    data,
    isMutable: meta.isMutable,
    collectionDetails: meta.collectionDetails
  });
  const [collectionMasterEditionAccount] = await getProgramDerivedAddress({
    seeds: [
      Buffer.from("metadata", "utf8"),
      new Uint8Array(getAddressEncoder().encode(MPL_TOKEN_METADATA_PROGRAM_ID)),
      new Uint8Array(getAddressEncoder().encode(collectionMint)),
      Buffer.from("edition", "utf8")
    ],
    programAddress: MPL_TOKEN_METADATA_PROGRAM_ID
  });
  const collectionMasterEditionIx = getCreateMasterEditionV3Instruction({
    edition: collectionMasterEditionAccount,
    mint: collectionMint,
    mintAuthority,
    payer,
    updateAuthority: mintAuthority,
    metadata: collectionMetadataAccount,
    maxSupply: 0
  });
  const sizeCollectionIx = getSetCollectionSizeInstruction({
    collectionMetadata: collectionMetadataAccount,
    collectionAuthority: mintAuthority,
    collectionMint,
    setCollectionSizeArgs: { size: 50 }
  });
  const { value: latestBlockhash } = await client.rpc.getLatestBlockhash().send();
  await pipe(
    createTransactionMessage({ version: 0 }),
    (tx) => setTransactionMessageFeePayerSigner(mintAuthority, tx),
    (tx) => setTransactionMessageFeePayerSigner(payer, tx),
    (tx) => setTransactionMessageLifetimeUsingBlockhash(latestBlockhash, tx),
    (tx) => appendTransactionMessageInstruction(collectionMetadataIx, tx),
    (tx) => appendTransactionMessageInstruction(collectionMasterEditionIx, tx),
    (tx) => appendTransactionMessageInstruction(sizeCollectionIx, tx),
    (tx) => signAndSendTransaction(client, tx)
  );
  return {
    collectionMint,
    collectionMetadataAccount,
    collectionMasterEditionAccount,
    metadata: meta
  };
};
var findAtaPda = async (seeds) => {
  return await getProgramDerivedAddress({
    seeds: [
      getAddressEncoder().encode(seeds.owner),
      getAddressEncoder().encode(seeds.tokenProgram ?? TOKEN_PROGRAM_ID),
      getAddressEncoder().encode(seeds.mint)
    ],
    programAddress: ASSOCIATED_TOKEN_ACCOUNTS_PROGRAM_ID
  });
};

export { AuthorityType, HolderDelegateRole, Key, MetadataDelegateRole, MigrationType, PayloadKey, RevokeArgs, TOKEN_METADATA_ERROR__ADDRESS_NOT_IN_RESERVATION, TOKEN_METADATA_ERROR__ALREADY_INITIALIZED, TOKEN_METADATA_ERROR__ALREADY_UNVERIFIED, TOKEN_METADATA_ERROR__ALREADY_VERIFIED, TOKEN_METADATA_ERROR__AMOUNT_MUST_BE_GREATER_THAN_ZERO, TOKEN_METADATA_ERROR__AUTHORIZATION_TOKEN_ACCOUNT_OWNER_MISMATCH, TOKEN_METADATA_ERROR__BEYOND_ALOTTED_ADDRESS_SIZE, TOKEN_METADATA_ERROR__BEYOND_MAX_ADDRESS_SIZE, TOKEN_METADATA_ERROR__BORSH_DESERIALIZATION_ERROR, TOKEN_METADATA_ERROR__BORSH_SERIALIZATION_ERROR, TOKEN_METADATA_ERROR__CANNOT_ADJUST_VERIFIED_CREATOR, TOKEN_METADATA_ERROR__CANNOT_BURN_WITH_DELEGATE, TOKEN_METADATA_ERROR__CANNOT_CHANGE_UPDATE_AUTHORITY_WITH_DELEGATE, TOKEN_METADATA_ERROR__CANNOT_CHANGE_USES_AFTER_FIRST_USE, TOKEN_METADATA_ERROR__CANNOT_CHANGE_USE_METHOD_AFTER_FIRST_USE, TOKEN_METADATA_ERROR__CANNOT_REMOVE_VERIFIED_CREATOR, TOKEN_METADATA_ERROR__CANNOT_UNVERIFY_ANOTHER_CREATOR, TOKEN_METADATA_ERROR__CANNOT_UPDATE_ASSET_WITH_DELEGATE, TOKEN_METADATA_ERROR__CANNOT_UPDATE_VERIFIED_COLLECTION, TOKEN_METADATA_ERROR__CANNOT_VERIFY_ANOTHER_CREATOR, TOKEN_METADATA_ERROR__CANNOT_WIPE_VERIFIED_CREATORS, TOKEN_METADATA_ERROR__COLLECTION_AUTHORITY_DOES_NOT_EXIST, TOKEN_METADATA_ERROR__COLLECTION_AUTHORITY_RECORD_ALREADY_EXISTS, TOKEN_METADATA_ERROR__COLLECTION_CANNOT_BE_VERIFIED_IN_THIS_INSTRUCTION, TOKEN_METADATA_ERROR__COLLECTION_MASTER_EDITION_ACCOUNT_INVALID, TOKEN_METADATA_ERROR__COLLECTION_MUST_BE_A_UNIQUE_MASTER_EDITION, TOKEN_METADATA_ERROR__COLLECTION_NOT_FOUND, TOKEN_METADATA_ERROR__COULD_NOT_DETERMINE_TOKEN_STANDARD, TOKEN_METADATA_ERROR__CREATORS_MUST_BE_ATLEAST_ONE, TOKEN_METADATA_ERROR__CREATORS_TOO_LONG, TOKEN_METADATA_ERROR__CREATOR_NOT_FOUND, TOKEN_METADATA_ERROR__DATA_INCREMENT_LIMIT_EXCEEDED, TOKEN_METADATA_ERROR__DATA_IS_EMPTY_OR_ZEROED, TOKEN_METADATA_ERROR__DATA_IS_IMMUTABLE, TOKEN_METADATA_ERROR__DATA_TYPE_MISMATCH, TOKEN_METADATA_ERROR__DELEGATE_ALREADY_EXISTS, TOKEN_METADATA_ERROR__DELEGATE_NOT_FOUND, TOKEN_METADATA_ERROR__DERIVED_KEY_INVALID, TOKEN_METADATA_ERROR__DESTINATION_MINT_MISMATCH, TOKEN_METADATA_ERROR__DISABLED, TOKEN_METADATA_ERROR__DUPLICATE_CREATOR_ADDRESS, TOKEN_METADATA_ERROR__EDITIONS_MUST_HAVE_EXACTLY_ONE_TOKEN, TOKEN_METADATA_ERROR__EDITION_ALREADY_MINTED, TOKEN_METADATA_ERROR__EDITION_MINT_DECIMALS_SHOULD_BE_ZERO, TOKEN_METADATA_ERROR__EDITION_NUMBER_GREATER_THAN_MAX_SUPPLY, TOKEN_METADATA_ERROR__EDITION_OVERRIDE_CANNOT_BE_ZERO, TOKEN_METADATA_ERROR__ESCROW_PARENT_HAS_DELEGATE, TOKEN_METADATA_ERROR__FEATURE_NOT_SUPPORTED, TOKEN_METADATA_ERROR__INCORRECT_OWNER, TOKEN_METADATA_ERROR__INCORRECT_TOKEN_STATE, TOKEN_METADATA_ERROR__INSTRUCTION_NOT_SUPPORTED, TOKEN_METADATA_ERROR__INSTRUCTION_PACK_ERROR, TOKEN_METADATA_ERROR__INSTRUCTION_UNPACK_ERROR, TOKEN_METADATA_ERROR__INSUFFICIENT_TOKENS, TOKEN_METADATA_ERROR__INSUFFICIENT_TOKEN_BALANCE, TOKEN_METADATA_ERROR__INVALID_AMOUNT, TOKEN_METADATA_ERROR__INVALID_ASSOCIATED_TOKEN_ACCOUNT_PROGRAM, TOKEN_METADATA_ERROR__INVALID_AUTHORITY_TYPE, TOKEN_METADATA_ERROR__INVALID_AUTHORIZATION_RULES, TOKEN_METADATA_ERROR__INVALID_BASIS_POINTS, TOKEN_METADATA_ERROR__INVALID_BUBBLEGUM_SIGNER, TOKEN_METADATA_ERROR__INVALID_CLOSE_AUTHORITY, TOKEN_METADATA_ERROR__INVALID_COLLECTION_AUTHORITY_RECORD, TOKEN_METADATA_ERROR__INVALID_COLLECTION_SIZE_CHANGE, TOKEN_METADATA_ERROR__INVALID_COLLECTION_UPDATE_AUTHORITY, TOKEN_METADATA_ERROR__INVALID_DELEGATE, TOKEN_METADATA_ERROR__INVALID_DELEGATE_ARGS, TOKEN_METADATA_ERROR__INVALID_DELEGATE_ROLE, TOKEN_METADATA_ERROR__INVALID_DELEGATE_ROLE_FOR_TRANSFER, TOKEN_METADATA_ERROR__INVALID_EDITION_INDEX, TOKEN_METADATA_ERROR__INVALID_EDITION_KEY, TOKEN_METADATA_ERROR__INVALID_EDITION_MARKER, TOKEN_METADATA_ERROR__INVALID_ESCROW_BUMP_SEED, TOKEN_METADATA_ERROR__INVALID_FEE_ACCOUNT, TOKEN_METADATA_ERROR__INVALID_FREEZE_AUTHORITY, TOKEN_METADATA_ERROR__INVALID_INSTRUCTION, TOKEN_METADATA_ERROR__INVALID_INSTRUCTIONS_SYSVAR, TOKEN_METADATA_ERROR__INVALID_LOCKED_TRANSFER_ADDRESS, TOKEN_METADATA_ERROR__INVALID_MASTER_EDITION, TOKEN_METADATA_ERROR__INVALID_MASTER_EDITION_ACCOUNT_LENGTH, TOKEN_METADATA_ERROR__INVALID_METADATA_FLAGS, TOKEN_METADATA_ERROR__INVALID_METADATA_KEY, TOKEN_METADATA_ERROR__INVALID_METADATA_POINTER, TOKEN_METADATA_ERROR__INVALID_MINT_AUTHORITY, TOKEN_METADATA_ERROR__INVALID_MINT_CLOSE_AUTHORITY, TOKEN_METADATA_ERROR__INVALID_MINT_EXTENSION_TYPE, TOKEN_METADATA_ERROR__INVALID_MINT_FOR_TOKEN_STANDARD, TOKEN_METADATA_ERROR__INVALID_OPERATION, TOKEN_METADATA_ERROR__INVALID_OWNER, TOKEN_METADATA_ERROR__INVALID_PARENT_ACCOUNTS, TOKEN_METADATA_ERROR__INVALID_PRINT_EDITION, TOKEN_METADATA_ERROR__INVALID_PROGRAMMABLE_CONFIG, TOKEN_METADATA_ERROR__INVALID_SYSTEM_PROGRAM, TOKEN_METADATA_ERROR__INVALID_SYSTEM_WALLET, TOKEN_METADATA_ERROR__INVALID_TOKEN_EXTENSION_TYPE, TOKEN_METADATA_ERROR__INVALID_TOKEN_PROGRAM, TOKEN_METADATA_ERROR__INVALID_TOKEN_RECORD, TOKEN_METADATA_ERROR__INVALID_TOKEN_STANDARD, TOKEN_METADATA_ERROR__INVALID_TRANSFER_AUTHORITY, TOKEN_METADATA_ERROR__INVALID_UPDATE_ARGS, TOKEN_METADATA_ERROR__INVALID_USER, TOKEN_METADATA_ERROR__INVALID_USE_AUTHORITY_RECORD, TOKEN_METADATA_ERROR__INVALID_USE_METHOD, TOKEN_METADATA_ERROR__IS_MUTABLE_CAN_ONLY_BE_FLIPPED_TO_FALSE, TOKEN_METADATA_ERROR__KEY_MISMATCH, TOKEN_METADATA_ERROR__LOCKED_TOKEN, TOKEN_METADATA_ERROR__MASTER_EDITION_HAS_PRINTS, TOKEN_METADATA_ERROR__MASTER_RECORD_MISMATCH, TOKEN_METADATA_ERROR__MAX_EDITIONS_MINTED_ALREADY, TOKEN_METADATA_ERROR__MINT_IS_NOT_SIGNER, TOKEN_METADATA_ERROR__MINT_MISMATCH, TOKEN_METADATA_ERROR__MINT_SUPPLY_MUST_BE_ZERO, TOKEN_METADATA_ERROR__MISSING_ACCOUNT_IN_BUILDER, TOKEN_METADATA_ERROR__MISSING_ARGUMENT_IN_BUILDER, TOKEN_METADATA_ERROR__MISSING_AUTHORIZATION_RULES, TOKEN_METADATA_ERROR__MISSING_AUTHORIZATION_RULES_PROGRAM, TOKEN_METADATA_ERROR__MISSING_COLLECTION_MASTER_EDITION, TOKEN_METADATA_ERROR__MISSING_COLLECTION_METADATA, TOKEN_METADATA_ERROR__MISSING_COLLECTION_MINT, TOKEN_METADATA_ERROR__MISSING_DELEGATE_RECORD, TOKEN_METADATA_ERROR__MISSING_DELEGATE_ROLE, TOKEN_METADATA_ERROR__MISSING_EDITION, TOKEN_METADATA_ERROR__MISSING_EDITION_ACCOUNT, TOKEN_METADATA_ERROR__MISSING_EDITION_MARKER_ACCOUNT, TOKEN_METADATA_ERROR__MISSING_IMMUTABLE_OWNER_EXTENSION, TOKEN_METADATA_ERROR__MISSING_LOCKED_TRANSFER_ADDRESS, TOKEN_METADATA_ERROR__MISSING_MASTER_EDITION_ACCOUNT, TOKEN_METADATA_ERROR__MISSING_MASTER_EDITION_MINT_ACCOUNT, TOKEN_METADATA_ERROR__MISSING_MASTER_EDITION_TOKEN_ACCOUNT, TOKEN_METADATA_ERROR__MISSING_PRINT_SUPPLY, TOKEN_METADATA_ERROR__MISSING_PROGRAMMABLE_CONFIG, TOKEN_METADATA_ERROR__MISSING_SPL_TOKEN_PROGRAM, TOKEN_METADATA_ERROR__MISSING_TOKEN_ACCOUNT, TOKEN_METADATA_ERROR__MISSING_TOKEN_OWNER_ACCOUNT, TOKEN_METADATA_ERROR__MISSING_TOKEN_RECORD, TOKEN_METADATA_ERROR__MUST_BE_BURNED, TOKEN_METADATA_ERROR__MUST_BE_ESCROW_AUTHORITY, TOKEN_METADATA_ERROR__MUST_BE_NON_FUNGIBLE, TOKEN_METADATA_ERROR__MUST_BE_ONE_OF_CREATORS, TOKEN_METADATA_ERROR__MUST_UNVERIFY, TOKEN_METADATA_ERROR__NAME_TOO_LONG, TOKEN_METADATA_ERROR__NOT_ALLOWED_TO_CHANGE_SELLER_FEE_BASIS_POINTS, TOKEN_METADATA_ERROR__NOT_A_COLLECTION_PARENT, TOKEN_METADATA_ERROR__NOT_A_MASTER_EDITION, TOKEN_METADATA_ERROR__NOT_A_MEMBER_OF_COLLECTION, TOKEN_METADATA_ERROR__NOT_A_PRINT_EDITION, TOKEN_METADATA_ERROR__NOT_ENOUGH_TOKENS, TOKEN_METADATA_ERROR__NOT_ENOUGH_USES, TOKEN_METADATA_ERROR__NOT_MINT_AUTHORITY, TOKEN_METADATA_ERROR__NOT_RENT_EXEMPT, TOKEN_METADATA_ERROR__NOT_VERIFIED_MEMBER_OF_COLLECTION, TOKEN_METADATA_ERROR__NO_BALANCE_IN_ACCOUNT_FOR_AUTHORIZATION, TOKEN_METADATA_ERROR__NO_CREATORS_PRESENT_ON_METADATA, TOKEN_METADATA_ERROR__NO_FREEZE_AUTHORITY_SET, TOKEN_METADATA_ERROR__NUMERICAL_OVERFLOW_ERROR, TOKEN_METADATA_ERROR__ONE_TIME_AUTH_MINT_SUPPLY_MUST_BE_ZERO_FOR_CONVERSION, TOKEN_METADATA_ERROR__ONE_TIME_PRINTING_AUTHORIZATION_MINT_DECIMALS_SHOULD_BE_ZERO, TOKEN_METADATA_ERROR__ONE_TIME_PRINTING_AUTH_MINT_MISMATCH, TOKEN_METADATA_ERROR__ONLY_SALE_DELEGATE_CAN_TRANSFER, TOKEN_METADATA_ERROR__OWNER_MISMATCH, TOKEN_METADATA_ERROR__PRIMARY_SALE_CAN_ONLY_BE_FLIPPED_TO_TRUE, TOKEN_METADATA_ERROR__PRINTING_MINT_AUTHORIZATION_ACCOUNT_MISMATCH, TOKEN_METADATA_ERROR__PRINTING_MINT_DECIMALS_SHOULD_BE_ZERO, TOKEN_METADATA_ERROR__PRINTING_MINT_MISMATCH, TOKEN_METADATA_ERROR__PRINTING_MINT_SUPPLY_MUST_BE_ZERO_FOR_CONVERSION, TOKEN_METADATA_ERROR__PRINTING_WOULD_BREACH_MAXIMUM_SUPPLY, TOKEN_METADATA_ERROR__PRINT_EDITION_DOES_NOT_MATCH_MASTER_EDITION, TOKEN_METADATA_ERROR__REMOVED, TOKEN_METADATA_ERROR__RESERVATION_ALREADY_MADE, TOKEN_METADATA_ERROR__RESERVATION_ARRAY_SHOULD_BE_SIZE_ONE, TOKEN_METADATA_ERROR__RESERVATION_BREACHES_MAXIMUM_SUPPLY, TOKEN_METADATA_ERROR__RESERVATION_DOES_NOT_EXIST, TOKEN_METADATA_ERROR__RESERVATION_EXISTS, TOKEN_METADATA_ERROR__RESERVATION_LIST_DEPRECATED, TOKEN_METADATA_ERROR__RESERVATION_NOT_COMPLETE, TOKEN_METADATA_ERROR__RESERVATION_NOT_SET, TOKEN_METADATA_ERROR__RESERVATION_SPOTS_REMAINING_SHOULD_MATCH_TOTAL_SPOTS_AT_START, TOKEN_METADATA_ERROR__REVOKE_COLLECTION_AUTHORITY_SIGNER_INCORRECT, TOKEN_METADATA_ERROR__SHARE_TOTAL_MUST_BE100, TOKEN_METADATA_ERROR__SIZED_COLLECTION, TOKEN_METADATA_ERROR__SPOT_MISMATCH, TOKEN_METADATA_ERROR__SYMBOL_TOO_LONG, TOKEN_METADATA_ERROR__TOKEN_ACCOUNT_MINT_MISMATCH, TOKEN_METADATA_ERROR__TOKEN_ACCOUNT_MINT_MISMATCH_V2, TOKEN_METADATA_ERROR__TOKEN_ACCOUNT_ONE_TIME_AUTH_MINT_MISMATCH, TOKEN_METADATA_ERROR__TOKEN_BURN_FAILED, TOKEN_METADATA_ERROR__TOKEN_CLOSE_FAILED, TOKEN_METADATA_ERROR__TOKEN_MINT_TO_FAILED, TOKEN_METADATA_ERROR__TRIED_TO_REPLACE_AN_EXISTING_RESERVATION, TOKEN_METADATA_ERROR__UNINITIALIZED, TOKEN_METADATA_ERROR__UNLOCKED_TOKEN, TOKEN_METADATA_ERROR__UNSIZED_COLLECTION, TOKEN_METADATA_ERROR__UNUSABLE, TOKEN_METADATA_ERROR__UPDATE_AUTHORITY_INCORRECT, TOKEN_METADATA_ERROR__UPDATE_AUTHORITY_IS_NOT_SIGNER, TOKEN_METADATA_ERROR__UPDATE_AUTHORITY_MUST_BE_EQUAL_TO_METADATA_AUTHORITY_AND_SIGNER, TOKEN_METADATA_ERROR__URI_TOO_LONG, TOKEN_METADATA_ERROR__USE_AUTHORITY_RECORD_ALREADY_EXISTS, TOKEN_METADATA_ERROR__USE_AUTHORITY_RECORD_ALREADY_REVOKED, TOKEN_METADATA_PROGRAM_ADDRESS, TokenDelegateRole, TokenMetadataAccount, TokenMetadataInstruction, TokenStandard, TokenState, UseMethod, VerificationArgs, burnArgs, collectionDetails, collectionDetailsToggle, collectionToggle, createArgs, createDefaultNft, createDefaultNftInCollection, decodeCollectionAuthorityRecord, decodeEdition, decodeEditionMarker, decodeEditionMarkerV2, decodeHolderDelegateRecord, decodeMasterEdition, decodeMasterEditionV1, decodeMetadata, decodeMetadataDelegateRecord, decodeReservationListV1, decodeReservationListV2, decodeTokenOwnedEscrow, decodeTokenRecord, decodeUseAuthorityRecord, delegateArgs, escrowAuthority, fetchAllCollectionAuthorityRecord, fetchAllEdition, fetchAllEditionMarker, fetchAllEditionMarkerV2, fetchAllHolderDelegateRecord, fetchAllMasterEdition, fetchAllMasterEditionV1, fetchAllMaybeCollectionAuthorityRecord, fetchAllMaybeEdition, fetchAllMaybeEditionMarker, fetchAllMaybeEditionMarkerV2, fetchAllMaybeHolderDelegateRecord, fetchAllMaybeMasterEdition, fetchAllMaybeMasterEditionV1, fetchAllMaybeMetadata, fetchAllMaybeMetadataDelegateRecord, fetchAllMaybeReservationListV1, fetchAllMaybeReservationListV2, fetchAllMaybeTokenOwnedEscrow, fetchAllMaybeTokenRecord, fetchAllMaybeUseAuthorityRecord, fetchAllMetadata, fetchAllMetadataDelegateRecord, fetchAllReservationListV1, fetchAllReservationListV2, fetchAllTokenOwnedEscrow, fetchAllTokenRecord, fetchAllUseAuthorityRecord, fetchCollectionAuthorityRecord, fetchEdition, fetchEditionMarker, fetchEditionMarkerV2, fetchHolderDelegateRecord, fetchMasterEdition, fetchMasterEditionFromSeeds, fetchMasterEditionV1, fetchMaybeCollectionAuthorityRecord, fetchMaybeEdition, fetchMaybeEditionMarker, fetchMaybeEditionMarkerV2, fetchMaybeHolderDelegateRecord, fetchMaybeMasterEdition, fetchMaybeMasterEditionFromSeeds, fetchMaybeMasterEditionV1, fetchMaybeMetadata, fetchMaybeMetadataDelegateRecord, fetchMaybeMetadataFromSeeds, fetchMaybeReservationListV1, fetchMaybeReservationListV2, fetchMaybeTokenOwnedEscrow, fetchMaybeTokenRecord, fetchMaybeTokenRecordFromSeeds, fetchMaybeUseAuthorityRecord, fetchMetadata, fetchMetadataDelegateRecord, fetchMetadataFromSeeds, fetchReservationListV1, fetchReservationListV2, fetchTokenOwnedEscrow, fetchTokenRecord, fetchTokenRecordFromSeeds, fetchUseAuthorityRecord, findAtaPda, findMasterEditionPda, findMetadataPda, findTokenRecordPda, getApproveCollectionAuthorityInstruction, getApproveCollectionAuthorityInstructionDataCodec, getApproveCollectionAuthorityInstructionDataDecoder, getApproveCollectionAuthorityInstructionDataEncoder, getApproveUseAuthorityInstruction, getApproveUseAuthorityInstructionDataCodec, getApproveUseAuthorityInstructionDataDecoder, getApproveUseAuthorityInstructionDataEncoder, getAuthorityTypeCodec, getAuthorityTypeDecoder, getAuthorityTypeEncoder, getAuthorizationDataCodec, getAuthorizationDataDecoder, getAuthorizationDataEncoder, getBubblegumSetCollectionSizeInstruction, getBubblegumSetCollectionSizeInstructionDataCodec, getBubblegumSetCollectionSizeInstructionDataDecoder, getBubblegumSetCollectionSizeInstructionDataEncoder, getBurnArgsCodec, getBurnArgsDecoder, getBurnArgsEncoder, getBurnEditionNftInstruction, getBurnEditionNftInstructionDataCodec, getBurnEditionNftInstructionDataDecoder, getBurnEditionNftInstructionDataEncoder, getBurnInstruction, getBurnInstructionDataCodec, getBurnInstructionDataDecoder, getBurnInstructionDataEncoder, getBurnNftInstruction, getBurnNftInstructionDataCodec, getBurnNftInstructionDataDecoder, getBurnNftInstructionDataEncoder, getCloseEscrowAccountInstruction, getCloseEscrowAccountInstructionDataCodec, getCloseEscrowAccountInstructionDataDecoder, getCloseEscrowAccountInstructionDataEncoder, getCollectInstruction, getCollectInstructionDataCodec, getCollectInstructionDataDecoder, getCollectInstructionDataEncoder, getCollectionAuthorityRecordCodec, getCollectionAuthorityRecordDecoder, getCollectionAuthorityRecordEncoder, getCollectionCodec, getCollectionDecoder, getCollectionDetailsCodec, getCollectionDetailsDecoder, getCollectionDetailsEncoder, getCollectionDetailsToggleCodec, getCollectionDetailsToggleDecoder, getCollectionDetailsToggleEncoder, getCollectionEncoder, getCollectionToggleCodec, getCollectionToggleDecoder, getCollectionToggleEncoder, getConvertMasterEditionV1ToV2Instruction, getConvertMasterEditionV1ToV2InstructionDataCodec, getConvertMasterEditionV1ToV2InstructionDataDecoder, getConvertMasterEditionV1ToV2InstructionDataEncoder, getCreateArgsCodec, getCreateArgsDecoder, getCreateArgsEncoder, getCreateEscrowAccountInstruction, getCreateEscrowAccountInstructionDataCodec, getCreateEscrowAccountInstructionDataDecoder, getCreateEscrowAccountInstructionDataEncoder, getCreateMasterEditionInstruction, getCreateMasterEditionInstructionDataCodec, getCreateMasterEditionInstructionDataDecoder, getCreateMasterEditionInstructionDataEncoder, getCreateMasterEditionV3Instruction, getCreateMasterEditionV3InstructionDataCodec, getCreateMasterEditionV3InstructionDataDecoder, getCreateMasterEditionV3InstructionDataEncoder, getCreateMetadataAccountInstruction, getCreateMetadataAccountInstructionDataCodec, getCreateMetadataAccountInstructionDataDecoder, getCreateMetadataAccountInstructionDataEncoder, getCreateMetadataAccountV2Instruction, getCreateMetadataAccountV2InstructionDataCodec, getCreateMetadataAccountV2InstructionDataDecoder, getCreateMetadataAccountV2InstructionDataEncoder, getCreateMetadataAccountV3Instruction, getCreateMetadataAccountV3InstructionDataCodec, getCreateMetadataAccountV3InstructionDataDecoder, getCreateMetadataAccountV3InstructionDataEncoder, getCreateV1Instruction, getCreateV1InstructionAsync, getCreateV1InstructionDataCodec, getCreateV1InstructionDataDecoder, getCreateV1InstructionDataEncoder, getCreatorCodec, getCreatorDecoder, getCreatorEncoder, getDataCodec, getDataDecoder, getDataEncoder, getDataV2Codec, getDataV2Decoder, getDataV2Encoder, getDelegateArgsCodec, getDelegateArgsDecoder, getDelegateArgsEncoder, getDelegateInstruction, getDelegateInstructionDataCodec, getDelegateInstructionDataDecoder, getDelegateInstructionDataEncoder, getDeprecatedCreateMasterEditionInstruction, getDeprecatedCreateMasterEditionInstructionDataCodec, getDeprecatedCreateMasterEditionInstructionDataDecoder, getDeprecatedCreateMasterEditionInstructionDataEncoder, getDeprecatedCreateReservationListInstruction, getDeprecatedCreateReservationListInstructionDataCodec, getDeprecatedCreateReservationListInstructionDataDecoder, getDeprecatedCreateReservationListInstructionDataEncoder, getDeprecatedMintNewEditionFromMasterEditionViaPrintingTokenInstruction, getDeprecatedMintNewEditionFromMasterEditionViaPrintingTokenInstructionDataCodec, getDeprecatedMintNewEditionFromMasterEditionViaPrintingTokenInstructionDataDecoder, getDeprecatedMintNewEditionFromMasterEditionViaPrintingTokenInstructionDataEncoder, getDeprecatedMintPrintingTokensInstruction, getDeprecatedMintPrintingTokensInstructionDataCodec, getDeprecatedMintPrintingTokensInstructionDataDecoder, getDeprecatedMintPrintingTokensInstructionDataEncoder, getDeprecatedMintPrintingTokensViaTokenInstruction, getDeprecatedMintPrintingTokensViaTokenInstructionDataCodec, getDeprecatedMintPrintingTokensViaTokenInstructionDataDecoder, getDeprecatedMintPrintingTokensViaTokenInstructionDataEncoder, getDeprecatedSetReservationListInstruction, getDeprecatedSetReservationListInstructionDataCodec, getDeprecatedSetReservationListInstructionDataDecoder, getDeprecatedSetReservationListInstructionDataEncoder, getEditionCodec, getEditionDecoder, getEditionEncoder, getEditionMarkerCodec, getEditionMarkerDecoder, getEditionMarkerEncoder, getEditionMarkerSize, getEditionMarkerV2Codec, getEditionMarkerV2Decoder, getEditionMarkerV2Encoder, getEditionSize, getEscrowAuthorityCodec, getEscrowAuthorityDecoder, getEscrowAuthorityEncoder, getFreezeDelegatedAccountInstruction, getFreezeDelegatedAccountInstructionDataCodec, getFreezeDelegatedAccountInstructionDataDecoder, getFreezeDelegatedAccountInstructionDataEncoder, getHolderDelegateRecordCodec, getHolderDelegateRecordDecoder, getHolderDelegateRecordEncoder, getHolderDelegateRecordSize, getHolderDelegateRoleCodec, getHolderDelegateRoleDecoder, getHolderDelegateRoleEncoder, getKeyCodec, getKeyDecoder, getKeyEncoder, getLockArgsCodec, getLockArgsDecoder, getLockArgsEncoder, getLockInstruction, getLockInstructionDataCodec, getLockInstructionDataDecoder, getLockInstructionDataEncoder, getMasterEditionCodec, getMasterEditionDecoder, getMasterEditionEncoder, getMasterEditionV1Codec, getMasterEditionV1Decoder, getMasterEditionV1Encoder, getMetadataCodec, getMetadataDecoder, getMetadataDelegateRecordCodec, getMetadataDelegateRecordDecoder, getMetadataDelegateRecordEncoder, getMetadataDelegateRecordSize, getMetadataDelegateRoleCodec, getMetadataDelegateRoleDecoder, getMetadataDelegateRoleEncoder, getMetadataEncoder, getMigrateInstruction, getMigrateInstructionDataCodec, getMigrateInstructionDataDecoder, getMigrateInstructionDataEncoder, getMigrationTypeCodec, getMigrationTypeDecoder, getMigrationTypeEncoder, getMintArgsCodec, getMintArgsDecoder, getMintArgsEncoder, getMintNewEditionFromMasterEditionViaTokenArgsCodec, getMintNewEditionFromMasterEditionViaTokenArgsDecoder, getMintNewEditionFromMasterEditionViaTokenArgsEncoder, getMintNewEditionFromMasterEditionViaTokenInstruction, getMintNewEditionFromMasterEditionViaTokenInstructionDataCodec, getMintNewEditionFromMasterEditionViaTokenInstructionDataDecoder, getMintNewEditionFromMasterEditionViaTokenInstructionDataEncoder, getMintNewEditionFromMasterEditionViaVaultProxyInstruction, getMintNewEditionFromMasterEditionViaVaultProxyInstructionDataCodec, getMintNewEditionFromMasterEditionViaVaultProxyInstructionDataDecoder, getMintNewEditionFromMasterEditionViaVaultProxyInstructionDataEncoder, getMintV1Instruction, getMintV1InstructionDataCodec, getMintV1InstructionDataDecoder, getMintV1InstructionDataEncoder, getPayloadCodec, getPayloadDecoder, getPayloadEncoder, getPayloadKeyCodec, getPayloadKeyDecoder, getPayloadKeyEncoder, getPayloadTypeCodec, getPayloadTypeDecoder, getPayloadTypeEncoder, getPrintArgsCodec, getPrintArgsDecoder, getPrintArgsEncoder, getPrintInstruction, getPrintInstructionDataCodec, getPrintInstructionDataDecoder, getPrintInstructionDataEncoder, getPrintSupplyCodec, getPrintSupplyDecoder, getPrintSupplyEncoder, getProgrammableConfigCodec, getProgrammableConfigDecoder, getProgrammableConfigEncoder, getProofInfoCodec, getProofInfoDecoder, getProofInfoEncoder, getPuffMetadataInstruction, getPuffMetadataInstructionDataCodec, getPuffMetadataInstructionDataDecoder, getPuffMetadataInstructionDataEncoder, getRemoveCreatorVerificationInstruction, getRemoveCreatorVerificationInstructionDataCodec, getRemoveCreatorVerificationInstructionDataDecoder, getRemoveCreatorVerificationInstructionDataEncoder, getReservationCodec, getReservationDecoder, getReservationEncoder, getReservationListV1Codec, getReservationListV1Decoder, getReservationListV1Encoder, getReservationListV2Codec, getReservationListV2Decoder, getReservationListV2Encoder, getReservationV1Codec, getReservationV1Decoder, getReservationV1Encoder, getRevokeArgsCodec, getRevokeArgsDecoder, getRevokeArgsEncoder, getRevokeCollectionAuthorityInstruction, getRevokeCollectionAuthorityInstructionDataCodec, getRevokeCollectionAuthorityInstructionDataDecoder, getRevokeCollectionAuthorityInstructionDataEncoder, getRevokeInstruction, getRevokeInstructionDataCodec, getRevokeInstructionDataDecoder, getRevokeInstructionDataEncoder, getRevokeUseAuthorityInstruction, getRevokeUseAuthorityInstructionDataCodec, getRevokeUseAuthorityInstructionDataDecoder, getRevokeUseAuthorityInstructionDataEncoder, getRuleSetToggleCodec, getRuleSetToggleDecoder, getRuleSetToggleEncoder, getSeedsVecCodec, getSeedsVecDecoder, getSeedsVecEncoder, getSetAndVerifyCollectionInstruction, getSetAndVerifyCollectionInstructionDataCodec, getSetAndVerifyCollectionInstructionDataDecoder, getSetAndVerifyCollectionInstructionDataEncoder, getSetAndVerifySizedCollectionItemInstruction, getSetAndVerifySizedCollectionItemInstructionDataCodec, getSetAndVerifySizedCollectionItemInstructionDataDecoder, getSetAndVerifySizedCollectionItemInstructionDataEncoder, getSetCollectionSizeArgsCodec, getSetCollectionSizeArgsDecoder, getSetCollectionSizeArgsEncoder, getSetCollectionSizeInstruction, getSetCollectionSizeInstructionDataCodec, getSetCollectionSizeInstructionDataDecoder, getSetCollectionSizeInstructionDataEncoder, getSetTokenStandardInstruction, getSetTokenStandardInstructionDataCodec, getSetTokenStandardInstructionDataDecoder, getSetTokenStandardInstructionDataEncoder, getSignMetadataInstruction, getSignMetadataInstructionDataCodec, getSignMetadataInstructionDataDecoder, getSignMetadataInstructionDataEncoder, getThawDelegatedAccountInstruction, getThawDelegatedAccountInstructionDataCodec, getThawDelegatedAccountInstructionDataDecoder, getThawDelegatedAccountInstructionDataEncoder, getTokenDelegateRoleCodec, getTokenDelegateRoleDecoder, getTokenDelegateRoleEncoder, getTokenMetadataErrorMessage, getTokenOwnedEscrowCodec, getTokenOwnedEscrowDecoder, getTokenOwnedEscrowEncoder, getTokenRecordCodec, getTokenRecordDecoder, getTokenRecordEncoder, getTokenStandardCodec, getTokenStandardDecoder, getTokenStandardEncoder, getTokenStateCodec, getTokenStateDecoder, getTokenStateEncoder, getTransferArgsCodec, getTransferArgsDecoder, getTransferArgsEncoder, getTransferInstruction, getTransferInstructionDataCodec, getTransferInstructionDataDecoder, getTransferInstructionDataEncoder, getTransferOutOfEscrowInstruction, getTransferOutOfEscrowInstructionDataCodec, getTransferOutOfEscrowInstructionDataDecoder, getTransferOutOfEscrowInstructionDataEncoder, getUnlockArgsCodec, getUnlockArgsDecoder, getUnlockArgsEncoder, getUnlockInstruction, getUnlockInstructionDataCodec, getUnlockInstructionDataDecoder, getUnlockInstructionDataEncoder, getUnverifyCollectionInstruction, getUnverifyCollectionInstructionDataCodec, getUnverifyCollectionInstructionDataDecoder, getUnverifyCollectionInstructionDataEncoder, getUnverifyInstruction, getUnverifyInstructionDataCodec, getUnverifyInstructionDataDecoder, getUnverifyInstructionDataEncoder, getUnverifySizedCollectionItemInstruction, getUnverifySizedCollectionItemInstructionDataCodec, getUnverifySizedCollectionItemInstructionDataDecoder, getUnverifySizedCollectionItemInstructionDataEncoder, getUpdateArgsCodec, getUpdateArgsDecoder, getUpdateArgsEncoder, getUpdateInstruction, getUpdateInstructionDataCodec, getUpdateInstructionDataDecoder, getUpdateInstructionDataEncoder, getUpdateMetadataAccountInstruction, getUpdateMetadataAccountInstructionDataCodec, getUpdateMetadataAccountInstructionDataDecoder, getUpdateMetadataAccountInstructionDataEncoder, getUpdateMetadataAccountV2Instruction, getUpdateMetadataAccountV2InstructionDataCodec, getUpdateMetadataAccountV2InstructionDataDecoder, getUpdateMetadataAccountV2InstructionDataEncoder, getUpdatePrimarySaleHappenedViaTokenInstruction, getUpdatePrimarySaleHappenedViaTokenInstructionDataCodec, getUpdatePrimarySaleHappenedViaTokenInstructionDataDecoder, getUpdatePrimarySaleHappenedViaTokenInstructionDataEncoder, getUseArgsCodec, getUseArgsDecoder, getUseArgsEncoder, getUseAuthorityRecordCodec, getUseAuthorityRecordDecoder, getUseAuthorityRecordEncoder, getUseAuthorityRecordSize, getUseInstruction, getUseInstructionDataCodec, getUseInstructionDataDecoder, getUseInstructionDataEncoder, getUseMethodCodec, getUseMethodDecoder, getUseMethodEncoder, getUsesCodec, getUsesDecoder, getUsesEncoder, getUsesToggleCodec, getUsesToggleDecoder, getUsesToggleEncoder, getUtilizeInstruction, getUtilizeInstructionDataCodec, getUtilizeInstructionDataDecoder, getUtilizeInstructionDataEncoder, getVerificationArgsCodec, getVerificationArgsDecoder, getVerificationArgsEncoder, getVerifyCollectionInstruction, getVerifyCollectionInstructionDataCodec, getVerifyCollectionInstructionDataDecoder, getVerifyCollectionInstructionDataEncoder, getVerifyInstruction, getVerifyInstructionDataCodec, getVerifyInstructionDataDecoder, getVerifyInstructionDataEncoder, getVerifySizedCollectionItemInstruction, getVerifySizedCollectionItemInstructionDataCodec, getVerifySizedCollectionItemInstructionDataDecoder, getVerifySizedCollectionItemInstructionDataEncoder, identifyTokenMetadataInstruction, initializeCollection, isBurnArgs, isCollectionDetails, isCollectionDetailsToggle, isCollectionToggle, isCreateArgs, isDelegateArgs, isEscrowAuthority, isLockArgs, isMintArgs, isPayloadType, isPrintArgs, isPrintSupply, isProgrammableConfig, isRuleSetToggle, isTokenMetadataError, isTransferArgs, isUnlockArgs, isUpdateArgs, isUseArgs, isUsesToggle, lockArgs, mintArgs, mintNft, parseApproveCollectionAuthorityInstruction, parseApproveUseAuthorityInstruction, parseBubblegumSetCollectionSizeInstruction, parseBurnEditionNftInstruction, parseBurnInstruction, parseBurnNftInstruction, parseCloseEscrowAccountInstruction, parseCollectInstruction, parseConvertMasterEditionV1ToV2Instruction, parseCreateEscrowAccountInstruction, parseCreateMasterEditionInstruction, parseCreateMasterEditionV3Instruction, parseCreateMetadataAccountInstruction, parseCreateMetadataAccountV2Instruction, parseCreateMetadataAccountV3Instruction, parseCreateV1Instruction, parseDelegateInstruction, parseDeprecatedCreateMasterEditionInstruction, parseDeprecatedCreateReservationListInstruction, parseDeprecatedMintNewEditionFromMasterEditionViaPrintingTokenInstruction, parseDeprecatedMintPrintingTokensInstruction, parseDeprecatedMintPrintingTokensViaTokenInstruction, parseDeprecatedSetReservationListInstruction, parseFreezeDelegatedAccountInstruction, parseLockInstruction, parseMigrateInstruction, parseMintNewEditionFromMasterEditionViaTokenInstruction, parseMintNewEditionFromMasterEditionViaVaultProxyInstruction, parseMintV1Instruction, parsePrintInstruction, parsePuffMetadataInstruction, parseRemoveCreatorVerificationInstruction, parseRevokeCollectionAuthorityInstruction, parseRevokeInstruction, parseRevokeUseAuthorityInstruction, parseSetAndVerifyCollectionInstruction, parseSetAndVerifySizedCollectionItemInstruction, parseSetCollectionSizeInstruction, parseSetTokenStandardInstruction, parseSignMetadataInstruction, parseThawDelegatedAccountInstruction, parseTransferInstruction, parseTransferOutOfEscrowInstruction, parseUnlockInstruction, parseUnverifyCollectionInstruction, parseUnverifyInstruction, parseUnverifySizedCollectionItemInstruction, parseUpdateInstruction, parseUpdateMetadataAccountInstruction, parseUpdateMetadataAccountV2Instruction, parseUpdatePrimarySaleHappenedViaTokenInstruction, parseUseInstruction, parseUtilizeInstruction, parseVerifyCollectionInstruction, parseVerifyInstruction, parseVerifySizedCollectionItemInstruction, payloadType, printArgs, printSupply, programmableConfig, ruleSetToggle, transferArgs, unlockArgs, updateArgs, useArgs, usesToggle };
//# sourceMappingURL=index.mjs.map
//# sourceMappingURL=index.mjs.map